unit     dos2io;
{ Changes:                                                                  }
{ 25/12/96  DosSeek updated to handle files > 64k, longint for recnum & size}
{                                                                           }
{                                                                           }
{                                                                           }

interface
uses dos;

CONST
  BufSize = 255;
  dBufSize = 511;




  {WARNING....where is some buggy code here......LB
  when referring to dbufsize ,I suggest you replace all occurances
  of dbufsize/bufsize with the sizeof function}

  {This was a real hack..of a public domain include file for turbo 3 that
   I grabbed off Compuserve.  As it works WELL I am delaying cleaning it
   up until the compiler is completed. A lot of code is not needed.
   This unit is used for file handling only. LB}


TYPE
  dos2str80 = STRING[80];
  BufType = PACKED ARRAY [1..BufSize] OF CHAR; {?0..bufsize?? LB}
  dBufType =PACKED ARRAY [0..dBufSize] OF CHAR; {yes, 0 based is correct LB}
  dos2str255 = STRING[255];

  ErrorMessage  = (
           NoError,
           BadFunction,
           FileNotFound,
           PathNotFound,
           NoHandlesLeft,
           AccessDenied,
           BadHandle,
           MCBsDestroyed,
           TooLittleMemory,
           BadMemBlockAddr,
           BadEnvironment,
           BadFormat,
           BadAccessCode,
           BadData,
           MissingMessage,
           {The PC-DOS v2.0 user's manual doesn't list a message 14.}
           InvalidDrive,
           CurrentDirErase,
           DifferentDevice,
           NoMoreFiles,
           {These are the 18 MS-DOS standard error messages.  See
           PC-DOS v2.0 user's manual at D-14.  The function
           MessageType, below, depends on your keeping them in their
           present order.  The messages below are added for
           convenience.}
           EndOfFile,
           PartialRead
          );



FUNCTION  CreateFile ( VAR FileHandle : INTEGER;
             fname : dos2str80): ErrorMessage;
FUNCTION  OpenFile ( VAR FileHandle : INTEGER;
                fname : dos2str80): ErrorMessage;
FUNCTION CloseHandle ( FileHandle : INTEGER ): ErrorMessage;

FUNCTION DosBlkWrite( FileHandle : INTEGER;
             VAR buffer : dbuftype;
             BlockNumber : INTEGER ): ErrorMessage;

FUNCTION  DosBlkRead ( FileHandle : INTEGER;
               VAR buffer : dbuftype;
               BlockNumber : INTEGER ): ErrorMessage;

PROCEDURE PrintMessage( functionresult: errormessage );

FUNCTION  BlkRead ( FileHandle : INTEGER;
                  VAR buffer  {: dbuftype};
                  blocks       : integer;
                  RelBlock     : integer;
                  var blocksread : integer ): ErrorMessage;


FUNCTION  Blkwrite ( FileHandle : INTEGER;
                  VAR buffer  {: dbuftype};
                  blocks       : integer;
                  RelBlock     : integer;
                  var blocksread : integer ): ErrorMessage;


PROCEDURE WriteStr( FileHandle : INTEGER; TheStr : dos2str255 );
PROCEDURE WriteEol( FileHandle : INTEGER );

PROCEDURE ReadStr ( FileHandle : INTEGER; VAR TheStr : dos2str255 );


FUNCTION EndReached( FileHandle : INTEGER ): BOOLEAN;




Procedure DosSeek(FileHandle:integer; RecNum : Longint; Elsize:Longint);



Procedure DosSeekEnd(FileHandle:integer; Var fileposlo,fileposHi:word);




Procedure DosReadElement(FileHandle:integer;
                         Elsize:integer;
                         VarSeg:word;VarOff:word;
                         Var BytesRead : Word);

Procedure DosWriteElement(FileHandle:integer;
                         Elsize:integer;
                         VarSeg:word;VarOff:word);

implementation


(*
                   Dos2io-1.inc


    Dedicated to the public domain.
                -- Cole Brecheen
                   17 August 1985
*)

{$V-}   {Relaxes type checking on string parameters; must
                      also be turned off in the main file.}
{ $ U-,C-,R-} {Enables keyboard buffering.}

CONST
  null = '';
    {A vestige of IBM Pascal, which does not allow '' as a
    string literal.  Helps distinguish '' from a literal
    space.}

  inp = 0;
  outp = 1;
    {The PC-DOS v2.0 manual at D-15 explains the significance of these numbers.}






Function HiWord(l:longint):integer;
Inline( $58/             { pop ax     ;word(l)}
        $58              { pop ax     ;word(l+2)}

      );


Function LoWord(l:longint):integer;
Inline( $58/             { pop ax     ;word(l)}
        $5b              { pop bx     ;word(l+2)}

      );



(*
Function IncPtrMac (aPtr: Pointer; anOffset: Word): Pointer;
Inline(
  $5B/                   {  Pop Bx    ; anOffset}
  $58/                   {  Pop Ax    ; Word(aPtr)}
  $5A/                   {  Pop Dx    ; Word(aPtr+2)}
  $01/$D8/               {  Add Ax,Bx}
  $73/$04/               {  Jnc @@1}
  $03/$16/>SelectorInc); {  Add Dx,[>SelectorInc]}
                         {@@1:}
*)

(*
SelectorInc (variable)     (System unit)

Selector increment value.

Target

Protected; Real; Windows

Declaration

var SelectorInc: Word;



Remarks

SelectorInc contains the value that must be added to or
subtracted from the selector part of a pointer to
increment or decrement the pointer by 64K bytes. In real
mode, SelectorInc always contains $1000, but in
protected mode the actual value can vary.

*)





TYPE


(*
  DataRegister =
    RECORD
      CASE BOOLEAN OF
        TRUE  : ( l : BYTE ; h : BYTE );
        FALSE : ( x : INTEGER );
      END;

  regpack =
    RECORD
      a, b, c, d: DataRegister;
      bp, si, di, ds, es, flags: INTEGER;
    END;
    {This is the record type used with the msdos procedure.}
*)

  RegPack = registers;

  dos2charset = set of CHAR;
  dos2numset = set of 0..255;

VAR
  choice :  CHAR;
  TypeAheadLegal : BOOLEAN;


FUNCTION MessageType( FunctionResult: byte ): ErrorMessage;
VAR
  converter : RECORD CASE BOOLEAN of
        true : ( num : byte );
        false : ( msg : ErrorMessage );
          END;
BEGIN {MessageType}
  converter.num := FunctionResult;
  MessageType := converter.msg;
    {The case variant allows coverter to be referred to both
    as a byte and as an ErrorMessage.}
END; {MessageType}


(*
PROCEDURE WriteStr( FileHandle : INTEGER;
            TheStr : dos2str255 ); forward;

*)
(*
PROCEDURE WriteEol( FileHandle : INTEGER ); forward;
*)


PROCEDURE abort( message : dos2str80 );
BEGIN {abort}
  WriteEol( outp );
  WriteStr( outp, message );
  WriteEol( outp );
  WriteStr( outp, 'Press <return>..program will abort.' );
  readln;
    {Can't use GetKey here because GetKey may abort for lack
    of initialization.  A GetKey inside GetKey would cause
    endless loop.}
  halt;
END;  {abort}



PROCEDURE PrintMessage( functionresult: errormessage );
BEGIN {PrintMessage}
  CASE functionresult OF
    NoError         : BEGIN END;
    BadFunction     : abort( 'Invalid function number.' );
    FileNotFound    : abort( 'File not found.' );
    PathNotFound    : abort( 'Path not found.' );
    NoHandlesLeft   : abort( 'No handles left.' );
    AccessDenied    : abort( 'Access denied.' );
    BadHandle       : abort( 'Invalid handle.' );
    MCBsDestroyed   : abort( 'Memory control blocks destroyed.' );
    TooLittleMemory : abort( 'Insufficient memory.' );
    BadMemBlockAddr : abort( 'Invalid memory block address.' );
    BadEnvironment  : abort( 'Invalid environment.' );
    BadFormat       : abort( 'Invalid format.' );
    BadAccessCode   : abort( 'Invalid access code.' );
    BadData         : abort( 'Invalid data.' );
    MissingMessage  : abort( 'Missing message 14.' );
    InvalidDrive    : abort( 'Invalid drive was specified.' );
    CurrentDirErase : abort('Can''t remove current directory.');
    DifferentDevice : abort( 'Different device.' );
    NoMoreFiles     : abort( 'No more files.' );

    PartialRead     : write( 'Partial read.' );
    EndOfFile       : write( 'End of file.' );
    {We don't have an else because, if the runtime system
    decides that some different value is possible, we want to
    know.}
  END; {case}
END; {PrintMessage}


FUNCTION FlaggedError( TheFlags : INTEGER ): BOOLEAN;
    {Detects the PC/MS-DOS error signal in the carry flag.}
BEGIN
  FlaggedError := odd( abs( TheFlags ) );
END; {FlaggedError}



PROCEDURE AddStr( VAR first : dos2str255; second : dos2str255 );
    {Concatenates the second string onto the end of the
    first.  Requires less typing and executes more
    efficiently than doing the same thing with Turbo's concat
    function.}
BEGIN
  first[0] := succ( first[0] );
  insert( second, first, length(first) );
  first[0] := pred( first[0] );
END; {AddStr}



PROCEDURE MakeAsciiZ( VAR TheStr : dos2str255 );
{Convert a VAR pascal string to a 'C' type string with #0 at end LB}
VAR
  lngth,
  index : INTEGER;
BEGIN
  lngth := length(thestr);    {FIX LB 14/4/91}
  IF lngth > 0 THEN 
    FOR index := 0 TO (lngth - 1) DO
      BEGIN
        TheStr[ index ] := TheStr[ index + 1 ];
      END;
  TheStr[lngth] := #0;
END; {MakeAsciiZ}



PROCEDURE WriteStr{ FileHandle : INTEGER; TheStr : dos2str255 };
VAR
  rgstr : Registers;
BEGIN {WriteStr}
  IF FileHandle = inp
    THEN abort( 'Cannot write to standard input.' );
  with rgstr DO BEGIN
    Bx := FileHandle;
    Cx := length( TheStr );
    MakeAsciiZ( TheStr );
    ds := seg( TheStr );
    Dx := ofs( TheStr );
    ah := $40;  {Write to a file or device command}
    msdos( rgstr );
    IF FlaggedError( flags )
      THEN PrintMessage( MessageType( ax ) );
    IF ax < Cx  {if fewer than Cx bytes were actually written}
      THEN abort( 'No room to write.' );
  END; {with rgstr}
END;  {WriteStr}



FUNCTION IntStr( TheNumber : INTEGER;
         StrLngth: INTEGER ): dos2str80;
VAR
  BufStr : dos2str80;
BEGIN {IntStr}
  str( TheNumber:StrLngth, BufStr );
    {See the Turbo Pascal manual at p. 108 for an
    explanation of how StrLngth functions in this statement.}
  IntStr := BufStr;
END; {IntStr}


FUNCTION RealStr( TheNumber : REAL;
          StrLngth,
          DigitsAfterDecimal : INTEGER ): dos2str80;
VAR
  BufStr : dos2str80;
BEGIN {RealStr}
  str( TheNumber:StrLngth:DigitsAfterDecimal, BufStr );
  RealStr := BufStr;
END; {RealStr}   


PROCEDURE WriteEol{ FileHandle : INTEGER };
BEGIN {WriteEol}
  WriteStr( FileHandle, concat( #13, #10 ) );
END;  {WriteEol} 



TYPE
  BufferPtr = ^FileBuff;
    {This is the record type that ReadStr uses to perform
    dynamic file buffering.}

  FileBuff = RECORD
           buf : buftype;
    {There's a mysterious problem lurking here somewhere that
    takes an eggbeater to the heap if buf is made the last
    item in this record.  It doesn't seem to show up if buf
    is the first item.}

           prev,
           next : BufferPtr;
           ndx,
           handle, size : INTEGER;
           eof : BOOLEAN;
         END;
VAR
  BufLstBase : BufferPtr;
  Dos2ioInitKey : REAL;


PROCEDURE InitDos2io;
BEGIN
  TypeAheadLegal := true;
  BufLstBase := nil;
  Dos2ioInitKey := 5721.0;
END; {InitDos2io}

PROCEDURE CheckInitialization;
BEGIN
  IF Dos2ioInitKey <> 5721.0 THEN
    abort( 'Please initialize with InitDos2io.' );
END; {CheckInitialization}


PROCEDURE ReadStr( FileHandle : INTEGER; VAR TheStr : dos2str255 );
LABEL EndProcedure;
VAR
  BufPtr : BufferPtr;
  Strlong: dos2str255;

  PROCEDURE load( VAR BufPtr : BufferPtr );
  VAR
    rgstr : Registers;
    eofpos : INTEGER;
  BEGIN
    with rgstr DO BEGIN
      Bx := FileHandle;
      Cx := BufSize;
    {CX gets the number of bytes to be transferred.}
      ds := seg( BufPtr^.buf );
      Dx := ofs( BufPtr^.buf );
      ah := $3F;
    {Read from a file or device commanD}
      msdos( rgstr );
      IF FlaggedError( flags )
    THEN BEGIN writeln('readstr error');  {diag}
      PrintMessage( MessageType( ax ) );
      END;
      BufPtr^.size := ax;
    {AX contains the number of bytes actually transferred.
    If the value is zero, the program has tried to read from
    the end of file. }
      IF FileHandle <> 0 THEN BufPtr^.ndx := BufPtr^.ndx - BufSize
        ELSE BufPtr^.ndx := 1;
      eofpos := pos(#26,BufPtr^.buf);
      IF eofpos <> 0 THEN  BEGIN
        BufPtr^.buf[eofpos] := #13;
        BufPtr^.size := eofpos - 1;
      END;
      IF BufPtr^.size = BufSize THEN BufPtr^.size := BufSize + 3;
      BufPtr^.eof := BufPtr^.size = 0;
    END; {with rgstr}
  END; {load}

  PROCEDURE MakeBuffFor( FileHandle : INTEGER );
  LABEL
    EndProcedure;
  VAR
    OldPtr, TmpPtr : BufferPtr;
  BEGIN
    IF BufLstBase = nil THEN
      BEGIN
    {If there are no file buffers in the BufLst at all (i.e,
    if BufLstBase is nil), the next few lines will create the
    first buffer and put its address in BufLstBase.}
    new( TmpPtr );
    BufLstBase := TmpPtr;
    TmpPtr^.ndx := BufSize + 1;
    TmpPtr^.next := nil;
    TmpPtr^.prev := nil;
    TmpPtr^.handle := FileHandle;
    GOTO EndProcedure;
      END;

    TmpPtr := BufLstBase;

    WHILE (TmpPtr^.handle <> FileHandle)
      and
      (TmpPtr^.next <> nil)
      DO TmpPtr := TmpPtr^.next;
    {This checks to see whether a buffer for this file is
    already in the BufLst.  If not, the if-then construct
    immediately below will create one and add it to the
    BufLst.}

    IF TmpPtr^.handle <> FileHandle THEN
      BEGIN
    OldPtr := TmpPtr;
    new( TmpPtr );
    OldPtr^.next := TmpPtr;
    TmpPtr^.prev := OldPtr;
    TmpPtr^.ndx := BufSize + 1;
    TmpPtr^.next := nil;
    TmpPtr^.handle := FileHandle;
      END;

    EndProcedure:
    BufPtr := TmpPtr;
  END;  {MakeBuffFor}

  PROCEDURE MoveLine( VAR BufPtr : BufferPtr;
              VAR TheLine : dos2str255 );
    {Takes one line from the buffer and puts it in TheLine.}
  VAR  endstr: INTEGER;
  LABEL EndProcedure;
  BEGIN
    TheLine := copy(BufPtr^.buf,BufPtr^.ndx,BufSize - BufPtr^.ndx + 1);
    endstr :=pos(#13,TheLine);
    IF endstr = 0 THEN BEGIN   {no CR in rest of current buffer}
      IF BufPtr^.size > BufSize THEN BEGIN  {eof not in current buffer}
        BufPtr^.ndx := BufSize + 1;
        load( BufPtr );
        endstr := pos(#13, BufPtr^.buf);
        IF endstr = 0 THEN     {no CR in new buufer either}
          IF BufPtr^.size < BufSize THEN BEGIN  {if eof in this buffer}
            endstr := BufPtr^.size + 1;
            BufPtr^.eof := TRUE;
          END  {IF BufPtr^.size < BufSize}
          ELSE  abort('line too long:' + copy(TheLine,1,60) + '...');
        TheLine := TheLine + copy(BufPtr^.buf,1,endstr -1);
        BufPtr^.ndx := endstr + 2; {jumps over following LF}
      END
      ELSE BEGIN  {eof is in current buffer}
        TheLine[0] := Chr(BufPtr^.size);
        BufPtr^.eof := TRUE;
      END;
    END   {IF endstr = 0 }
    ELSE BEGIN    {CR is in current buffer}
      TheLine[0] := Chr(endstr - 1);
      BufPtr^.ndx := BufPtr^.ndx + endstr + 1; {+1 jumps over following LF}
    END;
    EndProcedure:
    END; {MoveLine}

BEGIN {ReadStr}
  CheckInitialization;
  IF FileHandle = outp
    THEN abort( 'Cannot read from standard output.' );
  TheStr := null;
  MakeBuffFor( FileHandle );
  IF (BufPtr^.ndx > BufSize) OR (FileHandle = 0) THEN load( BufPtr ); 
  MoveLine( BufPtr, Strlong );
  IF (BufPtr^.ndx > BufPtr^.size) AND (FileHandle <> 0) THEN BufPtr^.eof := TRUE
  ELSE IF (BufPtr^.ndx > BufSize) AND (FileHandle <> 0) THEN load( BufPtr ); 
  TheStr := Strlong;
END;  {ReadStr}




FUNCTION EndReached( FileHandle : INTEGER ): BOOLEAN;
LABEL ErrorLabel;
VAR
  TmpPtr : BufferPtr;
BEGIN
  CheckInitialization;
  TmpPtr := BufLstBase;
  IF TmpPtr = nil
    THEN GOTO ErrorLabel;
  WHILE (TmpPtr^.handle <> FileHandle)
    and
    (TmpPtr^.next <> nil)
    DO TmpPtr := TmpPtr^.next;
  IF TmpPtr^.handle <> FileHandle
    THEN
ErrorLabel:
      abort('ReadStr(handle) must precede EndReached(handle).');
  EndReached := TmpPtr^.eof;
END; {EndReached}



PROCEDURE GetKey( VAR ch:CHAR; ReturnOnMatch: dos2charset );
VAR
  rgstr : Registers;
BEGIN {GetKey}
  CheckInitialization;
  IF TypeAheadLegal
    {Works only if U- and C- compiler directives are set in
    all files.}
    THEN rgstr.AH := 8
    {Console input without echo.}
    ELSE rgstr.AH := $C;
    {Clear standard input buffer and invoke the input
    function stored in AL.      See D-20 of PC-DOS 2.0 manual.}
  REPEAT
    rgstr.AL := 8;
    msdos( rgstr );
    ch := CHR(rgstr.AL);
  UNTIL ch IN ReturnOnMatch;
END; {GetKey}



PROCEDURE GetExtendedKey( VAR ch    : CHAR;
                  legalchars : dos2charset;
                  legalxkeys : dos2numset;
                  VAR xkeygotten : BOOLEAN );
VAR
  byte1,
  byte2 : BYTE;
  rgstr : Registers;

BEGIN {GetExtendedKey}
  CheckInitialization;
  IF TypeAheadLegal
    {Works only if U- and C- compiler directives are set in
    all files.}
    THEN rgstr.AH := 8
    ELSE rgstr.AH := $C;

  REPEAT
    rgstr.AL := 8;
    MsDos( rgstr );
    byte1 := rgstr.AL;
    IF CHR(byte1) = CHR(0)
      THEN
    BEGIN
      rgstr.AH := 8;
      MsDos( rgstr );
      byte2 := rgstr.AL;
    END;
  UNTIL ( CHR(byte1) IN legalchars)
    OR
    ( (byte1 = 0) AND (ORD(byte2) IN legalxkeys)); 
  IF CHR(byte1) = CHR(0)
    THEN
      BEGIN
        ch := CHR(byte2);
        xkeygotten := TRUE;
      END
    ELSE
      BEGIN
        ch := CHR(byte1);
        xkeygotten := FALSE;
      END;
END; {GetExtendedKey}





(*
                          Dos2io-2.inc



    Dedicated to the public domain.

        -- Cole Brecheen
           17 August 1985
*)

{ $V-,U-,C-,R-}
CONST
  SegSize = 6.5536E+4;

TYPE
  BitRange = 0..15;
  BitSet = SET OF BitRange;


PROCEDURE IntegerToBitSet( TheInteger : INTEGER;
                   VAR TheSet : BitSet );
VAR
  tmp: RECORD
     CASE BOOLEAN of
       true: ( IntForm : INTEGER );
       false:( SetForm : BitSet );
       END;
BEGIN {IntegerToBitSet}
  tmp.IntForm := TheInteger;
  TheSet := tmp.SetForm;
END;  {IntegerToBitSet}


PROCEDURE BitSetToInteger( TheSet : BitSet;
                   VAR TheInteger : {INTEGER} word );
VAR
  tmp: RECORD
     CASE BOOLEAN of
       true: ( IntForm : INTEGER );
       false:( SetForm : BitSet );
       END;
BEGIN {BitSetToInteger}
  tmp.SetForm := TheSet;
  TheInteger := tmp.IntForm;
END;  {BitSetToInteger}



FUNCTION WordToReal( TheWord : INTEGER ): REAL;
var
  storage: real;
BEGIN  {WordToReal}
  IF (TheWord > maxint) OR (TheWord < 0) THEN
    BEGIN
      storage := ord(TheWord);
      WordToReal := storage + maxint + maxint + 2;
    END
  ELSE WordToReal := ORD( TheWord );
END;  {WordToReal}


FUNCTION RealToWord( TheReal : REAL ): INTEGER;
BEGIN  {RealToWord}
  IF (TheReal < 0) or (TheReal >= segsize)
    THEN abort('Real out of word range:  '+RealStr(TheReal,0,0));
  if TheReal >= (segsize - 1) then
    RealToWord := -1
  else
    IF TheReal > maxint THEN
      RealToWord := maxint + round(TheReal - maxint)
    ELSE RealToWord := round(TheReal);
END;  {RealToWord}




PROCEDURE RealToSegmented( TheReal: REAL;
                   VAR TheSeg, TheOfs: {INTEGER} word );
BEGIN {RealToSegmented}
  IF TheReal > SegSize THEN
    TheSeg := trunc(TheReal / SegSize)
  ELSE
    TheSeg := 0;
  TheOfs := RealToWord( TheReal - (TheSeg * SegSize) );
END; {RealToSegmented}


FUNCTION SegmentedToReal( TheSeg, TheOfs: INTEGER ): REAL;
VAR
  tmp: REAL;
BEGIN {SegmentedToReal}
  tmp := WordToReal( TheSeg ) * SegSize;
  SegmentedToReal := WordToReal( TheOfs ) + tmp;
END; {SegmentedToReal}




PROCEDURE lowerch( VAR TheCh : CHAR );
    {Converts TheCh to lower case.}
BEGIN
  IF TheCh in ['A'..'Z']
    THEN TheCh := chr( ord(TheCh) + 32 );
END; {lowerch}


(*
Procedure DosSeek(FileHandle:integer; RecNum : Integer; Elsize:integer);
VAR
  rgstr : RegPack;
begin
  WITH rgstr DO
    Begin
    ah := $42;  {LSEEK}
    al := 0;
    {moves pointer to offset bytes from beginnning of file}
    bx := FileHandle;
    cx := 0;
    dx := Recnum * Elsize{ *2};
    msdos( rgstr );
    IF FlaggedError( flags ) THEN
      begin {writeln('DosBlkRead error');  } {diag}
      PrintMessage( MessageType( ax ) );
      end;
    end;
end;
*)
Procedure DosSeek(FileHandle:integer; RecNum : Longint; Elsize:Longint);
type trixrec = record case boolean of
               false: (lo,hi:word);
               true : (l:longint);
               end;
VAR
  rgstr : Registers;
  m:trixrec;
begin
  WITH rgstr DO
    Begin
    ah := $42;  {LSEEK}
    al := 0; {0=offset from start, 1=from current pos, 2=from end}
    {moves pointer to offset bytes from beginnning of file}
    bx := FileHandle;
    m.l  := RecNum * Elsize{ *2};
    cx := m.hi;
    dx := m.lo;
    msdos( rgstr );
    IF FlaggedError( flags ) THEN
      begin {writeln('DosBlkRead error');  } {diag}
      PrintMessage( MessageType( ax ) );
      end;
    end;
end;


Procedure DosSeekEnd(FileHandle:integer; Var fileposlo,fileposHi:word);
{seek eof and return file pointer}
VAR
  rgstr : RegPack;
begin
  WITH rgstr DO
    Begin
    ah := $42;  {LSEEK}
    al := 02;   {offset from end of file}
    {moves pointer to offset bytes from end of file}
    bx := FileHandle;
    cx := 0;
    dx := 0;
    msdos( rgstr );
    fileposlo:=AX;
    fileposHi:=DX;
    IF FlaggedError( flags ) THEN
      begin {writeln('DosBlkRead error');  } {diag}
      PrintMessage( MessageType( ax ) );
      end;
    end;
end;


Procedure DosReadElement(FileHandle:integer; Elsize:integer; VarSeg,VarOff:word;
                         var bytesread:word);
VAR
  rgstr : RegPack;
begin
  WITH rgstr DO
    Begin
    ah := $3f;  {READ}
    al := 0;
    bx := FileHandle;
    cx := Elsize{*2};
    ds := VarSeg;
    Dx := VarOff;
    msdos( rgstr );
    BytesRead:=AX;
    IF FlaggedError( flags ) THEN
      begin {writeln('DosReadElement error');  } {diag}
      PrintMessage( MessageType( ax ) );
      end;
    (*
    writeln('filehandle=',bx,' bytes read=',AX,' elementsize=',cx,' at ',ds,' ',dx);
    *)
    end;
end;



Procedure DosWriteElement(FileHandle:integer; Elsize:integer; VarSeg,VarOff:word);
VAR
  rgstr : RegPack;
begin
  WITH rgstr DO
    Begin
    ah := $40;  {WRITE}
    al := 0;
    bx := FileHandle;
    cx := Elsize{*2};   {# bytes to write}
    ds := VarSeg;
    Dx := VarOff;
    msdos( rgstr );
    IF FlaggedError( flags ) THEN
      begin {writeln('DosWriteElement error');  } {diag}
      PrintMessage( MessageType( ax ) );
      end;
    end;
end;







FUNCTION  DosBlkRead ( FileHandle : INTEGER;
               VAR buffer : dbuftype;
               BlockNumber : INTEGER ): ErrorMessage;
VAR
  rgstr : RegPack;
  BlksInSeg : integer;
BEGIN {DosBlkRead}
  DosBlkRead := NoError;
  BlksInSeg := trunc( SegSize / dBufSize );  {ie 65536 div dbufsize LB}
  WITH rgstr DO BEGIN
    ah := $42;  {command to move file read/write pointer}
    al := 0;
    {moves pointer to offset bytes from beginnning of file}
    bx := FileHandle;
    cx := BlockNumber DIV BlksInSeg;
    dx := (BlockNumber - (cx * BlksInSeg)) * dBufSize;
    msdos( rgstr );
    IF FlaggedError( flags )
      THEN BEGIN {writeln('DosBlkRead error');  } {diag}
          PrintMessage( MessageType( ax ) );
          END;

    bx := FileHandle;
    cx := dBufSize;
    ah := $3F;  {Read from a file or device.}
    dx := ofs( buffer );
    ds := seg( buffer );
    msdos( rgstr );
    IF FlaggedError( flags )
      THEN DosBlkRead := MessageType( ax )
      ELSE
    BEGIN
      IF ax < cx THEN
        IF ax = 0 THEN
          DosBlkRead := EndOfFile
        ELSE
          DosBlkRead := PartialRead
      ELSE DosBlkRead := NoError;
    END
  END; {WITH rgstr}
END;  {DosBlkRead}



FUNCTION  BlkRead ( FileHandle : INTEGER;
                  VAR buffer  {: dbuftype};
                  blocks       : integer;
                  RelBlock     : integer;
                  var blocksread : integer ): ErrorMessage;
{LB 13/4/91}
VAR
  rgstr : RegPack;
  BlksInSeg : integer;
begin
  BlkRead := NoError;
  BlksInSeg := trunc( SegSize / sizeof(dbuftype){dBufSize} );  {ie 65536 div dbufsize LB}
  WITH rgstr DO
    begin   {if relative block then do a seek}
    If RelBlock <> -1 then
      Begin
      ah := $42;  {command to move file read/write pointer}
      al := 0;
      {moves pointer to offset bytes from beginnning of file}
      bx := FileHandle;
      cx := RelBlock DIV BlksInSeg;
      dx := (RelBlock-(cx*BlksInSeg)) * sizeof(dBuftype) {dBufSize}; {fix LB}
      msdos( rgstr );
      IF FlaggedError( flags ) THEN
        begin {writeln('DosBlkRead error');  } {diag}
        PrintMessage( MessageType( ax ) );
        end;
      end; {if RelBlock <> -1}
    bx := FileHandle;
    cx := blocks * sizeof(dbuftype){dBufSize};
    ah := $3F;  {Read from a file or device.}
    al := 0; {LB}
    dx := ofs( buffer );
    ds := seg( buffer );
    msdos( rgstr );
    blocksread := ax div sizeof(dbuftype){dbufsize};
    IF FlaggedError( flags ) then
      BlkRead := MessageType( ax )
    else
      begin
      if ax < cx then
        if ax = 0 then
          BlkRead := EndOfFile
        else
          BlkRead := PartialRead
      else BlkRead := NoError;
    end
    end; {WITH rgstr}
end;





FUNCTION  Blkwrite ( FileHandle : INTEGER;
                  VAR buffer  {: dbuftype};
                  blocks       : integer;
                  RelBlock     : integer;
                  var blocksread : integer ): ErrorMessage;
{LB 13/4/91}
VAR
  rgstr : RegPack;
  BlksInSeg : integer;
begin
  Blkwrite := NoError;
  BlksInSeg := trunc( SegSize / sizeof(dbuftype){dBufSize} );  {ie 65536 div dbufsize LB}
  WITH rgstr DO
    begin   {if relative block then do a seek}
    If RelBlock <> -1 then
      Begin
      ah := $42;  {command to move file read/write pointer}
      al := 0;
      {moves pointer to offset bytes from beginnning of file}
      bx := FileHandle;
      cx := RelBlock DIV BlksInSeg;
      dx := (RelBlock-(cx*BlksInSeg)) * sizeof(dBuftype) {dBufSize}; {fix LB}
      msdos( rgstr );
      IF FlaggedError( flags ) THEN
        begin {writeln('DosBlkRead error');  } {diag}
        PrintMessage( MessageType( ax ) );
        end;
      end; {if RelBlock <> -1}
    bx := FileHandle;
    cx := blocks * sizeof(dbuftype){dBufSize};
    ah := $40;  {write to a file or device.}
    al := 0; {LB}
    dx := ofs( buffer );
    ds := seg( buffer );
    msdos( rgstr );
    blocksread := ax div sizeof(dbuftype){dbufsize};



    IF ax < cx  {if fewer than c.x bytes were actually written}
      THEN abort( 'No room to write.' );
    IF FlaggedError( flags )
      THEN BlkWrite := MessageType( ax );




    end; {WITH rgstr}
end;

FUNCTION DosBlkWrite( FileHandle : INTEGER;
             VAR buffer : dbuftype;
             BlockNumber : INTEGER ): ErrorMessage;
VAR
  rgstr : RegPack;
  BlksInSeg : integer;
BEGIN {DosBlkWrite}
  DosBlkWrite := NoError;
  BlksInSeg := trunc( SegSize / dBufSize );
  WITH rgstr DO BEGIN
    ah := $42;  {command to move file read/write pointer}
    al := 0;
    {moves pointer to offset bytes from beginnning of file}
    bx := FileHandle;
    cx := BlockNumber DIV BlksInSeg;
    dx := (BlockNumber - (cx * BlksInSeg))* dBufSize;
    msdos( rgstr );
    IF FlaggedError( flags )
      THEN PrintMessage( MessageType( ax ) );

    bx := FileHandle;
    cx := dBufSize;
    ah := $40; {Write to a file or device.}
    dx := ofs( buffer );
    ds := seg( buffer );
    msdos( rgstr );
  END; {WITH rgstr}
END; {DosBlkWrite}


(*

PROCEDURE GetProgramParameter( VAR ParamStr : dos2str80 );
VAR
  TmpStr : string[80] absolute cseg:$0080;
BEGIN {GetProgramParameter}
  IF length( TmpStr ) > 1 THEN
    ParamStr := copy( TmpStr, 2, length(TmpStr) - 1 )
    {We start at 2 and copy length - 1 because the first
    character in the parameter will always be a space.}
  ELSE
    ParamStr := null;
END;  {GetProgramParameter}

*)



FUNCTION CloseHandle ( FileHandle : INTEGER ): ErrorMessage;
LABEL EndProcedure;
VAR
  TmpPtr : BufferPtr;
  rgstr : RegPack;
BEGIN {CloseHandle}
  CloseHandle := NoError;
  WITH rgstr DO BEGIN
    ah := $3E;  {close a FileHandle}
    bx := FileHandle;
    msdos( rgstr );
    IF FlaggedError( flags )
      THEN CloseHandle := MessageType( ax );
  END; {WITH rgstr}

  CheckInitialization;
    {From here down we are releasing any memory that ReadStr
    may have allocated to FileHandle for buffering purposes.}

  IF BufLstBase = nil
    THEN GOTO EndProcedure;
  TmpPtr := BufLstBase;
  IF (TmpPtr^.next = NIL) AND (TmpPtr^.handle = FileHandle) THEN 
    BufLstBase := NIL                         {added 6/6/85}
  ELSE  WHILE (TmpPtr^.next <> nil)
    and
    (TmpPtr^.handle <> FileHandle) DO TmpPtr := TmpPtr^.next;
  IF TmpPtr^.handle = FileHandle
    THEN
      BEGIN
    IF TmpPtr^.prev <> NIL THEN TmpPtr^.prev^.next := TmpPtr^.next;
    IF TmpPtr^.next <> NIL THEN TmpPtr^.next^.prev := TmpPtr^.prev;
    dispose( TmpPtr );
      END;
  EndProcedure:
END;  {CloseHandle}



FUNCTION FileLength( FileHandle : INTEGER ): REAL;
    {Returns the number of bytes in the file identified by
    FileHandle.}
VAR
  rgstr : RegPack;
  tmp : REAL;
  OldSeg, OldOfs : INTEGER;
BEGIN {FileLength}
  WITH rgstr DO BEGIN
    al := 1;  {move pointer to current location plus offset}
    ah := $42;
    bx := FileHandle;
    cx := 0;  {most significant part of the offset}
    dx := 0;  {least significant part of the offset}
    msdos( rgstr );
    IF FlaggedError( flags )
      THEN BEGIN { writeln('filelength error'); } {diag}
        PrintMessage( MessageType( ax ) );
      END;
    OldSeg := dx;
    OldOfs := ax;
    {We save these values so we can restore the pointer to
    its original location.}

    al := 2;  {move pointer to end of file plus offset}
    ah := $42;
    bx := FileHandle;
    cx := 0;  {most significant part of the offset}
    dx := 0;  {least significant part of the offset}
    msdos( rgstr );
    IF FlaggedError( flags )
      THEN BEGIN { writeln('filelength error'); } {diag}
        PrintMessage( MessageType( ax ) );
      END;
    FileLength := SegmentedToReal( dx, ax );

    al := 0;
    {move pointer to offset bytes from beginning of file}
    ah := $42;
    bx := FileHandle;
    cx := OldSeg;  {most significant part of the offset}
    dx := OldOfs;  {least significant part of the offset}
    msdos( rgstr );
      {Restores pointer to its original location.}
    IF FlaggedError( flags )
      THEN BEGIN { writeln('filelength error'); } {diag}
        PrintMessage( MessageType( ax ) );
      END;
  END; {WITH rgstr}
END; {FileLength}



FUNCTION  OpenFile ( VAR FileHandle : INTEGER;
                fname : dos2str80): ErrorMessage;
VAR
  rgstr : RegPack;
BEGIN  {OpenFile}
  FileHandle := 0;
  OpenFile := NoError;
  MakeAsciiZ( fname );
  WITH rgstr DO BEGIN
    ah := $3D;   {open a file}
    AL := 2;     {for reading and writing.  This is the filemode in TP dos}
    bx := 0;
    cx := 0;
    dx := ofs( fname );
    ds := seg( fname );
    msdos( rgstr );
    IF FlaggedError( flags )
      THEN OpenFile := MessageType( ax )
      ELSE FileHandle := ax;
  END; {WITH rgstr}
END;  {OpenFile}



FUNCTION  CreateFile ( VAR FileHandle : INTEGER;
             fname : dos2str80): ErrorMessage;
VAR
  rgstr : RegPack;
BEGIN  {CreateFile}
  FileHandle := 0;
  CreateFile := NoError;
  MakeAsciiZ( fname );

  WITH rgstr DO BEGIN
    ah := $3C;   {create a file}
    AL := 0;
    bx := 0;
    cx := 0;  {attribute of the file; 0 makes it normal}
    dx := ofs( fname );
    ds := seg( fname );
    msdos( rgstr );
    IF FlaggedError( flags )
      THEN CreateFile := MessageType( ax )
      ELSE FileHandle := ax;
  END; {WITH rgstr}
END;  {CreateFile}



FUNCTION EndFile( FileHandle : INTEGER ): BOOLEAN;
VAR
  rgstr : RegPack;
  OldSeg, OldOfs : INTEGER;
BEGIN {EndFile}
  WITH rgstr DO BEGIN
    al := 1;  {move pointer to current location plus offset}
    ah := $42;
    bx := FileHandle;
    cx := 0;  {most significant part of the offset}
    dx := 0;  {least significant part of the offset}
    msdos( rgstr );
    OldSeg := dx;
    OldOfs := ax;

    al := 2;  {move pointer to end of file plus offset}
    ah := $42;
    bx := FileHandle;
    cx := 0;  {most significant part of the offset}
    dx := 0;  {least significant part of the offset}
    msdos( rgstr );
    EndFile := (dx <= OldSeg) and (ax <= OldOfs);

    al := 0;
    {move pointer to offset bytes from beginning of file}
    ah := $42;
    bx := FileHandle;
    cx := OldSeg;  {most significant part of the offset}
    dx := OldOfs;  {least significant part of the offset}
    msdos( rgstr );
      {Restores pointer to its original location.}
  END; {WITH rgstr}
END; {EndFile}  



FUNCTION RenameFile( OldFileName,
             NewFileName :  Dos2str80 ): ErrorMessage;
VAR
  rgstr : RegPack;
BEGIN {RenameFile}
  RenameFile := NoError;
  IF pos( ':', NewFileName ) = 2
    THEN delete( NewFileName, 1, 2 );
  IF pos( ':', OldFileName ) = 2
    THEN insert( copy(OldFileName, 1, 2), NewFileName, 1 );
  MakeAsciiZ( OldFileName );
  MakeAsciiZ( NewFileName );
  WITH rgstr DO BEGIN
    ds := seg( OldFileName );
    dx := ofs( OldFileName );
    es := seg( NewFileName );
    di := ofs( NewFileName );
    ah := $56; {Rename a file.}
    msdos( rgstr );
    IF FlaggedError( flags )
      THEN RenameFile := MessageType( ax );
  END; {WITH rgstr}
END; {RenameFile}



FUNCTION DeleteFile( FileName : Dos2str80 ): ErrorMessage;
VAR
  rgstr : RegPack;
BEGIN {DeleteFile}
  DeleteFile := NoError;
  MakeAsciiZ( FileName );
  WITH rgstr DO BEGIN
    ds := seg( FileName );
    dx := ofs( FileName );
    ah := $41; {Delete a file from a specified directory.}
    msdos( rgstr );
    IF FlaggedError( flags )
      THEN DeleteFile := MessageType ( ax );
  END; {WITH rgstr}
END; {DeleteFile}


TYPE
  FileMode = (NormalFile, ReadOnlyFile, HiddenFile, SystemFile);
  ModeSet = set of FileMode;

FUNCTION SetFileMode( FileName: dos2str80;
              TheSet: ModeSet ): ErrorMessage;
VAR
  TmpMode : FileMode;
  rgstr : RegPack;
  TmpSet : BitSet;
BEGIN {SetFileMode}
  SetFileMode := NoError;
  MakeAsciiZ( FileName );
  WITH rgstr DO BEGIN
    ah := $43; {Change file mode command (CHMOD).}
    al := 1;
    {Indicates that we want to change the mode rather than
    find out what it presently is.}
    ds := seg( FileName );
    dx := ofs( FileName );

    TmpSet := [];
    TmpMode := NormalFile;
    WHILE TheSet <> [] DO BEGIN
      IF TmpMode in TheSet THEN
    CASE TmpMode of
      NormalFile:
        BEGIN
          TmpSet := [];
          TheSet := [];
        END;
      ReadOnlyFile: TmpSet := TmpSet + [0];
      HiddenFile: TmpSet := TmpSet + [1];
      SystemFile: TmpSet := TmpSet + [2];
    END; {case}
      IF TheSet <> [] THEN
    TheSet := TheSet - [TmpMode];
      TmpMode := succ( TmpMode );
    END; {while}

    BitSetToInteger( TmpSet, cx );
    msdos( rgstr );
    IF FlaggedError( flags ) THEN
      SetFileMode := MessageType( ax );
  END; {WITH rgstr}
END; {SetFileMode}    


FUNCTION GetFileMode( FileName: dos2str80;
              VAR TheSet: ModeSet ): ErrorMessage;
VAR
  rgstr : RegPack;
  TmpSet : BitSet;
BEGIN {GetFileMode}
  MakeAsciiZ( FileName );
  GetFileMode := NoError;
  TheSet := [];
  WITH rgstr DO BEGIN
    ah := $43; {Change file mode command (CHMOD).}
    al := 0; {Indicates that we want the file's present mode.}
    ds := seg( FileName );
    dx := ofs( FileName );
    msdos( rgstr );
    IF FlaggedError( flags ) THEN
      GetFileMode := MessageType( ax )
    ELSE
      BEGIN
    IntegerToBitSet( cx, TmpSet );
    TheSet := [NormalFile];
    IF 2 in TmpSet THEN
      TheSet := TheSet + [SystemFile];
    IF 1 in TmpSet THEN
      TheSet := TheSet + [HiddenFile];
    IF 0 in TmpSet THEN
      TheSet := TheSet + [ReadOnlyFile];
    IF TheSet <> [NormalFile] THEN
    {i.e., if something's been added}
      TheSet := TheSet - [NormalFile];
      END;
  END; {WITH rgstr}
END; {GetFileMode}



FUNCTION DefaultDrive: CHAR;
    {Returns the current default drive as a lower case
    letter.}
VAR
  rgstr : RegPack;
BEGIN  {DefaultDrive}
  rgstr.ah := $19;  {DOS "current disk" function number}
  msdos( rgstr );
  DefaultDrive := CHR( ORD(rgstr.al) + ORD( 'a' ) );
END;  {DefaultDrive}



PROCEDURE SetDefaultDrive( DriveLetter: CHAR );
VAR
  rgstr : RegPack;
BEGIN {SetDefaultDrive}
  lowerch( DriveLetter );
  IF not (DriveLetter in ['a'..'z'])
    THEN PrintMessage( InvalidDrive );
  rgstr.ah := $E;
  rgstr.dl := ord( DriveLetter ) - ord( 'a' );
  msdos( rgstr );
END; {SetDefaultDrive}



PROCEDURE GetDate( VAR month, day, year: INTEGER );
VAR
  rgstr : RegPack;
BEGIN {GetDate}
  WITH rgstr DO BEGIN
    ah := $2A;  {DOS "get date" function number}
    msdos( rgstr );
    month := dh;
    day := dl;
    year := cx;
  END; {WITH rgstr}
END;  {GetDate}



PROCEDURE SetDate( month, day, year: INTEGER );
VAR
  rgstr : RegPack;

  PROCEDURE quit;
  BEGIN
    abort('Invalid date.');
  END;

BEGIN {SetDate}
  WITH rgstr DO
    BEGIN
      ah := $2B; {Set date function number}
      IF year < 1900
    THEN year := year + 1900;
      IF (year >= 1980) and (year <= 2099)
    THEN cx := year
    ELSE quit;
      IF month in [1..12]
    THEN dh := month
    ELSE quit;
      IF day in [1..31]
    THEN dl := day
    ELSE quit;
      msdos( rgstr );
    END; {WITH rgstr}
END; {SetDate}



FUNCTION MkDir( DirName: dos2str80 ): ErrorMessage;
VAR
  rgstr : RegPack;
BEGIN {MkDir}
  MkDir := NoError;
  MakeAsciiZ( DirName );
  WITH rgstr DO BEGIN
    ah := $39; {Create a sub-directory.}
    ds := seg( DirName );
    dx := ofs( DirName );
    msdos( rgstr );
    IF FlaggedError( flags )
      THEN MkDir := MessageType( ax );
  END; {WITH rgstr}
END; {MkDir}


FUNCTION RmDir( DirName: dos2str80 ): ErrorMessage;
VAR
  rgstr : RegPack;
BEGIN {RmDir}
  RmDir := NoError;
  MakeAsciiZ( DirName );
  WITH rgstr DO BEGIN
    ah := $3A; {Remove a directory entry}
    ds := seg( DirName );
    dx := ofs( DirName );
    msdos( rgstr );
    IF FlaggedError( flags )
      THEN RmDir := MessageType( ax );
  END; {WITH rgstr}
END; {RmDir}


FUNCTION ChDir( DirName: dos2str80 ): ErrorMessage;
VAR
  rgstr : RegPack;
BEGIN {ChDir}
  ChDir := NoError;
  MakeAsciiZ( DirName );
  WITH rgstr DO BEGIN
    ah := $3B; {Change the current directory}
    ds := seg( DirName );
    dx := ofs( DirName );
    msdos( rgstr );
    IF FlaggedError( flags )
      THEN ChDir := MessageType( ax );
  END; {WITH rgstr}
END; {ChDir}

FUNCTION FileExists( fname: dos2str80 ): BOOLEAN;
VAR dumset: ModeSet;
    resultofgfm: ErrorMessage;
BEGIN {FileExists}
  resultofgfm := GetFileMode( fname, dumset);
  IF resultofgfm IN [FileNotFound, PathNotFound] THEN
    FileExists := FALSE
  ELSE FileExists := TRUE;
END; {FileExists}



(*
                          Dos2io-3.inc


    Dedicated to the public domain.

        -- Cole Brecheen
           17 August 1985
*)
{$V-} {Relaxes type checking on string parameters.}
{ $U-,C-}{Enables keyboard buffering.}


PROCEDURE SetPtrFromEnd( FileHandle: INTEGER;
                 OffSetFromEnd: REAL );
LABEL EndProcedure;
VAR
  TmpPtr : BufferPtr;
  rgstr : RegPack;
  lngthnum : REAL;
  segnum : INTEGER;
BEGIN {SetPtrFromEnd}
  lngthnum := FileLength( FileHandle );
  IF lngthnum = 0
    THEN GOTO EndProcedure;
  WITH rgstr DO BEGIN
    ah := $42; {command to move file read/write pointer}
    al := 0;
    {Zero in al means that pointer moves to offset bytes
    from the beginnning of the file.}
    bx := FileHandle;

    RealToSegmented( lngthnum + OffSetFromEnd, cx, dx );
    msdos( rgstr );
    IF FlaggedError( flags )
      THEN BEGIN { writeln('setptrfromend error'); } {diag}
        PrintMessage( MessageType( ax ) );
      END;
  END; {WITH rgstr}

  CheckInitialization;
    {From here down we're flushing any buffer that
    corresponds with this filehandle.}

  IF BufLstBase = nil
    THEN GOTO EndProcedure;
  TmpPtr := BufLstBase;
  WHILE (TmpPtr^.next <> nil)
    and
    (TmpPtr^.handle <> FileHandle) DO TmpPtr := TmpPtr^.next;
  IF TmpPtr^.handle = FileHandle
    THEN  tmpPtr^.ndx := BufSize + 1;
  EndProcedure:
END; {SetPtrFromEnd}


PROCEDURE SetPtrFromStart( FileHandle: INTEGER;
                   OffSetFromStart : REAL );
LABEL
  EndProcedure;
VAR
  TmpPtr : BufferPtr;
  rgstr : RegPack;
BEGIN {SetPtrFromStart}
  WITH rgstr DO BEGIN
    ah := $42;
    {command to move file read/write pointer}
    al := 0;
    {moves pointer to offset bytes from the beginnning of the
    file}
    bx := FileHandle;
    RealToSegmented( OffSetFromStart, cx, dx );
    msdos( rgstr );
    IF FlaggedError( flags )
      THEN BEGIN { writeln('setptrfromstart error'); } {diag}
        PrintMessage( MessageType( ax ) );
      END;
  END; {WITH rgstr}

  CheckInitialization;
  IF BufLstBase = nil
    THEN GOTO EndProcedure;
  TmpPtr := BufLstBase;
  WHILE (TmpPtr^.next <> nil)
    and
    (TmpPtr^.handle <> FileHandle) DO TmpPtr := TmpPtr^.next;
  IF TmpPtr^.handle = FileHandle
    THEN  tmpPtr^.ndx := BufSize + 1;
  EndProcedure:
END; {SetPtrFromStart}



FUNCTION BytesToWord( lobyte, hibyte: INTEGER ): INTEGER;
    {Takes two bytes and stores them in a single word.  The
    last byte in the parameter list is most significant.}
BEGIN {BytesToWord}
  hibyte := swap( hibyte );
      {Reverses the order of the two bytes in hibyte.}
  BytesToWord := lobyte OR hibyte;
      {OR does bitwise addition in this language.}
END; {BytesToWord}


PROCEDURE BitRangeToInt( TheSet: BitSet;
                 LowBit, HighBit: INTEGER;
                 VAR answer:  INTEGER );
      {BitRangeToInt lets us specify the bits that store the
      value in which we're interested, and it loads that value
      into the last parameter in the list.}

  FUNCTION power(x,n:INTEGER): INTEGER;
    {Returns x raised to the nth power.}
  VAR w,z,i: INTEGER;
  BEGIN
    w := x; i := n;
    z := 1;
    WHILE i <> 0 DO
    BEGIN
      IF ODD(i) THEN z := z*w;
      i := i DIV 2;
      IF i <> 0
    THEN w := w*w;
    END;
    power := z;
  END; {power}

VAR
  tmp: RECORD
     CASE BOOLEAN of
       true: ( IntForm : INTEGER );
       false:( SetForm : BitSet );
       END;
  cnt : INTEGER;
BEGIN {BitRangeToInt}
  tmp.SetForm := TheSet;
  {Bit 15 is most significant.}
  answer := 0;
  FOR cnt := LowBit TO HighBit DO
    BEGIN
      IF cnt IN tmp.SetForm
    THEN answer := answer + power( 2,  cnt - LowBit );
    END;
END;  {BitRangeToInt}


PROCEDURE IntegerToDate( TheInt: INTEGER;
                 VAR month, day, year: INTEGER );
VAR
  TheSet : BitSet;
BEGIN {IntegerToDate}
  IntegerToBitSet( TheInt, TheSet );
  BitRangeToInt( TheSet, 0, 4, day );
  BitRangeToInt( TheSet, 5, 8, month );
  BitRangeToInt( TheSet, 9, 15, year );
  year := year + 80;
END; {IntegerToDate}



FUNCTION DateToInteger( month, day, year: INTEGER ): INTEGER;
VAR
  BitSet1, BitSet2: BitSet;
  TmpResult: {integer} word;
  buf: BitRange;
BEGIN {DateToInteger}
  IF year > 1900 THEN
    year := year - 1900;
  IF year in [80 .. 199] THEN
    year := year - 80
  ELSE abort( 'Invalid year: ' + IntStr(year,0) );
  IF not (month in [1..12]) THEN
    abort( 'Invalid month: ' + IntStr(month,0) );
  IF not (day in [1..31]) THEN
    abort( 'Invalid day: ' + IntStr(day,0) );


  IntegerToBitSet( 0, BitSet2 );
  IntegerToBitSet( day, BitSet1 );
  FOR buf := 0 to 15 DO
    BEGIN
      IF buf in BitSet1
    THEN BitSet2 := BitSet2 + [buf];
    END;

  IntegerToBitSet( month, BitSet1 );
  FOR buf := 0 to 15 DO
    BEGIN
      IF buf in BitSet1
    THEN BitSet2 := BitSet2 + [buf + 5];
    END;

  IntegerToBitSet( year, BitSet1 );
  FOR buf := 0 to 15 DO
    BEGIN
      IF buf in BitSet1
    THEN BitSet2 := BitSet2 + [buf + 9];
    END;

  BitSetToInteger( BitSet2, TmpResult );
  DateToInteger := TmpResult;
END; {DateToInteger}



PROCEDURE IntegerToTime( TheInteger: INTEGER;
                 VAR hours, minutes, seconds : INTEGER );
VAR
  TheSet : BitSet;
BEGIN {IntegerToTime}
  IntegerToBitSet( TheInteger, TheSet );
  BitRangeToInt( TheSet, 11, 15, hours );
  BitRangeToInt( TheSet, 5, 10, minutes );
  BitRangeToInt( TheSet, 0, 4, seconds );
  seconds := seconds * 2;
    {We double seconds because the operating system stores
    this value in two-second increments.}
END; {IntegerToTime}



FUNCTION TimeToInteger( hours,
                minutes,
                seconds: INTEGER ): INTEGER;
VAR
  BitSet1, BitSet2: BitSet;
  TmpResult: {integer} word;
  buf: BitRange;
BEGIN {TimeToInteger}
  IF not (hours in [0..23]) THEN
    abort( 'Invalid hour: ' + IntStr(hours,0) );
  IF not( minutes in [0..59] ) THEN
    abort( 'Invalid minute: ' + IntStr(minutes,0) );
  IF not( seconds in [0..59] ) THEN
    abort( 'Invalid second: ' + IntStr(seconds,0) );

  IntegerToBitSet( 0, BitSet2 );
  IntegerToBitSet( seconds div 2, BitSet1 );
  FOR buf := 0 to 15 DO
    BEGIN
      IF buf in BitSet1
    THEN BitSet2 := BitSet2 + [buf];
    END;

  IntegerToBitSet( minutes, BitSet1 );
  FOR buf := 0 to 15 DO
    BEGIN
      IF buf in BitSet1
    THEN BitSet2 := BitSet2 + [buf + 5];
    END;

  IntegerToBitSet( hours, BitSet1 );
  FOR buf := 0 to 15 DO
    BEGIN
      IF buf in BitSet1
    THEN BitSet2 := BitSet2 + [buf + 11];
    END;

  BitSetToInteger( BitSet2, TmpResult );
  TimeToInteger := TmpResult;
END; {TimeToInteger}



PROCEDURE AddToFile( FileName : dos2str80; FileHandle : INTEGER;
             message  : dos2str255 );
VAR
  SavedMessage  : ErrorMessage;
  AlreadyOpen   : BOOLEAN;

BEGIN  {AddToFile}
  IF FileName = null
    THEN abort( 'Always pass a file name to AddToFile.' );
  IF FileHandle > 4 {see D-15 of PC-DOS manual}
    THEN
      BEGIN
    AlreadyOpen := TRUE;
      END
    ELSE
      BEGIN
    AlreadyOpen := FALSE;
    SavedMessage := OpenFile( FileHandle, FileName );
    IF SavedMessage <> NoError
      THEN printmessage( SavedMessage );
      END;

  SetPtrFromEnd( FileHandle, -1 );
    {We move to -1 because we want to insert this data just
    before the eof char.}

  AddStr( message, #26 );
    {This will be the new eof marker.}
  WriteStr( FileHandle, message );
  PrintMessage( CloseHandle( FileHandle ) );
    {updates the file length}
  IF AlreadyOpen
    THEN
      BEGIN
    SavedMessage := OpenFile( FileHandle, FileName );
    IF SavedMessage <> NoError
      THEN printmessage( SavedMessage );
      END;
END;  {AddToFile} 



 PROCEDURE SetFileDateAndTime( FileHandle,
                      month, day, year,
                      hours, minutes, seconds: INTEGER );
VAR
  rgstr : RegPack;
BEGIN {SetFileDateAndTime}
  WITH rgstr DO
    BEGIN
      ah := $57;
      al := 1;
      bx := FileHandle;
      dx := DateToInteger( month, day, year );
      cx := TimeToInteger( hours, minutes, seconds );
    {The reason for the swaps is that the bytes are reversed
    when date and time values are passed in registers.}
      msdos( rgstr );
      IF FlaggedError( flags )
    THEN PrintMessage( MessageType( ax ) );
    END; {WITH rgstr}
END; {SetFileDateAndTime}



 PROCEDURE GetFileDateAndTime( FileHandle: INTEGER;
                      VAR month, day, year,
                      hours, minutes, seconds: INTEGER );
VAR
  rgstr : RegPack;
BEGIN {GetFileDateAndTime}
  WITH rgstr DO
    BEGIN
      ah := $57;
      al := 0;
      bx := FileHandle;
      msdos( rgstr );
      IF FlaggedError( flags ) THEN
    PrintMessage( MessageType( ax ) )
      ELSE
    BEGIN
      IntegerToDate( dx, month, day, year );
      IntegerToTime( cx, hours, minutes, seconds );
    END;
    END; {WITH rgstr}
END; {GetFileDateAndTime}


 PROCEDURE LoadDTAinfo( VAR tmpstr : dos2str255 );
    {Pulls information about files from an area of memory
    called the Disk Transfer Address (DTA).  Used in both
    FindFirstFile and FindNextFile, below.}

  PROCEDURE ExtractTime( TheInteger : INTEGER;
                 VAR TheStr : dos2str80 );
  TYPE
    str8 = STRING[8];
  VAR
    hours, minutes, seconds : INTEGER;
    TheSet : BitSet;
    MinStr : str8;
    pm : BOOLEAN;
  BEGIN {ExtractTime}
    IntegerToTime( TheInteger, hours, minutes, seconds );
    {From here down we're formatting TheStr so that the
    string returned by LoadDTAinfo will look nice if it's
    written.}
{
    str( seconds:2, SecStr );
    IF SecStr[1] = ' '
      THEN SecStr[1] := '0';
    You can add this back in if you're interested in the
    seconds part of the file's time.
}
    str( minutes:2, MinStr );
    IF MinStr[1] = ' '
      THEN MinStr[1] := '0';
    pm := hours > 12;
    IF pm
      THEN hours := hours - 12;
    TheStr := concat( '  ', IntStr(hours,2), ':', MinStr );
    IF pm
      THEN TheStr := concat( TheStr, 'p' )
      ELSE TheStr := concat( TheStr, 'a' );
  END;  {ExtractTime}


  PROCEDURE ExtractDate( TheInteger : INTEGER;
                 VAR TheStr : dos2str80 );
  TYPE
    str8 = STRING[8];
  VAR
    month, day, year : INTEGER;
    TheSet : BitSet;
    YrStr, MnthStr, DayStr : str8;
  BEGIN {ExtractDate}
    IntegerToDate( TheInteger, month, day, year );
    str( day:2, DayStr );
    IF DayStr[1] = ' '
      THEN DayStr[1] := '0';
    TheStr := concat( IntStr(month,2),
              '-', DayStr,
              '-', IntStr(year,2) );
  END;  {ExtractDate}

LABEL 1;
TYPE
  str32 = STRING[32];
VAR
  rgstr : RegPack;
  FileSize : REAL;
  DTAinfo : dos2str255;
  SizeStr,
  datestr,
  timestr : str32;
  SubDirCode,
  cnt,
  index : INTEGER;
  LoWord, HiWord : INTEGER;
BEGIN {LoadDTAinfo}
  SizeStr := null;
  DateStr := null;
  TimeStr := null;

  WITH rgstr DO BEGIN
    ah := $2F; {get Disk Transfer Address}
    msdos( rgstr );
      {ES:BX now contains the DTA}
    FillChar( DTAinfo, sizeof( DTAinfo ), CHR(0) );
    FOR cnt := 0 TO 42 DO
       mem[seg(DTAinfo):ofs(DTAinfo) + cnt] := mem[ES:bx + cnt];
    {Transfers 43 bytes from the DTA into DTAinfo.}
  END; {WITH rgstr}

  SubDirCode := ord(DTAinfo[21]) and $10;
    {This sets SubDirCode to 16--that is, it turns on the
    fourth bit of SubDirCode--if the file found is a
    directory entry.  Otherwise, SubDirCode is set to 0.}

  IF SubDirCode <> 0 {That is, if the file is a sub-directory.}
    THEN SizeStr := '   <DIR>'
    ELSE
      BEGIN
    LoWord := BytesToWord( ORD(DTAinfo[26]), ORD(DTAinfo[27]) );
    HiWord := BytesToWord( ORD(DTAinfo[28]), ORD(DTAinfo[29]) );
    FileSize := SegmentedToReal( HiWord, LoWord );
    str( FileSize:0:0, SizeStr );
    WHILE length(SizeStr) < 8
      DO insert( ' ', SizeStr, 1 );
      END;

  ExtractTime( BytesToWord( ORD(DTAinfo[22]), ORD(DTAinfo[23]) ),
           timestr );
  ExtractDate( BytesToWord( ORD(DTAinfo[24]), ORD(DTAinfo[25]) ),
           datestr );
  WHILE length(DateStr) < 10
    DO insert( ' ', DateStr, 1 );

  tmpstr := null;
  FOR index := 30 TO 43 DO
    BEGIN
      tmpstr[0] := succ( tmpstr[0] );
      IF DTAinfo[ index ] = CHR(0)
    THEN
      BEGIN
        tmpstr[0] := pred( tmpstr[0] );
        GOTO 1;
      END
    ELSE tmpstr[ index - 29 ] := DTAinfo[ index ];
    END;
  1:
  WHILE length(TmpStr) < 12
    DO TmpStr := concat( TmpStr, ' ' );
  TmpStr := concat( TmpStr, SizeStr, datestr, timestr );
END;  {LoadDTAinfo}





TYPE
  DTAptr = ^DTA;
  DTA = array [1..128] of byte;
VAR
  DTAseg, DTAofs : INTEGER;
  TmpDTAptr : DTAptr;

PROCEDURE SaveDTA;
VAR
  rgstr : RegPack;
BEGIN {SaveDTA}
  WITH rgstr DO BEGIN
    ah := $2F;
    msdos( rgstr );
    DTAseg := es;
    DTAofs := bx;
    new( TmpDTAptr );
    ds := seg( TmpDTAptr^ );
    dx := ofs( TmpDTAptr^ );
    ah := $1A;
  END; {WITH rgstr}
  msdos( rgstr );
END; {SaveDTA}

PROCEDURE RestoreDTA;
VAR
  rgstr : RegPack;
BEGIN {RestoreDTA}
  dispose( TmpDTAptr );
  rgstr.ds := DTAseg;
  rgstr.dx := DTAofs;
  rgstr.ah := $1A;
  msdos( rgstr );
END; {RestoreDTA}


 FUNCTION FindFirstFile(FileName: dos2str80;
               VAR FileInfo: dos2str255): ErrorMessage;
VAR
  tmpset : BitSet;
  rgstr : RegPack;
  tmpstr : dos2str80;
BEGIN {FindFirstFile}
  FindFirstFile := NoError;
  FileInfo := null;
  tmpstr := FileName;
  MakeAsciiZ( tmpstr );
  WITH rgstr DO BEGIN
    dx := ofs( tmpstr );
    ds := seg( tmpstr );
    TmpSet := [0,1,2,4];
    {We set four attribute bits:  read-only file, hidden
    file, system file, and sub-directory.  This allows us to
    find any of these files, plus normal files.}
    BitSetToInteger( TmpSet, cx );
    ah := $4E; {find first matching file}
    msdos( rgstr );
    IF FlaggedError( flags )
      THEN FindFirstFile := MessageType( ax )
      ELSE LoadDTAinfo( FileInfo );
  END; {WITH rgstr}
END; {FindFirstFile}


 FUNCTION FindNextFile( VAR FileInfo : dos2str255 ): ErrorMessage;
VAR
  rgstr : RegPack;
BEGIN
  FindNextFile := NoError;
  FileInfo := null;
  WITH rgstr DO BEGIN
    ah := $4F; {find next matching file}
    flags := 0;
    msdos( rgstr );
    IF FlaggedError( flags )
      THEN FindNextFile := MessageType( ax )
      ELSE LoadDTAinfo( FileInfo );
  END; {WITH rgstr}
END; {FindNextFile}



 FUNCTION VolumeLabel( TheDrive: CHAR ): dos2str80;
    {Returns the label of the disk in TheDrive.}
VAR
  rgstr : RegPack;
  XFCB : RECORD
       prfx : array [1..7] of byte;
       fcb : array [0..36] of byte;
     END;
    {XFCB is an "Extended File Control Block." }
  bufstr : dos2str80;
  cnt : INTEGER;
BEGIN {VolumeLabel}
  lowerch( TheDrive );
  bufstr := null;
  fillchar( XFCB, sizeof(XFCB), '?' );
    {We fill XFCB with question marks because function $11
    does not take any other kind of wildcard.  The PC-DOS
    documentation says that question-mark wildcards are
    allowed, but neglects to mention that they are
    mandatory.}
  WITH XFCB DO
    BEGIN
      prfx[1] := $FF; {indicates an extended FCB}
      prfx[7] := $8; {attribute set to volume label}
      IF TheDrive = 'z'
    THEN fcb[0] := 0
    ELSE fcb[0] := ord(TheDrive) - 96 ;
    {sets 'a' to 1, 'b' to 2, etc.}
    END;

  WITH rgstr DO BEGIN
    ds := seg( XFCB );
    dx := ofs( XFCB );
    ah := $11; {Search for first entry.}
    msdos( rgstr );
    IF al = $FF
      THEN bufstr := 'unlabelled vol'
      ELSE
    BEGIN
      ah := $2F; {get Disk Transfer Address}
      msdos( rgstr );
        {ES:BX now contains the DTA}
      FOR cnt := 8 to 18 DO
        AddStr( bufstr, chr(mem[es:bx + cnt]) );
    {We do this because information from the search gets
    transferred into the DTA, not the extended file control
    block whose address we passed going into function $11.}
    END;
  END; {WITH rgstr}
  VolumeLabel := bufstr;
END; {VolumeLabel}



FUNCTION FreeDiskSpace( DriveLetter: CHAR;
                VAR FreeBytes: REAL ): ErrorMessage;
CONST
  upperdifference = 32;
VAR
  rgstr : RegPack;
BEGIN
  FreeDiskSpace := NoError;
  FreeBytes := 0;
  lowerch( DriveLetter );
  IF not (DriveLetter in ['a'..'z'])
    THEN halt;
  WITH rgstr DO BEGIN
    IF DriveLetter = 'z' {'z' means default drive}
      THEN dl := 0
      ELSE dl := ord( DriveLetter ) - 96;
    {turns an A into a 1, etc}
    ah := $36;
    msdos( rgstr );
    IF ax = $FFFF THEN
      FreeDiskSpace := InvalidDrive
    {AX returns $FFFF if the drive number was invalid.
    Otherwise, BX contains the number of available clusters,
    DX contains the total number of bytes per sector, and AX
    contains the number of sectors per cluster.}
    ELSE
      BEGIN
    FreeBytes := WordToReal(bx) * WordToReal(ax);
    FreeBytes := FreeBytes * WordToReal(cx);
    {Division of this operation into two lines only reduces
    the width of the listing.}
      END;
  END; {WITH rgstr}
END; {FreeDiskSpace}



 FUNCTION CopyFile( OldHandle: integer;
           NewFileName: dos2str80 ): ErrorMessage;
TYPE
  memptr = RECORD
         addr : ^integer;
         size : INTEGER;
       END;

VAR
  TheDrive : char;
  MemoryPtr : memptr;
  NewHandle : INTEGER;
  SavedMessage : ErrorMessage;
  FreeBytes,
  FileSize,
  BytesToBeFreed,
  BytesToRead : REAL;


  PROCEDURE ReadOldFile( VAR MemoryPtr : memptr );
  LABEL EndProcedure;
  VAR
    rgstr : regpack;

    function min( first, second: real ): real;
    begin {min}
      if first < second
    then min := first
    else min := second;
    end; {min}

  BEGIN {ReadOldFile}
    IF BytesToRead <= 0 THEN
      BEGIN
    MemoryPtr.addr := nil;
    GOTO EndProcedure;
      END;
    with MemoryPtr DO
      BEGIN
    size := RealToWord( min( maxavail * 16,
                         min( SegSize - 1,
                              BytesToRead)));
    GetMem( addr, size );
    rgstr.cx := size;
          {CX gets number of bytes to read.}
    rgstr.ah := $3F;  {DOS Read From file Code}
    rgstr.bx := OldHandle;
    rgstr.dx := ofs( addr^ );
    rgstr.ds := seg( addr^ );
      END;
    msdos( rgstr );
    IF FlaggedError( rgstr.flags )
      THEN printmessage( messagetype( rgstr.ax ) )
      ELSE BytesToRead := BytesToRead - MemoryPtr.size;
    EndProcedure:
  END; {ReadOldFile}


  PROCEDURE WriteNewFile( MemoryPtr : MemPtr );
  LABEL EndProcedure;
  VAR
    rgstr : regpack;
  BEGIN {WriteNewFile}
    IF MemoryPtr.addr = nil
      THEN GOTO EndProcedure;

    rgstr.bx := NewHandle;
    rgstr.cx := MemoryPtr.size;
    rgstr.ds := seg( MemoryPtr.addr^ );
    rgstr.dx := ofs( MemoryPtr.addr^ );
    rgstr.ah := $40;  {Write to a file or device.}
    msdos( rgstr );
    IF rgstr.ax < rgstr.cx
      {if fewer than cx bytes were actually written}
      THEN
    BEGIN
      CopyFile := AccessDenied;
      SavedMessage := CloseHandle( NewHandle );
      WriteStr( outp, 'No room.' );
      halt;
    END;
    FreeMem( MemoryPtr.addr, MemoryPtr.size );
    EndProcedure:
  END; {WriteNewFile}



  PROCEDURE SetDateAndTime;
  VAR
    month, day, year,
    hours, minutes, seconds : INTEGER;
  BEGIN
    GetFileDateAndTime(OldHandle, month, day, year,
                          hours, minutes, seconds );
    SetFileDateAndTime(NewHandle, month, day, year,
                          hours, minutes, seconds );
  END; {SetDateAndTime}


LABEL
  EndProcedure;

begin {CopyFile}
  BytesToBeFreed := 0;
  CopyFile := NoError;
  FileSize := FileLength( OldHandle );
  BytesToRead := FileSize;

  IF pos(':', NewFileName) = 2 THEN
    TheDrive := NewFileName[1]
  ELSE TheDrive := 'z';
    {Determines the drive to which we're copying.
    'z' means "default drive" to FreeDiskSpace.}
  SavedMessage := FreeDiskSpace( TheDrive, FreeBytes );
  if SavedMessage <> NoError then
    goto EndProcedure;

  SavedMessage := OpenFile( NewHandle, NewFileName );
  if SavedMessage = NoError then
    begin
      BytesToBeFreed := FileLength( NewHandle );
      SavedMessage := CloseHandle( NewHandle );
    end
  else
    begin
      if SavedMessage <> FileNotFound then
    goto EndProcedure;
    end;

  IF FileSize > (FreeBytes + BytesToBeFreed) THEN
    BEGIN
      SavedMessage := AccessDenied;
    {This will have to stand for 'Not enough room.'}
      goto EndProcedure;
    END;

  SavedMessage := CreateFile(NewHandle, NewFileName);
  if SavedMessage <> NoError then
    goto EndProcedure;

  REPEAT
    ReadOldFile( MemoryPtr );
    WriteNewFile( MemoryPtr );
  UNTIL (BytesToRead <= 0);

  SetDateAndTime;

  SavedMessage := CloseHandle(NewHandle);
  EndProcedure:
  CopyFile := SavedMessage;
end; {CopyFile}






begin

  InitDos2io;
end.