UNIT ErrorStuf;
INTERFACE
{ Error message handler for MBS. L.Boshell 16/11/92                       }
{ 17/12/95 Error 1, SHARE not loaded or invalid DOS version message added }
{  7/ 2/99 Other assorted errors added                                    }

Function GetERROR(ErrNo:integer): String;

IMPLEMENTATION

Function GetERROR(ErrNo:integer): String;
var
  exitmsg:string;
begin
    case ErrNo of
    1  :exitmsg:='Share not loaded (or possibly old DOS)'; {17/12/95}
    2  :exitmsg:='File not found';
    3  :exitmsg:='Path not found (bad path or file name)';
    4  :exitmsg:='Too many open files';
    5  :exitmsg:='Access denied';
    6  :exitmsg:='Invalid file handle';
    7  :exitmsg:='Memory ctrl blocks destroyed'; {added 7/2/99}
    8  :exitmsg:='Insufficient memory';          {added 7/2/99}
    9  :exitmsg:='Invalid memory block address'; {added 7/2/99}
    10 :exitmsg:='Invalid environment';          {added 7/2/99}
    11 :exitmsg:='Invalid format';               {added 7/2/99}
    12 :exitmsg:='Invalid file access code';
    13 :exitmsg:='Invalid data';                 {added 7/2/99}
    14 :exitmsg:='this eror code not used!!';    {added 7/2/99}
    15 :exitmsg:='Invalid drive';
    16 :exitmsg:='Cannot remove current directory';
    17 :exitmsg:='Cannot rename across drives';
    18 :exitmsg:='No more files to be found ';{18..89 added 26/12/95}
    19 :exitmsg:='Disk write protected';
    20 :exitmsg:='Unknown unit ID ';
    21 :exitmsg:='Disk drive not ready';
    22 :exitmsg:='Command not defined';
    23 :exitmsg:='Disk data error ';
    24 :exitmsg:='Bad request structure length';
    25 :exitmsg:='Disk seek error';
    26 :exitmsg:='Unknown disk media type';
    27 :exitmsg:='Disk sector not found ';
    28 :exitmsg:='Printer out of paper';
    29 :exitmsg:='Write error - Printer Error?';
    30 :exitmsg:='Read error ';
    31 :exitmsg:='General failure ';
    32 :exitmsg:='File sharing violation ';
    33 :exitmsg:='File locking violation ';
    34 :exitmsg:='Improper disk change';
    35 :exitmsg:='No FCB available';
    36 :exitmsg:='Sharing buffer overflow';
    50 :exitmsg:='Network request not supported ';
    51 :exitmsg:='Remote computer not listening ';
    52 :exitmsg:='Duplicate name on network ';
    53 :exitmsg:='Network name not found ';
    54 :exitmsg:='Network busy ';
    55 :exitmsg:='Network device no longer exists';
    56 :exitmsg:='NetBIOS command limit exceeded';
    57 :exitmsg:='Network adapter hardware error';
    58 :exitmsg:='Incorrect response from network';
    59 :exitmsg:='Unexpected network error';
    60 :exitmsg:='Incompatible remote adapter ';
    61 :exitmsg:='Print queue full';
    62 :exitmsg:='Not enough space for print file';
    63 :exitmsg:='Print file was deleted ';
    64 :exitmsg:='Network name was deleted';
    65 :exitmsg:='Access denied';
    66 :exitmsg:='Network device type incorrect';
    67 :exitmsg:='Network name not found';
    68 :exitmsg:='Network name limit exceeded ';
    69 :exitmsg:='NetBIOS session limit exceeded';
    70 :exitmsg:='Temporarily paused';
    71 :exitmsg:='Network request not accepted ';
    72 :exitmsg:='Print or disk re-direction is paused';
    80 :exitmsg:='File already exists';
    81 :exitmsg:='Reserved';
    82 :exitmsg:='Cannot make ';
    83 :exitmsg:='Critical-error interrupt failure';
    84 :exitmsg:='Too many redirections ';
    85 :exitmsg:='Duplicate redirection ';
    86 :exitmsg:='Duplicate password';
    87 :exitmsg:='Invalid parameter';
    88 :exitmsg:='Network data fault';
    89 :exitmsg:='Undefined Error';

    100:exitmsg:='Disk read error';
    101:exitmsg:='Disk write error - Disk Full ?';
    102:exitmsg:='File not assigned';
    103:exitmsg:='File not opened';
    104:exitmsg:='File not open for input';
    105:exitmsg:='File not open for output';
    106:exitmsg:='Invalid numeric format';
    122:exitmsg:='Invalid directory path';
    150:exitmsg:='Disk is write protected';
    151:exitmsg:='Unknown unit';
    152:exitmsg:='Drive not ready';
    153:exitmsg:='Unkown command';
    154:exitmsg:='CRC error in data';
    155:exitmsg:='Bad drive request structure length';
    156:exitmsg:='Disk seek error';
    157:exitmsg:='Unknown media type';
    158:exitmsg:='Sector not found';
    159:exitmsg:='Printer out of paper';
    160:exitmsg:='Device write fault';
    161:exitmsg:='Device read fault';
    162:exitmsg:='Hardware failure';
    200:exitmsg:='Division by zero';
    201:exitmsg:='Range check error';
    202:exitmsg:='Stack overflow';
    203:exitmsg:='Heap overflow';
    204:exitmsg:='Invalid pointer operation';
    205:exitmsg:='Floating point overflow';
    206:exitmsg:='Floating point underflow';
    207:exitmsg:='Invalid floating point operation'
    else
      Begin
      ExitMsg:='';
      Str(ErrNo,ExitMsg);
      exitmsg:='Unknown Error # '+ exitMsg;
      end;
    end;
  GetERROR:=exitmsg;
end;

Begin
end.






