
{$N+} {for turbo single}

unit globals;   (* for I.5 dos cross-compiler*)
interface


CONST
  DISPLIMIT    = 12;
  MAXLEVEL     = 8;
  MAXADDR      = 28000;
  INTSIZE      = 1;
  REALSIZE     = 2;
  BITSPERWD    = 16;
  CHARSIZE     = 1;
  BOOLSIZE     = 1;
  PTRSIZE      = 1;
  FILESIZE     = 300;
  NILFILESIZE  = 40;
  BITSPERCHR   = 8;
  CHRSPERWD    = 2;
  STRINGSIZE   = 0;
  STRGLGTH     = 255;
  MAXINT       = 32767;   {STOPS ERR 101 U-}
  MAXDEC       = 36;
  DEFSTRGLGTH  = 80;
  LCAFTERMARKSTACK = 1;
  REFSPERBLK   = 128;
  EOL          = 13;
  MAXCURSOR    = 1023;
  MAXCODE      = {1299;} {2999} 4999;     {/tp5}
  MAXJTAB      = 24;
  MAXSEG       = 15;
  MAXPROCNUM   = 149;


  idnum        =  45+1;  {patch /tp3}  {+1 for binary search in idsearch}

  pnil         = nil;

  setsize      = 4079;     {157g,bug13}


TYPE 

   PHYLE = FILE;
   INFOREC = RECORD
            { WORKSYM,WORKCODE: ^PHYLE; }
            ERRSYM,ERRBLK,ERRNUM: INTEGER;
            SLOWTERM,STUPID: BOOLEAN;
            ALTMODE: CHAR
          END;


                 (*BASIC SYMBOLS, MUST MATCH ORDER IN IDSEARCH*)

SYMBOL =  (IDENT,COMMA,COLON,SEMICOLON,LPARENT,RPARENT,DOSY,TOSY,
	  DOWNTOSY,ENDSY,UNTILSY,OFSY,THENSY,ELSESY,BECOMES,LBRACK,
	  RBRACK,ARROW,PERIOD,BEGINSY,IFSY,CASESY,REPEATSY,WHILESY,
	  FORSY,WITHSY,GOTOSY,LABELSY,CONSTSY,TYPESY,VARSY,PROCSY,
	  FUNCSY,PROGSY,FORWARDSY,INTCONST,REALCONST,STRINGCONST,
	  NOTSY,MULOP,ADDOP,RELOP,SETSY,PACKEDSY,ARRAYSY,RECORDSY,
	  FILESY,OTHERSY,LONGCONST,USESSY,UNITSY,INTERFCESY,IMPLESY,
	  EXTERNLSY,SEPARATSY,absolutsy {/pc157f});


OPERATOR = (MUL,RDIV,ANDOP,IDIV,IMOD,PLUS,MINUS,OROP,LTOP,LEOP,
            GEOP,GTOP,NEOP,EQOP,INOP,NOOP,shlop,shrop,xorop); {/pc157d}

SETOFSYS = SET OF SYMBOL;

{SEEK CHANGED TO SEAK}
{SEEK CHANGED TO SEAK}
NONRESIDENT = (fSEAK,         {/tp5}   {cxp 0  9}
               fFREADREAL,    {/tp5}   {cxp 0 14}
               fFWRITEREAL,   {/tp5}   {cxp 0 15}
               fFREADDEC,     {/pc157a}{cxp 0 50}
               fFWRITEDEC,    {/pc157a}{cxp 0 51}
               fDECOPS);      {/pc157a}{cxp 0 49}

NONRESPFLIST = ARRAY[NONRESIDENT] OF INTEGER;


     

(*CONSTANTS*)





CSTCLASS = (REEL,PSET,STRG,TRIX,LONG);
CSP = ^ CONSTREC;
CONSTREC = RECORD CASE CCLASS: CSTCLASS OF
                    LONG: (LLENG,LLAST: INTEGER;
                           LONGVAL: ARRAY[1..9] OF INTEGER);
                    TRIX: (CSTVAL: ARRAY [1..8] OF INTEGER);
                          (*MUST COMPLETELY OVERLAP FOLLOWING FIELDS*)
                    REEL: (RVAL: {REAL} single );{/tp5 single}
                    PSET: (PVAL: SET OF 0..127);
                    STRG: (SLGTH: 0..STRGLGTH;
                           SVAL: PACKED ARRAY [1..STRGLGTH] OF CHAR)
                  END;

VALU = RECORD CASE BOOLEAN OF
                TRUE:  (IVAL: INTEGER);
                FALSE: (VALP: CSP)
              END;

(*DATA STRUCTURES*)
BITRANGE  = 0..BITSPERWD;
OPRANGE   = {0..80;} 0..86;  {patch /tp3}
CURSRANGE = 0..MAXCURSOR;
PROCRANGE = 0..MAXPROCNUM;
LEVRANGE  = 0..MAXLEVEL;
ADDRRANGE = 0..MAXADDR;
JTABRANGE = 0..MAXJTAB;
SEGRANGE  = 0..MAXSEG;
DISPRANGE = 0..DISPLIMIT;

  {POINTER is reserved word in turbo change to POINTERs}  {/tp3}
STRUCTFORM = (SCALAR,SUBRANGE,POINTERs,LONGINTs,POWER,ARRAYS,
              RECORDS,FILES,TAGFLD,VARIANT);

DECLKIND = (STANDARD,DECLARED,SPECIAL);

STP = ^ STRUCTURE; CTP = ^ IDENTIFIER;

STRUCTURE = RECORD
              SIZE: ADDRRANGE;
              CASE FORM: STRUCTFORM OF
                SCALAR:   (CASE SCALKIND: DECLKIND OF
                             DECLARED: (FCONST: CTP));
                SUBRANGE: (RANGETYPE: STP; MIN,MAX: VALU);
                POINTERs:  (ELTYPE: STP);    {/tp3}
                POWER:    (ELSET: STP);
                ARRAYS:   (AELTYPE,INXTYPE: STP;
                           CASE AISPACKD:BOOLEAN OF
                             TRUE: (ELSPERWD,ELWIDTH: BITRANGE;
                                    CASE AISSTRNG: BOOLEAN OF
                                     TRUE:(MAXLENG: 1..STRGLGTH)));
                RECORDS:  (FSTFLD: CTP; RECVAR: STP);
                FILES:    (FILTYPE: STP);
                TAGFLD:   (TAGFIELDP: CTP; FSTVAR: STP);
                VARIANT:  (NXTVAR,SUBVAR: STP; VARVAL: VALU)
              END;

                                                       (*NAMES*)
IDCLASS = (TYPES,KONST,FORMALVARS,ACTUALVARS,FIELD,
           PROC,FUNC,MODULE);
SETOFIDS = SET OF IDCLASS;
IDKIND = (ACTUAL,FORMAL);
ALPHA = PACKED ARRAY [1..8] OF CHAR;

IDENTIFIER = RECORD
              NAME: ALPHA; LLINK, RLINK: CTP;
              IDTYPE: STP; NEXT: CTP;
              CASE KLASS: IDCLASS OF
                KONST: (VALUES: VALU);
           FORMALVARS,
           ACTUALVARS: (VLEV: LEVRANGE;
                        VADDR: ADDRRANGE;
                        CASE BOOLEAN OF
                          TRUE: (PUBLIC: BOOLEAN));
                FIELD: (FLDADDR: ADDRRANGE;
                        CASE FISPACKD: BOOLEAN OF
                          TRUE: (FLDRBIT,FLDWIDTH: BITRANGE));
                PROC,
                FUNC:  (CASE PFDECKIND: DECLKIND OF
                         SPECIAL:  (KEY: INTEGER);
                         STANDARD: (CSPNUM: INTEGER);
                         DECLARED: (PFLEV: LEVRANGE;
                                    PFNAME: PROCRANGE;
                                    PFSEG: SEGRANGE;
                                    CASE PFKIND: IDKIND OF
                                     ACTUAL: (LOCALLC: ADDRRANGE;
                                              FORWDECL: BOOLEAN;
                                              EXTURNAL: BOOLEAN;
                                              INSCOPE: BOOLEAN;
                                              CASE BOOLEAN OF
                                               TRUE: (IMPORTED:BOOLEAN))));
              MODULE: (SEGID: INTEGER)
              END;


WHERE = (BLCK,CREC,VREC,REC);

(*EXPRESSIONS*)
ATTRKIND = (CST,VARBL,EXPR);
VACCESS = (DRCT,INDRCT,PACKD,MULTI,BYTE);

ATTR = RECORD TYPTR: STP;
         CASE KIND: ATTRKIND OF
           CST:   (CVAL: VALU);
           VARBL: (CASE ACCESS: VACCESS OF
                     DRCT:   (VLEVEL: LEVRANGE; DPLMT: ADDRRANGE);
                     INDRCT: (IDPLMT: ADDRRANGE))
       END;

TESTP = ^ TESTPOINTER;
TESTPOINTER = RECORD
                ELT1,ELT2 : STP;
                LASTTESTP : TESTP
              END;

(*LABELS*)
LBP = ^ CODELABEL;
CODELABEL = RECORD
              CASE DEFINED: BOOLEAN OF
                FALSE: (REFLIST: ADDRRANGE);
                TRUE:  (OCCURIC: ADDRRANGE; JTABINX: JTABRANGE)
            END;

LABELP = ^ USERLABEL;
USERLABEL = RECORD
              LABVAL: INTEGER;
              NEXTLAB: LABELP;
              CODELBP: LBP
            END;

REFARRAY = ARRAY[1..REFSPERBLK] OF
             RECORD
               KEY,OFFSET: INTEGER
             END;
             
CODEARRAY = PACKED ARRAY [0..MAXCODE] OF CHAR;
(*
SYMBUFARRAY = PACKED ARRAY [CURSRANGE] OF CHAR;
*)

symbufarray = packed array[0..2047] of char;    {/tp3}

UNITFILE = (WORKCODE,SYSLIBRARY);

lexptp3  = ^lexstkrec;   {patch /tp3}

LEXSTKREC = RECORD
              DOLDTOP: DISPRANGE;
              DOLDLEV: 0..MAXLEVEL;
              POLDPROC,SOLDPROC: PROCRANGE;
              DOLDSEG: SEGRANGE;
              DLLC: ADDRRANGE;
              BFSY: SYMBOL;
              DFPROCP: CTP;
              DMARKP: ^INTEGER;
              ISSEGMENT: BOOLEAN;
              PREVLEXSTACKP: {LEXSTKREC} lexptp3;  {patch /tp3}
            END;

   string80 = string[80];
   astringp = ^string80;


{TYPE for idtable}    {patch /tp3}
  t_tokenname = array[0..idnum] of alpha;
  t_tokentype = array[0..idnum] of symbol;
  t_optype    = array[0..idnum] of operator;




(*--------------------------------------------------------------------*)

VAR

    interlist   : Boolean;

    worksym,wurkcode    : file;         {read text and write code}

    {Note workcode changed to wurkcode to avoid id dec twice}
    listfile    : Text;
    userinfo    : inforec;              {keeps tab of error location}
    list_open   : Boolean;              {is the listing file open?}
    flipsex     : Boolean;              {opposite sex switch}
    CODEP: ^ CODEARRAY;             (*CODE BUFFER UNTIL WRITEOUT*)
    SYMBUFP: ^ SYMBUFARRAY;         (*SYMBOLIC BUFFER...ASCII OR CODED*)

    GATTR: ATTR;                    (*DESCRIBES CURRENT EXPRESSION*)

    TOP: DISPRANGE;                 (*TOP OF DISPLAY*)
    LC,IC: ADDRRANGE;               (*LOCATION AND INSTRUCT COUNTERS*)
    TEST: BOOLEAN;
    INTPTR: STP;                    (*POINTER TO STANDARD INTEGER TYPE*)
    SEG: SEGRANGE;                  (*CURRENT SEGMENT NO.*)
                                    (*SCANNER GLOBALS...NEXT FOUR VARS*)
                                        (*MUST BE IN THIS ORDER FOR IDSEARCH*)
    SYMCURSOR: {CURSRANGE;} integer; {/tp4}           (*CURRENT SCANNING INDEX IN SYMBUFP^*)
    SY: SYMBOL;                     (*SYMBOL FOUND BY INSYMBOL*)
    OP: OPERATOR;                   (*CLASSIFICATION OF LAST SYMBOL*)
    ID: ALPHA;                      (*LAST IDENTIFIER FOUND*)

    LGTH: INTEGER;                  (*LENGTH OF LAST STRING CONSTANT IN CHARS
                                      OR LEN OF LAST LONG INTEGER CONSTANT
                                       IN DIGITS*)
    VAL: VALU;                      (*VALUE OF LAST CONSTANT*)
    DISX: DISPRANGE;                (*LEVEL OF LAST ID SEARCHED*)

    LCMAX: ADDRRANGE;               (*TEMPORARIES LOCATION COUNTER*)

                                        (*SWITCHES:*)

    PRTERR,GOTOOK,RANGECHECK,DEBUGGING,
    NOISY,CODEINSEG,IOCHECK,BPTONLINE,
    CLINKERINFO,DLINKERINFO,LIST,TINY,LSEPPROC,
    DP,INCLUDING,USING,NOSWAP,SEPPROC,
    STARTINGUP,INMODULE,ININTERFACE,
    LIBNOTOPEN,SYSCOMP,PUBLICPROCS,GETSTMTLEV: BOOLEAN;

                                        (*POINTERS:*)
    {Why is intptr commented out???             LB}
    (*INTPTR,*)REALPTR,LONGINTPTR,
    CHARPTR,BOOLPTR,
    TEXTPTR,NILPTR, ptrptr,  {today}
    INTRACTVPTR,STRGPTR: STP; (*POINTERS TO STANDARD IDS*)

    UTYPPTR,UCSTPTR,UVARPTR,
    UFLDPTR,UPRCPTR,UFCTPTR,  (*POINTERS TO UNDECLARED IDS*)
    MODPTR,INPUTPTR,OUTPUTPTR,
    OUTERBLOCK,FWPTR,USINGLIST: CTP;

    GLOBTESTP: TESTP;         (*LAST TESTPOINTER*)

    LEVEL: LEVRANGE;          (*CURRENT STATIC LEVEL*)
    BEGSTMTLEV,STMTLEV:INTEGER;(*CURRENT STATEMENT NESTING LEVEL*)
    MARKP: ^INTEGER;          (*FOR MARKING HEAP*)
    TOS: ^LEXSTKREC;          (*TOP OF LEX STACK*)
    GLEV: DISPRANGE;          (*GLOBAL LEVEL OF DISPLAY*)
    NEWBLOCK: BOOLEAN;        (*INDICATES NEED TO PUSH LEX STACK*)

    NEXTSEG: SEGRANGE;        (*NEXT SEGMENT #*)
    SEGINX: INTEGER;          (*CURRENT INDEX IN SEGMENT*)
    SCONST: CSP;              (*INSYMBOL STRING RESULTS*)

    LOWTIME,LINEINFO,SCREENDOTS,STARTDOTS,SYMBLK{,SMALLESTSPACE}: INTEGER;
    smallestspace:longint; {/tp6}
    LINESTART:{ CURSRANGE;} integer; {/tp4}

    CURPROC,NEXTPROC: PROCRANGE;     (*PROCEDURE NUMBER ASSIGNMENT*)

    CONSTBEGSYS,SIMPTYPEBEGSYS,TYPEBEGSYS,
    BLOCKBEGSYS,SELECTSYS,FACBEGSYS,STATBEGSYS,TYPEDELS: SETOFSYS;
    VARS: SETOFIDS;

    DISPLAY: ARRAY [DISPRANGE] OF
                RECORD
                  FNAME: CTP;
                  CASE OCCUR: WHERE OF
                    BLCK: (FFILE: CTP; FLABEL: LABELP);
                    CREC: (CLEV: LEVRANGE; CDSPL: ADDRRANGE);
                    VREC: (VDSPL: ADDRRANGE)
                  END;

    PFNUMOF: NONRESPFLIST;

    PROCTABLE: ARRAY [PROCRANGE] OF INTEGER;

    SEGTABLE: ARRAY [SEGRANGE] OF
                RECORD
                  DISKADDR,CODELENG: INTEGER;
                  SEGNAME: ALPHA;
                  SEGKIND,
                  TEXTADDR: INTEGER
                END (*SEGTABLE*) ;

{    COMMENT: ^string[80];}
     comment: ^string80;     {patch /tp3}
    SYSTEMLIB: string80;
    NEXTJTAB: JTABRANGE;
    JTAB: ARRAY [JTABRANGE] OF INTEGER;

    REFFILE: FILE;
    NREFS,REFBLK: INTEGER;
    REFLIST: ^REFARRAY;
    OLDSYMBLK,PREVSYMBLK: INTEGER;

    OLDSYMCURSOR,
    OLDLINESTART,
    PREVSYMCURSOR,
    PREVLINESTART: {CURSRANGE;} integer; {/tp6}

    USEFILE: UNITFILE;
    INCLFILE,pLIBRARY: FILE;
    LP: TEXT;   {superceded by listfile}

    CURBYTE, CURBLK: INTEGER;
    DISKBUF: PACKED ARRAY [0..511] OF CHAR;

    SpitInterface : boolean;  {/pc157} {?getnextpage to call writetext}





{ vars for idtable }  {patch /tp3}
  tokenname : t_tokenname;
  tokentype : t_tokentype;
  optype    : t_optype;




Function TreeSearch(Var root,node:ctp;key:alpha):integer;



Function PwrOfTen(exponent:integer):Real;

Function Scan(Limit:integer;opcode:char;Ch:Char;Var source):Integer;

Function UCSDBlockread(var f:file;var buf;Blocks:integer{;RelBlock:integer}):
         integer;

Function UCSDBlockreadrel(var f:file;var buf;Blocks:integer;RelBlock:integer):
         integer;

Function PartialBlockreadrel(var f:file;var buf;len:integer;RelBlock:integer):
         integer;

Function UCSDBlockwrite(var f:file;var buf;Blocks:integer;RelBlock:integer)
         :integer;


Procedure Flipbufword;



PROCEDURE ERROR(ERRORNUM: INTEGER);




implementation

Procedure PrintError(ErrorNum:integer);
var f:text;
    e:string;
    found:boolean;
    crap:integer;
    x,num:integer;
Begin
  Assign(f,'SYNTAX.TXT');
  Reset(f);
  Found:=false;
  Repeat
    readln(f,e);
    x:=pos(':',e);
    System.Val(copy(e,1,x-1),num,crap);
    if num = Errornum then
      Begin
      Found:=true;
      Writeln(output,e);
      end;

  Until found or eof(f);

end;


  Function TreeSearch(Var root,node:ctp;key:alpha):integer;
  var last:ctp;
  Begin
    node:=root;
    Repeat
      last:=node;
      if(key<node^.name)then
        begin
        node:=node^.llink;treesearch:= -1;
        end
      else
      if(key>node^.name)then
        begin
        node:=node^.rlink;treesearch:=1;
        end
      else
        begin
        treesearch:=0;exit;
        end;
    until node=nil;
  node:=last;
  end;







  Function PwrOfTen(exponent:integer):Real;
  Begin
    PwrOfTen:=exp(exponent*ln(10));
  end;


  Function Scan(Limit:integer;opcode:char;Ch:Char;Var source):Integer;
  Label 999;
  Type Char_Array=Array[0..maxint]of char;
  Var a:Char_Array ABSOLUTE SOURCE;
    i:Integer;
    PosScan :Boolean;
  Begin
  PosScan:=Limit>0;
  i:=0;
  While I<>Limit do
    Begin
    Case opcode of
      '=':if a[i]=ch then goto 999;
      '#':if a[i]<>ch then goto 999;
    End;
    Case PosScan of
      True:i:=succ(i);
      False:i:=pred(i);
    End;
    end;
999: Scan:=i;
  End;




Function UCSDBlockread(var f:file;var buf;Blocks:integer{;RelBlock:integer}):
           integer;
Type TempBufType=PACKED ARRAY[0..1023]OF CHAR;
Var i:integer;
    SourceLine:String[255];
    TEMPBUF :TempBufType absolute buf;
    Result  :integer;

Begin
  (* THIS CODE WORKS AS A STRAIGHT UCSD BLOCKREAD*)

{  Seek(f,RelBlock);}
  {$I+}
  Blockread(f,TEMPbuf,blocks,Result);
  {$I-}
  UcsdBlockread:=Result;
{
  If Blocks<>Result then
    begin
    Writeln('UcsdBlockread Error');
    writeln('blocks requested =',blocks);
    Writeln('blocks read      =',result);
    end;
}

  Move(tempbuf,buf,blocks*512);

{FOR I:=0 TO SIZEOF(BUF) DO WRITE(TEMPBUF[I]);}



  End;




Function UCSDBlockreadrel(var f:file;var buf;Blocks:integer;RelBlock:integer):
integer;
Type TempBufType=PACKED ARRAY[0..1023]OF CHAR;
Var i:integer;
    SourceLine:String[255];


    TEMPBUF :TempBufType absolute buf;
    Result  :integer;

Begin
  (* THIS CODE WORKS AS A STRAIGHT UCSD BLOCKREAD*)


  Seek(f,RelBlock);
  {$I+}


  Blockread(f,buf,blocks,Result);
  {$I-}
  UcsdBlockreadrel:=Result;
{
  If Blocks<>Result then
    begin
    Writeln('UcsdBlockread Error');
    writeln('blocks requested =',blocks);
    Writeln('blocks read      =',result);
    end;
}

{  Move(tempbuf,buf,blocks*512);}

{  Move(buf,tempbuf,blocks*512);}
{  for i:=0 to 1023 do write(tempbuf[i]);}



{
FOR I:=0 TO SIZEOF(TEMPBUF)-1 DO
  BEGIN
  IF TEMPBUF[I] IN [CHR(13),CHR(10),' '..'~'] THEN
    WRITE(TEMPBUF[I]);
  END;
}


End;











Function PartialBlockreadrel(var f:file;var buf;len:integer;RelBlock:integer):
integer;
  Type TempBufType=PACKED ARRAY[0..1023]OF CHAR;
  Var
    TEMPBUF :TempBufType;
    Result  :integer;
  Begin
  (* THIS CODE WORKS AS A STRAIGHT UCSD BLOCKREAD*)


  Seek(f,RelBlock);
  {$I+}
  Blockread(f,tempbuf,1,Result);
  {$I-}
  partialBlockreadrel:=Result;
{
  If Result <> 1 then
    begin
    Writeln('UcsdBlockread Error');
    writeln('blocks requested =',blocks);
    Writeln('blocks read      =',result);
    end;
}


  Move(tempbuf,buf,len);  {partial read}

  End;



Function UCSDBlockwrite(var f:file;var buf;Blocks:integer;RelBlock:integer)
   :integer;
Var i:integer;
    Result  :integer;
Begin
  seek(f,relblock);
  BlockWrite(f,buf,blocks,Result);
  UcsdBlockwrite:=Result;
  If Blocks<>Result then
    begin
    Writeln('UcsdBlockwrite Error');
    writeln('blocks requested =',blocks);
    Writeln('blocks read      =',result);
    end;
(*
  If Blocks <> 1 then begin Writeln('Incompatible Blockwrite');Readln; end;
  Seek(f,RelBlock);
  Blockwrite(f,buf,1,i);
  UCSDBlockwrite := i;
*)
End;





Procedure Flipbufword;
{flips buffer word starting at codep^[ic]
 used to generate sex flipped code}
Var temp:char;
Begin
  writeln('flipbufword');
  temp := codep^[ic];
  codep^[ic] := codep^[ic+1];
  codep^[ic+1] := temp;
end;










PROCEDURE ERROR(*ERRORNUM: INTEGER*);
  VAR CH: CHAR; ERRSTART: INTEGER;
      A: PACKED ARRAY [0..179] OF CHAR;
      i:integer;    {/tp4}
BEGIN
  WITH USERINFO DO
    IF (ERRSYM <> SYMCURSOR) OR (ERRBLK <> SYMBLK) THEN
      BEGIN
      ERRBLK := SYMBLK;
      ERRSYM := SYMCURSOR;
      ERRNUM := ERRORNUM;
      IF STUPID THEN CH := 'E'
      ELSE
        BEGIN
        IF NOISY THEN WRITELN(OUTPUT)
        ELSE
        IF LIST AND (ERRORNUM <= 400) THEN
          EXIT;{(ERROR);}
        IF LINESTART = 0 THEN
          {WRITE(pOUTPUT,SYMBUFP^:SYMCURSOR)} {patch /tp3}
          for i:=linestart to symcursor do
            write(OUTPUT,symbufp^[i]) {/tp3}
        ELSE
          BEGIN
          (*
          ERRSTART := SCAN(-(LINESTART-1),'=',CHR(EOL),  {patch /tp3}
                                    SYMBUFP^[LINESTART-2])+LINESTART-1;

          MOVE{LEFT}(SYMBUFP^[ERRSTART],A[0],SYMCURSOR-ERRSTART);

          {WRITE(pOUTPUT,A:SYMCURSOR-ERRSTART)} {patch /tp3}
          for i:=0 to symcursor-errstart-1 do
            write(pOUTPUT,a[i]) {/tp3}
          *)
          END;
        (*
        WRITELN(pOUTPUT,' <<<<');
        *)
        WRITE(OUTPUT,'Line ',SCREENDOTS,', error ',ERRORNUM:0,':');
        PrintError(ErrorNum);   {/tp5}
        halt;
        IF NOISY THEN
          WRITE(OUTPUT,' <sp>(continue), <esc>(terminate), E(dit');
        WRITE(OUTPUT,CHR(7));
        REPEAT READ({KEYBOARD,}CH)
        UNTIL (CH = ' ') OR (CH = 'E') OR (CH = 'e') OR (CH = ALTMODE)
        END;
      IF (CH = 'E') OR (CH = 'e') THEN
        BEGIN
        ERRBLK := SYMBLK-2;  {it normally points 2 blocks ahead..see getnextpage}
        {EXIT(PASCALCOMPILER)}
        END;
      IF (ERRORNUM > 400) OR (CH = CHR(27)) THEN
        BEGIN
        ERRBLK := 0;
        EXIT;{(PASCALCOMPILER)}
        END;
      WRITELN(OUTPUT);
      IF NOISY THEN
        WRITE(OUTPUT,'<',SCREENDOTS:4,'>')
      END
END (*ERROR*) ;


end.
