{ (*$U-*) }
(* $C COPYRIGHT (C) 1978 REGENTS UCSD I.5.5*)
(* $T-,Q-*)        {not tiny}
(* $S- *)
(* $U+*) {as well as syscomp:=true sets --> $R-,I+,G+,LB Aug`86}
{$R-,I+,G+,V-}

{ for DOS VERSION use as much checking as possible:}
{$R-,I+,G+,V+}
PROGRAM PASCALCOMPILER(pinput,poutput);
(* VERSION I.5 (Unit Compiler)  9-01-78 *)

(************************************************)
(*                                              *)
(*        UCSD  PASCAL  COMPILER                *)
(*                                              *)
(*    BASED ON ZURICH P2 PORTABLE               *)
(*    COMPILER, EXTENSIVLY                      *)
(*    MODIFIED BY ROGER T. SUMNER               *)
(*    SHAWN FANNING AND ALBERT A. HOFFMAN       *)
(*    1976..1978                                *)
(*    RELEASE LEVEL: I.3 AUGUST,    1977        *)
(*                   I.4 JANUARY,   1978        *)
(*                   I.5 SEPTEMBER, 1978        *)
(*                                              *)
(************************************************)


(**************************************************************)
(*    Changes not in Public domain yet....                    *)
(*    Portions Copyright by Laurence L. Boshell 1986 and on.. *)
(*    Portions Copyright by Mark Fawcett  1986 and on..       *)
(*                                                            *)
(*    A lot of this code was a fast hack late at night        *)
(*    and on weekends, so please help me if you see           *)
(*    a simpler or more elegant way.                          *)
(*                                                            *)
(*    And as the linker states:                               *)
(*      "All hope abandon ye who enter here " -Dante          *)
(*    Laurie Boshell    laurie@pnc.com.au                     *)
(*    Martin Place LINDEN 2778 NSW Australia                  *)
(**************************************************************)
(* PC1.5.1 System stripped off to leave compiler              *)
(*         Change U- to R- I+ so compiler does itself         *)
(*         WORKSYM,WORKCODE: ^PHYLE  removed from INFOREC     *)
(*         All occurances of INTERFACESY changed to INTERFCESY*)
(*                           EXTERNALSY             EXTERNLSY *)
(*                           SEPARATESY             SEPARATSY *)
(*         OPENOLD/OPENNEW changed to Reset/Rewrite           *)
(*         Debugging added for error 253 2 sites,proc too long*)
(* PC1.5.2 Interlist mods from 1.3 ported to 1.5 thanks Mark. *)
(* PC1.5.3 Mods to compile under Apple I.2 as fake sys.comp   *)
(* PC1.5.4 Mods to compile under Apple I.2 as user program    *)
(* PC1.5.5 Byte sex added and                                 *)
(*         unused bytes cleared in seg. dict 7/9/87  LB       *)
(*         Bug introduced by Mark in GEN1 fixed: fp1+fp1,     *)
(*         not fp1+fp2   LB                                   *)
(* PC1.5.6 P_MACHINE added (procedure mcode)                  *)
(*         LDO instead of SLDO bug fixed  by stopping         *)
(*         backtracking 24/2/88                               *)
(*                                                            *)
(* PC157   Addr function added                                *)
(*         WriteText Re-worked to dump interface correctly    *)
(*                                                            *)
(*         Addr added modeled on sizeof... returns integer    *)
(*         Hex numbers added                                  *)
(*                                                            *)
(*         bumpcursor added if duple..missed in earlier vers  *)
(*                                                            *)
(*         Value of nil changed to 0 to match interp          *)
(*                                                            *)
(*                                                            *)
(*  157a   fwritedec becomes resident cxp 0 51                *)
(*  157a   freaddec  becomes resident cxp 0 50                *)
(*  157a   decops    becomes resident cxp 0 49                *)
(*                                                            *)
(*  157b   BUG FIX conditional call to close library added    *)
(*         in Procedure COMMENTER                             *)
(*                                                            *)
(*  157c   AND & OR & NOT  allowed with integers.... changes  *)
(*          in TERM and EXPRESSION  (in BODYPRTD)             *)
(*                                                            *)
(*  157d   xor shl shr added                                  *)
(*         UNIT INITIALIZATION                                *)
(*         The changes rely on the rule that the unit init    *)
(*         code becomes procedure number 1 in a unit.  When a *)
(*         unit is loaded, procedure 1 is called once only.   *)
(*         There were changes also to get text as the first   *)
(*         procedure the compiler sees then must be #2        *)
(*                                                            *)
(*  157e   Unit initializatn code added. Required changes to  *)
(*         Block ...   allow exit if[beginsy,endsy]           *)
(*               ....  Delay calls to Finishseg until later   *)
(*         Unitpart..  New procedure unitinit added           *)
(*                 ..  Subtle changes to way block called     *)
(*                 ..  Level:= 2 to stop lex level 0 in init  *)
(*         GetText ..  First proc is 2 not one                *)
(*         Body .....  Alter code generation for return from  *)
(*                     procedure such that the unit init code *)
(*                     is a RNP not RBP!                      *)
(*  157f   Absolute clause added.  Required changes to        *)
(*         idsearch in interp and same in dos compiler.  This *)
(*         change needs to be expanded, currently only allows *)
(*         absolute addr on another var..not yet a machine    *)
(*         addr.  Further, warns but does not flag as an error*)
(*         if more that one var in same absolute list e.g:    *)
(*         var i,j :integer ABSOLUTE x;  This should only     *)
(*         allow i or j but not both.  Fix later?             *)
(*                                                            *)
(*  157g   Typecast allowed in Expressions                    *)
(*         (not yet for read/write eg writeln(integer(c));)   *)
(*         Also cured an elusive bug...still not sure of the  *)
(*         circumstances, anyway the problem was that at      *)
(*         times the compiler fell over if you added comments *)
(*         that spanned a few lines and did only had braces   *)
(*         at the start and end lines.  The 2 SCAN ststements *)
(*         in CHECKEND were commented out.  ?A bug with my    *)
(*         scan or a subtle change in the way input is now    *)
(*         handled under DOS                                  *)
(*                                                            *)
(*         Error(9) added to call non special as compiler did *)
(*         not report correct error for chr[x]...the error    *)
(*         is error 9 not error 126                           *)
(*                                                            *)
(*  157g   Possible bug 26/9/92         While compiling the   *)
(*         Zurich P4 compiler, I noted that when assinging an *)
(*         array subscripted by ten (10) then compiler emited *)
(*         a zero (0)!!!.  Whilst chasing this bug I found    *)
(*         that the compiler finds an error if the labels are *)
(*         not present in ascending numerical order in the    *)
(*         source code. Changing declaratn order does nothing *)
(*         See the code in proc GEN1                          *)
(*                                                            *)
(*  157g   27/9/92.  Changes to sizeof to allow sizeof(p^)    *)
(*         where p is a pointer to a structure                *)
(*                                                            *)
(*  157g   28/9/92.  Changes to decpart to allow any order of *)
(*         declaration for label/const/type/var               *)
(*                                                            *)
(*                                                            *)
(*                                                            *)
(*                                                            *)
(*         PAtches to Read/Write to allow read structure      *)
(*         instead of get/put for turbo compatibility         *)
(*                                                            *)
(*                                                            *)
(*  157g   14/1/93 Bug in pred/succ ......allowed real as the *)
(*         argument when the scalar integer only is allowed   *)
(*                                                            *)
(*  157g   17/1/93 Bug in sets (bug13) sets constructed out   *)
(*         of range got thru the compiler eg [-1..5000]..fixed*)
(*                                                            *)
(*  157g   20/1/93 Bug in sets (bug14) sets assigned    out   *)
(*         of range got thru the compiler eg [-1..5000]..fixed*)
(*                                                            *)
(*                                                            *)
(*  157g   23/1/93 Bug 15 An elusive bug that only affected   *)
(*         numbers such as the integer that was an array index*)
(*         Problem was that bumpcursor was being called from  *)
(*         procedure number and shuffling the buffer if next  *)
(*         page was loaded.  This causes the text to be moved *)
(*         left by 1024 places and the symcursor to be dec by *)
(*         1024.  As procedure Number was keeping two integers*)
(*         pointing to the start and end of the integer in the*)
(*         text (IPART,ENDI) these were then out by +1024.    *)
(*         Fix...                                             *)
(*         Don't call bumpcursor NUMBER, rather allow  direct *)
(*         inc of sumcursor.  This bug explains many earlier  *)
(*         unstable conditions in the compiler after I added  *)
(*         new code and found unrelated problems occuring.    *)
(*         Fixes 'possible bug' of 26/9/92 above              *)
(*                                                            *)
(*  157g   1/2/93  DISPOSE added now CSP 51                   *)
(*         Still needs an intelligent heap manager            *)
(*                                                            *)
(*  157g   2/2/93  GETMEM & FREEMEM added CSP 52, CSP 53      *)
(*         Still needs an intelligent heap manager            *)
(*                                                            *)
(*  157g   5/2/93  TRUE = $FFFF ie not false on pcode ver ONLY*)
(*                                                            *)
(*  157g   15/1/95 SEARCHID now prints ID on screen if error  *)
(*         104 encountered (undeclared identifier)            *)
(*                                                            *)
(*  157g   15/1/95 Changes for Continue/Break in a for,       *)
(*         while or repeat loop.                              *)
(*         a. ENTSPCPROCS has 'BREAK   ' and 'CONTINUE' added *)
(*         b. Tconbrkptr type and variable added to           *)
(*            procedure BODYPART  (bodyprta.inc)              *)
(*         c. Procedure ConTBrkSTMT added just before ROUTINE *)
(*            in bodyprtb.inc                                 *)
(*         d. cases 51 and 52 added to the ROUTINE case stmt  *)
(*         e. 51 and 52 added to if statement in proc 'call'  *)
(*         f. Repeat/WHILE/FOR statement handlers altered     *)
(*            for addition of labels for break and continue   *)
(*         g. ConbrkPtr set to nil in main part of proc 'body'*)
(*            GRTI->GTRI 26/12/96 LB                          *)
(*                                                            *)
(*                                                            *)
(*                                                            *)
(*                                                            *)
(*                                                            *)
(*                                                            *)
(*                                                            *)
(*                                                            *)
(*                                                            *)
(**************************************************************)
(**************************************************************)

        (*----- IBM PCDOS PORT EASTER 1991 -----*)

(**************************************************************)
(*  Version for DOS derived from my p-system version PC156    *)
(*  All patches begin with /tp                                *)
(*  /tp3:-patches required to run under dos..no other changes *)
(*        assumes NIL = 1 see writelinker info -> range:=nil  *)
(*       -fixed the exit(insymbol) from proc commenter shit.  *)
(*        This wasted a LOT of time. Crappy orig code         *)
(*       -cleaned up spaces from include file name for dos    *)
(*       -include files now work correctly (no nesting)       *)
(*       -error now shows offending source just like original *)
(*       -changed POINTER to POINTERs to avoid turbo conflict *)
(*       -fixed INSYMBOL to skip chr(9) as well as chr(32)    *)
(*       -made WRITELINKERINFO a unit-allows room for $R+     *)
(*       -fixed PRINTLINE as turbo will not write a packed    *)
(*         array of char -UCSD writes it till first CHR(13)   *)
(*       -fixed pascal IDSEARCH to ignore '_' just like UCSD  *)
(*       -tag field list for NEW(p[,tag[,tag]]) commented out *)
(*         to allow compile using turbo                       *)
(*       -5/4/91 compiler now compiles itself correctly-BINGO!*)
(*         but... only using unchanged ucsd format text files *)
(*                                                            *)
(*  /tp4:-start at block 0 (not 2) of textfiles for dos       *)
(*         changes made in initscalars and insymbol include   *)
(*       -symbufp changed to array[0..2047] of char           *)
(*       -symcursor now starts a 1024 and the buffers are     *)
(*         shuffled around when symcursor > 2047-80           *)
(*       -currently only works correctly for dos text files   *)
(*       -error 132 changed to 131 in BODYPTRD.inc (sets>,<)  *)
(*                                                            *)
(*  /tp5 -this version was the first departure from pure UCSD *)
(*       the main issue was the generation of non resident    *)
(*       linker info for read/write reals                     *)
(*       so... extra cxp added                                *)
(*       fFREADREAL  becomes resident  cxp 0 14               *)
(*       fFWRITEREAL becomes resident  cxp 0 15               *)
(*       - removed automatic insertion of BPT for LEVEL 1     *)
(*       even when debugging false.  Why did they do this?    *)
(*       patch out line 529 in BODYPRTE.INC                   *)
(*       - MAXCODE changed from 1299 to 2999 {?too much}      *)
(*       - GOTOOK := true in compinit goto allowed as default *)
(*       - EXIT patched to allow no param in BODYPRTB.INC     *)
(*              23 (EXIT)  check added in proc CALL (BODYPRTC)*)
(*       -LNOT/BNOT problem solved in interp (see FJP)        *)
(*       -Mini-debugger written and working in 90 minutes!    *)
(*       -seak changed to fseak                               *)
(*        fseak becomes resident cxp 0 9                      *)
(*        see bodyprtB line 330                               *)
(*                                                            *)
(*                                                            *)
(*  /tp5.1                                                    *)
(*       the generation of a real number was changed to be    *)
(*       the IEEE format for 4 byte reals. Incredibly, the    *)
(*       only change needed was in the globals section where  *)
(*       the reserved word real was changed to single to be   *)
(*       compatible with turbo and quick pascal.              *)
(*       FORMAT OF IEEE 4 BYTE REAL:                          *)
(*        bit 31 30...23    22...0                            *)
(*           ---------------------------                      *)
(*           |s|   e     |     f       |                      *)
(*           ---------------------------                      *)
(*            s = sign                                        *)
(*            e = exponent offset by +127                     *)
(*            f = fractional part of the mantissa             *)
(*            the 1 in the mantissa is implied ie NOT recorded*)
(*                                                            *)
(*  /tp6                                                      *)
(*       -LONGINT altered to LONGINTs to avoid turbo conflict *)
(*       -IDSEARCH optomised to be a binary chop search       *)
(*                                                            *)
(*                                                            *)
(*                                                            *)
(**************************************************************)

uses dos,    {for gettime only}
     globals,
     procs,
     cmpinit,
     wrtlinkr;
(*--------------------------------------------------------------------*)


(* FORWARD DECLARED PROCEDURES NEEDED BY COMPINIT *)


(* FORWARD DECLARED PROCEDURES USED IN BOTH DECLARATIONPART AND BODYPART *)

PROCEDURE BLOCK(FSYS: SETOFSYS);
  FORWARD;
  
(* ------ turbo patches --------------*)


procedure time(var i:integer;var j:integer);
var a,b,c,d:word;
Begin
  getTime(a,b,c,d);
  i:=b; j:=c;
end;





(* ---- THESE ARE SEGMENT PROCEDURES L.B.1/4/91 --- *)


(*$I DECLARAT.INC*)

(*$I BODYPRTA.INC*)

(*$I BODYPRTB.INC*)

(*$I BODYPRTC.INC*)

(*$I BODYPRTD.INC*)

(*$I BODYPRTE.INC*)

(*   I WRTLINKR.INC     *)  { ----> now unit wrtlinkr {/tp3}

(*$I UNITPART.INC*)













const zzz:string='Portions (c) L.Boshell 1983 thru 1992';


{ (*$I BLOCK.TEXT*) }

PROCEDURE BLOCK(*FSYS: SETOFSYS*);
LABEL 1;
VAR BFSYFOUND: BOOLEAN;
    EndOfProgram: BOOLEAN;     {/pc157e}

  PROCEDURE FINDFORW(FCP: CTP);
    BEGIN
    IF FCP <> pNIL THEN
      WITH FCP^ DO
      BEGIN
      IF KLASS IN [PROC,FUNC] THEN
        IF PFDECKIND = DECLARED THEN
          IF PFKIND = ACTUAL THEN
            IF FORWDECL THEN
              BEGIN
              USERINFO.ERRNUM := 117; WRITELN{(OUTPUT)};
              WRITE({OUTPUT,}NAME,' undefined')
              END;
      FINDFORW(RLINK); FINDFORW(LLINK)
      END
    END (*FINDFORW*) ;

  BEGIN (*BLOCK*)
    EndOfProgram := False;   {/pc157e}
    IF (NOSWAP) AND (STARTINGUP) THEN
      BEGIN
      BODYPART(FSYS,pNIL);
      EXIT;{(BLOCK);}
      END;
    IF (SY IN [UNITSY,SEPARATSY]) AND (NOT INMODULE) THEN
      BEGIN
      UNITPART(FSYS + [UNITSY,INTERFCESY,IMPLESY,ENDSY]);
      IF SY = PERIOD THEN
        EXIT;{(BLOCK)}
      END;
    NEWBLOCK:=TRUE;
    REPEAT
      IF NOT NEWBLOCK THEN
      BEGIN
      DP := FALSE;
      STMTLEV := 0;
      IC := 0;
      LINEINFO := 0;
      IF (NOT SYSCOMP) OR (LEVEL>1) THEN
        FINDFORW(DISPLAY[TOP].FNAME);
      IF INMODULE THEN
        IF TOS^.PREVLEXSTACKP^.DFPROCP = OUTERBLOCK THEN

	      (* IF (SY = ENDSY) THEN              out in /pc157e
		 BEGIN FINISHSEG; EXIT(BLOCK) END
	       ELSE IF (SY = BEGINSY) THEN
		 BEGIN ERROR(13); FINISHSEG; EXIT(BLOCK) END;
              *)

                If sy in[beginsy,endsy] then exit{block}; {/pc157e}



          IF SY = BEGINSY THEN INSYMBOL ELSE ERROR(17);
          REPEAT
            BODYPART(FSYS + [CASESY] - [ENDSY], TOS^.DFPROCP);
            BFSYFOUND := (SY = TOS^.BFSY) OR (INMODULE AND (SY = ENDSY));
            IF NOT BFSYFOUND THEN
              BEGIN
              IF TOS^.BFSY = SEMICOLON THEN
                ERROR(14)  (*SEMICOLON EXPECTED*)
              ELSE
                ERROR(6);  (* PERIOD EXPECTED *)
              SKIP(FSYS + [TOS^.BFSY]);
              BFSYFOUND := (SY = TOS^.BFSY) OR (INMODULE AND (SY = ENDSY))
              END
          UNTIL (BFSYFOUND) OR (SY IN BLOCKBEGSYS);
          IF NOT BFSYFOUND THEN
            BEGIN
            IF TOS^.BFSY = SEMICOLON THEN
              ERROR(14)
            ELSE
              ERROR(6); (*PERIOD EXPECTED*)
            DECLARATIONPART(FSYS);
            END
          ELSE
            BEGIN
            IF SY = SEMICOLON THEN INSYMBOL;
            IF (NOT(SY IN [BEGINSY,PROCSY,FUNCSY,PROGSY])) AND
                  (TOS^.BFSY = SEMICOLON) THEN
              IF NOT (INMODULE AND (SY = ENDSY)) THEN
                BEGIN
                ERROR(6);
                SKIP(FSYS);
                DECLARATIONPART(FSYS);
                END
              ELSE
                GOTO 1
            ELSE
         1:   BEGIN
              WITH TOS^ DO
                BEGIN
                IF DFPROCP <> pNIL THEN
                DFPROCP^.INSCOPE:=FALSE;
                IF ISSEGMENT THEN
                  BEGIN
                  IF CODEINSEG THEN FINISHSEG;

                           (*                              out in /pc157e
			   IF DLINKERINFO AND (LEVEL = 1) THEN
			     BEGIN SEGTABLE[SEG].SEGKIND := 2;
			       WRITELINKERINFO(TRUE)
			     END
			   ELSE
			     IF CLINKERINFO THEN
			       BEGIN SEGTABLE[SEG].SEGKIND := 2;
				 WRITELINKERINFO(FALSE)
			       END;
                           *)

                  NEXTPROC:=SOLDPROC;
                  SEG:=DOLDSEG;
                  END;
                LEVEL:=DOLDLEV;
                TOP:=DOLDTOP;
                LC:=DLLC;
                CURPROC:=POLDPROC;
                END;

              if tos^.prevlexstackp <> nil then       {/pc157e}
                   begin
		   RELEASE(TOS^.DMARKP);
                   {TOS:=TOS^.PREVLEXSTACKP; }
                   move(tos^.prevlexstackp,tos,sizeof(tos));   {patch /tp3}
		   NEWBLOCK:=(SY IN [PROCSY,FUNCSY,PROGSY]);
                   end
                   else EndOfProgram := true;             {/pc157e}

              END
            END
          END
      ELSE
        BEGIN
        DECLARATIONPART(FSYS);
        IF LEVEL = 0 THEN
          IF SY IN [UNITSY,SEPARATSY] THEN
            BEGIN
            UNITPART(FSYS + [UNITSY,INTERFCESY,IMPLESY,ENDSY]);
            IF SY IN [PROCSY,FUNCSY,PROGSY] THEN
              DECLARATIONPART(FSYS)
            END
        END;
    UNTIL {TOS = pNIL} EndOfProgram;      {/pc157e}
    FINISHSEG;
  END (*BLOCK*) ;


{seg proc declaration moved to here for apple }
{IV.2.1 gets error 313 with segment}
{apple  gets error 399 with segment}
{  PROCEDURE PASCALCOMPILER(*VAR USERINFO: INFOREC*);}


var
  sm,ss,em,es : integer;   {patch /tp3}


BEGIN (* PASCALCOMPILER *)
  COMPINIT;
  {TIME(LGTH,LOWTIME);}                  {patch /tp3}
  time(sm,ss);
  BLOCK(BLOCKBEGSYS+STATBEGSYS-[CASESY]);
  IF SY <> PERIOD THEN ERROR(21);
  IF LIST THEN
    BEGIN SCREENDOTS := SCREENDOTS+1;
      SYMBUFP^[SYMCURSOR] := CHR(EOL);
      {SYMCURSOR := SYMCURSOR+1;}
      bumpcursor(1);
      PRINTLINE
    END;
  USERINFO.ERRBLK := 0;
  {TIME(LGTH,STARTDOTS);}                 {patch /tp3}
  {LOWTIME := STARTDOTS-LOWTIME;}
  time(em,es);
  {UNITWRITE(3,IC,7);}      {patch /tp3}
  IF DLINKERINFO OR CLINKERINFO THEN
    BEGIN
    SEGTABLE[SEG].SEGKIND := 1;
    WRITELINKERINFO(TRUE)
    END;

  {was close(LP,lock) ..... CLOSE(listfile,LOCK); }

  IF NOISY THEN WRITELN{(OUTPUT)};
  WRITE({OUTPUT,}SCREENDOTS,' lines');

  (* IF LOWTIME > 0 THEN
    WRITE({OUTPUT,}', ',(LOWTIME+30) DIV 60,' secs, ',
       ROUND((3600/LOWTIME)*SCREENDOTS),' lines/min'); *) {patch /tp3}
  {patch /tp3}
  em:=em-sm;
  es:=es-ss;
  if es < 0 then  {fix up minute wrap around...ignores hour wrap around}
    begin
    dec(em);
    es := -es;
    end;
  es := es + em*60;  {total seconds}
  if es=0 then es:=1;   {catch divide by 0 error}
  write({OUTPUT,}', ',es,' secs, ',(screendots div es) * 60,' lines/min');




  IF NOISY THEN
    BEGIN
    WRITELN{(OUTPUT)};
    WRITE({OUTPUT,}'Smallest available space = ',SMALLESTSPACE,' words');
    END;
  If Interlist and list_open then
    Begin
    Writeln;
    Writeln(listfile,'Generating code file Dictionary');
    End;
  IC := 0;
  {clear all unused bytes of segment dictionary}
  fillchar(codep^[0],sizeof(codep^),chr(0));       {LB} {/tp4}
  FOR SEG := 0 TO MAXSEG DO
    WITH SEGTABLE[SEG] DO
      BEGIN GENWORD(DISKADDR); GENWORD(CODELENG) END;
  FOR SEG := 0 TO MAXSEG DO
    WITH SEGTABLE[SEG] DO
      FOR LGTH := 1 TO 8 DO
        GENBYTE(ORD(SEGNAME[LGTH]));
  FOR SEG := 0 TO MAXSEG DO GENWORD(SEGTABLE[SEG].SEGKIND);
  FOR SEG := 0 TO MAXSEG DO GENWORD(SEGTABLE[SEG].TEXTADDR);
  FOR LGTH := 1 TO 80 DO
  {the comment field for I.5 clashes with Segrecs, Libsegs and LibInfo
   of later versions. So as a temp fix, just disable the comment entry.
   Later I will have to add the correct fields. I have commented out
   the relevent fields.  LB}

    {IF COMMENT <> pNIL THEN GENBYTE(ORD(COMMENT^[LGTH])) ELSE} GENBYTE(0);
  FOR LGTH := 1 TO 256 - 8*(MAXSEG + 1) - 40 DO GENWORD(0);
  CURBLK := 0; CURBYTE := 0; WRITECODE(TRUE);
  Close(Wurkcode {,Lock});
  If list_open then
    begin
    Close(listfile{,lock});
    If ioresult <> 0 then error(404);
    end;
END. (* PASCALCOMPILER *)

