{ M 16384,0,655360}
{$N+} {for turbo real single}
{bug 15 23/1/93. An elusive bug that only affected numbers such as the
 integer that was an array index.  Problem was that bumpcursor was being
 called from procedure number and shuffling the buffer if the next page
 was loaded.  This causes the text to be moved left by 1024 places and the
 symcursor to be decreased by 1024.  Unfortunately the number procedure
 was keeping two integer values that pointed to the start and end of the
 integer in the text (IPART,ENDI) and these were out by +1024. Fix...
 do not allow bumpcursor to be called from Procedure number, rather allow
 direct increment of sumcursor.  This bug explains many earlier unstable
 conditions in the compiler after I added new code and found unrelated
 problems occuring}

unit procs;     (* for I.5 dos cross-compiler*)
interface
uses globals;


Procedure BumpCursor(i:integer);   {/tp4}

Procedure IDSEARCH(*var SYMCURSOR:cursrange{largecur};var SYMBUFP*); (* MAGIC PROC *)


PROCEDURE GETNEXTPAGE;
PROCEDURE PRINTLINE;
PROCEDURE ENTERID(FCP: CTP);
PROCEDURE INSYMBOL;


PROCEDURE SEARCHSECTION(FCP:CTP; VAR FCP1: CTP);
PROCEDURE SEARCHID(FIDCLS: SETOFIDS; VAR FCP: CTP);
PROCEDURE GETBOUNDS(FSP: STP; VAR FMIN,FMAX: INTEGER);
PROCEDURE SKIP(FSYS: SETOFSYS);
FUNCTION  PAOFCHAR(FSP: STP): BOOLEAN;
FUNCTION  STRGTYPE(FSP: STP): BOOLEAN;
FUNCTION  DECSIZE(I: INTEGER): INTEGER;
PROCEDURE CONSTANT(FSYS: SETOFSYS; VAR FSP: STP; VAR FVALU: VALU);
FUNCTION  COMPTYPES(FSP1,FSP2: STP): BOOLEAN;
PROCEDURE GENBYTE(FBYTE: INTEGER);
PROCEDURE GENWORD(FWORD: INTEGER);
PROCEDURE WRITETEXT(start:integer);   {/pc157}
PROCEDURE WRITECODE(FORCEBUF: BOOLEAN);
PROCEDURE FINISHSEG;
{
PROCEDURE BLOCK(FSYS: SETOFSYS);
}




implementation



Procedure BumpCursor(i:integer);   {/tp4}
{replaces symcursor:=symcursor+i and checks for new page}
Begin
  inc(Symcursor,i);
  If symcursor > 2047-80 then
    getnextpage;  {shuffles buffers, decrements symcursor & linestart}
end;




{  alpha  = packed array[1..8] of char;
  univ    = packed array [0..1023] of char;

var
  key: alpha;
  BUF:univ;
  INX:INTEGER;
  SY : SYMBOL;
  OP : OPERATOR;
  ID : ALPHA;

}
  Procedure IDSEARCH(*var SYMCURSOR:cursrange{largecur};var SYMBUFP*); (* MAGIC PROC *)
  var key :alpha;
    i:integer;

    Procedure IDS;
      {See An introduction to Data Structures pg 154}
    Var found:boolean;low,hi,mid,bisection:integer;
    Begin

(*  bisection......bug with different # params for memavail when compiling
    compiler

    found := false;
    low :=0; hi := idnum{1};mid:=(low+hi) div 2;
    While (low <> mid) and (key <> tokenname[mid]) do
      begin
      if key < tokenname[mid] then
        hi:=mid
      else
        low:=mid;
      mid :=(low+hi) div 2;
      end;
    if key <> tokenname[mid] then
      bisection := mid+1
    else
      begin
      bisection :=mid; found:=true;
      end;

  If found
    then Begin
         sy := tokentype[bisection]; op := optype[bisection];
         id := tokenname[bisection];
         end
    else
         Begin
         sy := IDENT; op := NOOP; id := key;
         end;
   {WRITELN('ID = ',ID);}

  end;
*)


    i:=0;found:=false;
    while(not found)and(i<=idnum)do
      begin
      if key=tokenname[i]then found:=true
      else i:=i+1;
      end;
    If found then
      Begin
      sy:=tokentype[i];op:=optype[i];id:=tokenname[i];
      end
    else
      Begin
      sy:=IDENT;op:=NOOP;id:=key;
      end;
    {WRITELN('ID = ',ID);}

    end;





  var buf :packed array[0..1023]of char;  {added for patch /tp3}
      c:char;

  Begin
    i:=1;
    key:='        ';
    {build the key} {slow....but it works}
    c:= symbufp^[symcursor];
    while (c in['A'..'Z','a'..'z','0'..'9','_'])do
      begin
      If c <> '_' then   {ignore '_' for full UCSD compatibility   /tp3}
        begin
        if(i<9)then
          key[i]:=upcase(c);
        i:=i+1;
        end;
        {warning...do not call bumpcursor here...as it will shuffle
        the buffers around if it issues a call to get next page
        It is safe to manually increment symcursor as there will be
        no identifiers longer than 80 chars...or there should not be.
        This is a potential bug if identifiers are >80
        The next call to bumpcursor will cause a call to getnext page
        if symcursor >=2047-80}

        symcursor:=symcursor+1; {do not use   bumpcursor(1);} {/tp4}

      c:= symbufp^[symcursor];
      end;
    {ucsd requires that symcursor points to last char of identifier}
    symcursor:=symcursor-1;

(*
  if buf[symcursor] <> ' ' then
    repeat
      inc(symcursor)
    until buf[symcursor] = ' ';
    dec(symcursor);
*)

  IDS;
  end;                       {IDSEARCH}







{ (*$I PROCS.A.TEXT*) }








PROCEDURE GETNEXTPAGE;
var savecursor,savelinestart : integer;
BEGIN
  savecursor := Symcursor; SaveLinestart := Linestart;
  SYMCURSOR := 0; LINESTART := 0;
  IF USING THEN
    BEGIN
    IF USEFILE = WORKCODE THEN
      BEGIN
      IF ucsdBLOCKREADrel({USERINFO.WORKCODE^}wurkcode,symbufp^[1024],2,SYMBLK)
        <> 2 THEN USING := FALSE;
      END
    ELSE
      IF USEFILE = SYSLIBRARY THEN
        begin
        move(symbufp^[1024],symbufp^[0],1024);
        IF ucsdBLOCKREADrel(pLIBRARY,SYMBUFP^[1024],2,SYMBLK) = 2 then
          begin
          symcursor := savecursor-1024;
          linestart:=  savelinestart - 1024;
          end
        else
          USING := FALSE;
        end;
      IF NOT USING THEN
	BEGIN    {restore the state before using started}
(*
	SYMBLK := PREVSYMBLK;
        SYMCURSOR := PREVSYMCURSOR;
	LINESTART := PREVLINESTART
*)
        symblk := prevsymblk;            {/tp6}
        savecursor := prevsymcursor;
        savelinestart := prevlinestart;


	END
    END;
  IF NOT USING THEN
    BEGIN
      IF INCLUDING THEN
	IF ucsdBLOCKREADrel(INCLFILE,SYMBUFP^[1024],2,SYMBLK) <> 2 THEN
	  BEGIN   {restore the state before including started}
          CLOSE(INCLFILE);
          INCLUDING := FALSE;
	  SYMBLK := OLDSYMBLK;
          SYMCURSOR := OLDSYMCURSOR;
	  LINESTART := OLDLINESTART
	  END
    END;
  IF NOT (INCLUDING OR USING) THEN
    begin
    {fix the other shuffles up as well}
    {for now do straight text....no includes or usings}

    move(symbufp^[1024],symbufp^[0],1024);
    IF ucsdBLOCKREADrel({USERINFO.WORKSYM^} worksym ,
                        SYMBUFP^[1024],2,SYMBLK) <> 2 THEN
      Begin
      {for time being do nothing}
      {ERROR(401);}  {at end of textfile}  {fix this...}
      end;
    symcursor := savecursor-1024;
    linestart:=  savelinestart - 1024;
    end;

  { Handle leading dle's. All others are handled in checkend }
  {IF SYMCURSOR = 0 THEN}
  If spitInterface then  {/pc157 addition}
    If (symcursor>=944) and (symcursor<=1024) {[1024-80..1024]}
     then   {/pc157}
      BEGIN
      IF INMODULE THEN
        IF ININTERFACE AND NOT USING THEN {WRITETEXT}
          begin
          (* writeln('CALLING WRITETEXT FROM GETNEXTPAGE'); *)
          writetext(1024);  {/pc157}
          end;
      IF SYMBUFP^[0] = CHR(16(*DLE*)) THEN
       SYMCURSOR := 2
      END;

  SYMBLK := SYMBLK+2    {ok..point at next blocks to read}
END (*GETNEXTPAGE*) ;





{Printline indicates whether a line is code or declaration
 by a 'D' for declaration, and 0..9 for lexical level of of code.
 An '*' instead of ':' means a breakpoint associated with that line.
 It also prints the sorce code line to the list file}

(*$I+*)
PROCEDURE PRINTLINE;
VAR
  DORLEV,STARORC: CHAR;
  LENG: INTEGER;
  A: PACKED ARRAY [0..99] OF CHAR;   {ucsd allows write/ln of A}
  i:integer;   {/tp3}
BEGIN
  If not List_open then
    begin
      assign(listfile,'LISTING.TXT');
      rewrite(listfile);
      List_open := true;
    end;
  STARORC := ':';
  IF DP THEN
    DORLEV := 'D'
  ELSE
    DORLEV := CHR((BEGSTMTLEV MOD 10) + ORD('0'));
  IF BPTONLINE THEN STARORC := '*';
  WRITE(listfile,SCREENDOTS:6,SEG:4,CURPROC:5,
        STARORC,DORLEV,LINEINFO:6,' ');
  LENG := SYMCURSOR-LINESTART;
  IF LENG > 100 THEN LENG := 100;
  MOVE{LEFT}(SYMBUFP^[LINESTART],A,LENG);
  IF A[0] = CHR(16(*DLE*)) THEN
    BEGIN
    IF A[1] > ' ' THEN
      WRITE(listfile,' ':ORD(A[1])-ORD(' '));   {pad with spaces}
      LENG := LENG-2;
      MOVE{LEFT}(A[2],A,LENG)
    END;
  A[LENG-1] := CHR(EOL); (*JUST TO MAKE SURE*)   {wack eol at end of struct}

  {as dos ends a line with CR and LF as well...get rid of LF otherwise
  it turns up here at start of A}

  If A[0] = chr(10) (*LF*) then
    begin
    move(a[1],a[0],leng);   {/tp4}
    dec(leng);  {and dec length}
    end;

  {WRITE(listfile,A:LENG);} {turbo treats this as write all structure a!}
  {turbo patch}
  for i:= 0 to leng-1 do write(listfile,a[i]);    {/tp3}
  {the eol at end of struct results in a writeln to file}

  WITH USERINFO DO
    IF (ERRBLK = SYMBLK) AND (ERRSYM > LINESTART) THEN
      WRITELN(listfile,'>>>>>> Error # ',ERRNUM)
END (*PRINTLINE*) ;
(*$I-*)

PROCEDURE ENTERID(*FCP: CTP*);
  VAR LCP,LCP1: CTP; I: INTEGER;
BEGIN
{ writeln('Enterid---> ',fcp^.name);}   {FOR DEBUGGING L.B.}
  LCP := DISPLAY[TOP].FNAME;
  IF LCP = pNIL THEN DISPLAY[TOP].FNAME := FCP
  ELSE
    BEGIN I := TREESEARCH(LCP,LCP1,FCP^.NAME);
      WHILE I = 0 DO
	BEGIN ERROR(101);       {Identifier declared twice }
	  IF LCP1^.RLINK = pNIL THEN I := 1
	  ELSE I := TREESEARCH(LCP1^.RLINK,LCP1,FCP^.NAME)
	END;
      IF I = 1 THEN LCP1^.RLINK := FCP ELSE LCP1^.LLINK := FCP
    END;
  FCP^.LLINK := pNIL; FCP^.RLINK := pNIL
END (*ENTERID*) ;

{ Classify the next symbol into Sy,Op,Id. }
PROCEDURE INSYMBOL; (* COMPILER VERSION 3.4 06-NOV-76 *)
LABEL 1;
VAR LVP: CSP; X: INTEGER;
    ExitInsymbol : Boolean; {/tp3}

    tempc : char ; {/tp4}

{Check for end of page }
PROCEDURE CHECKEND;
BEGIN (* CHECKS FOR THE END OF THE PAGE *)
  SCREENDOTS := SCREENDOTS+1;
  {SYMCURSOR := SYMCURSOR + 1;}
  bumpcursor(1); {/tp4}
  IF NOISY and not interlist THEN
    BEGIN WRITE(OUTPUT,'.');
      IF (SCREENDOTS-STARTDOTS) MOD 50 = 0 THEN
	BEGIN WRITELN(OUTPUT);
	  WRITE(OUTPUT,'<',SCREENDOTS:4,'>')
	END
    END;
  IF LIST THEN PRINTLINE;
  BPTONLINE := FALSE;
  IF SYMBUFP^[SYMCURSOR]=CHR(0) THEN GETNEXTPAGE
  ELSE LINESTART := SYMCURSOR;
  IF SYMBUFP^[SYMCURSOR] = CHR(12(*FF*)) THEN
    {SYMCURSOR:=SYMCURSOR+1;}
    bumpcursor(1); {/tp4}

  {skip LF for dos text files....put it here or in insymbol???}
  if symbufp^[symcursor] = chr(10(*LF*)) then
    bumpcursor(1);            {/tp4}
  IF SYMBUFP^[SYMCURSOR] = CHR(16(*DLE*)) THEN
    {SYMCURSOR := SYMCURSOR+2}
    bumpcursor(2) {/tp4}

  ELSE
    BEGIN                         {PATCH /TP3}

(*    SYMCURSOR := SYMCURSOR+SCAN(80,'#',CHR(9),SYMBUFP^[SYMCURSOR]); *){157g}
(*    SYMCURSOR := SYMCURSOR+SCAN(80,'#',' ',SYMBUFP^[SYMCURSOR])     *)

    END;
  IF DP THEN LINEINFO := LC ELSE LINEINFO := IC
END;    {Checkend}

{Process everything inside a comment }
PROCEDURE COMMENTER(STOPPER: CHAR);
  VAR CH,SW,DEL: CHAR; LTITLE: STRING[40];
{$v-}    {PATCH /TP3}
  PROCEDURE SCANSTRING(VAR STRG: STRING80; MAXLENG: INTEGER);
    VAR LENG: INTEGER;
  BEGIN
    {SYMCURSOR := SYMCURSOR+2;}
    bumpcursor(2); {/tp4}

		    {patch /tp3}
    LENG := SCAN(MAXLENG,'=',STOPPER,SYMBUFP^[SYMCURSOR]);
    STRG[0] := CHR(LENG);
    MOVE{LEFT}(SYMBUFP^[SYMCURSOR],STRG[1],LENG);
	{here is a bug....spaces in include file are not removed!!!}
    {/tp3...remove them}
    while strg[1] = ' ' do delete(strg,1,1);
    while strg[length(strg)] = ' ' do delete(strg,length(strg),1);

    {SYMCURSOR := SYMCURSOR+LENG+1}
    bumpcursor(leng+1);  {/tp4}
  END (*SCANSTRING*) ;

BEGIN
  {SYMCURSOR := SYMCURSOR+1}; (* POINT TO THE FIRST CH PAST "(*" *)
  bumpcursor(1); {/tp4}

  IF SYMBUFP^[SYMCURSOR]='$' THEN
     IF SYMBUFP^[SYMCURSOR+1] <> STOPPER THEN
	REPEAT
	  CH := SYMBUFP^[SYMCURSOR+1];
	  SW := SYMBUFP^[SYMCURSOR+2];
	  DEL := SYMBUFP^[SYMCURSOR+3];
	  IF (SW = ',') OR (SW = STOPPER) THEN
	    BEGIN DEL := SW; SW := '+';
	      SYMCURSOR := SYMCURSOR-1
	    END;
          ch:=upcase(ch); {/tp6}
	  CASE CH OF
	  'C': BEGIN
	       IF LEVEL > 1 THEN ERROR(194);
	       NEW(COMMENT);
	       SCANSTRING(COMMENT^,80);
	       EXIT;{(COMMENTER)}             {TROUBLE}
	       END;
	  'D': DEBUGGING := (SW='+');
	  'G': GOTOOK := (SW='+');
	  'I': IF (SW='+') OR (SW='-') THEN IOCHECK := (SW='+')
	       ELSE
		 BEGIN SCANSTRING(LTITLE,40);
		 IF STOPPER = '*' THEN
		   {SYMCURSOR := SYMCURSOR+1;}
                   bumpcursor(1); {/tp4}
		 IF LIST THEN
		   BEGIN
		   {SYMCURSOR := SYMCURSOR + 1;}
                   bumpcursor(1); {/tp4}
		   PRINTLINE;
		   SYMCURSOR := SYMCURSOR - 1;
		   END;
		 IF INCLUDING OR INMODULE AND ININTERFACE THEN
		   BEGIN
		   ERROR(406); {include file not allowed here}
		   EXIT;{(COMMENTER)}    {TROUBLE}
		   END;
		 { OPENOLD}
		 assign (INCLFILE,LTITLE);   {patch /tp3}
		 Reset (INCLFILE,512);       {patch /tp3 512..not text}
		 IF IORESULT <> 0 THEN
		   BEGIN { OPENOLD}
		   Assign (INCLFILE,CONCAT(LTITLE,'.TXT'));  {patch /tp3}
		   Reset (INCLFILE,512);
		   IF IORESULT <> 0 THEN ERROR(403)
		   END;
                 {set up things for include file}
		 INCLUDING := TRUE;
		 OLDSYMCURSOR := SYMCURSOR;
		 OLDLINESTART := LINESTART;
		 OLDSYMBLK := SYMBLK-2;    {adjust for advance in getnext page}
		 SYMBLK := {2}0;    {/tp4}


		 GETNEXTPAGE;
		 INSYMBOL;
		 {BIG TROUBLE avoided /tp3} {should only exit from curr proc}
		 ExitInSymbol := True;   {/tp3}
		 EXIT;{(INSYMBOL)}{BIGGG TROUBLE...crappy code LB}
		 END;
	  'L': IF (SW='+') OR (SW='-') THEN
		 BEGIN LIST := (SW='+');
		 IF LIST THEN {OPENNEW}
		   begin
		   Assign(listfile,'SYSLIST.LST');    {patch /tp3}
		   Rewrite (listfile{'*SYSTEM.LST.TEXT'}) {no 512 as text}
		   end
		 END
	       ELSE
		 BEGIN
		 SCANSTRING(LTITLE,40);
		 {OPENNEW}
		 Assign (listfile,LTITLE);     {patch /tp3}
		 Rewrite (listfile{,LTITLE});
		 LIST := IORESULT = 0;
		 EXIT;{(COMMENTER)}
		 END;
	  'Q': NOISY := (SW='-');
	  'P': If List_open then WRITE(listfile,CHR(12(*FF*)));
	  'R': RANGECHECK := (SW='+');
	  'S': NOSWAP:=(SW='-');
	  'T': TINY := (SW='+');
	  'U': IF (SW='+') OR (SW='-') THEN
		 BEGIN
		 SYSCOMP := (SW = '-');
		 RANGECHECK := NOT SYSCOMP;
		 IOCHECK := RANGECHECK;
		 GOTOOK := SYSCOMP
		 END
	       ELSE
	       IF NOT USING THEN
		 BEGIN
		 SCANSTRING(SYSTEMLIB,40);
                 If libnotopen = false then   {/pc157b}
                   begin
		   CLOSE(pLIBRARY);
                   LIBNOTOPEN := TRUE;
                   end;
		 EXIT;{(COMMENTER)}
		 END
	  END (*CASES*);
	  {SYMCURSOR := SYMCURSOR+3;}
          bumpcursor(3);    {/tp4}
	UNTIL DEL <> ',';
  SYMCURSOR := SYMCURSOR-1; (* ADJUST *)
  REPEAT
    REPEAT
      bumpcursor(1);       {/tp4}
      {SYMCURSOR := SYMCURSOR+1;}
      WHILE SYMBUFP^[SYMCURSOR] = CHR(EOL) DO CHECKEND  {LB leave in 19/11/2004}
    UNTIL SYMBUFP^[SYMCURSOR]=STOPPER;
  UNTIL (SYMBUFP^[SYMCURSOR+1]=')') OR (STOPPER='}');
  {SYMCURSOR := SYMCURSOR+1;}
  bumpcursor(1) {/tp4}

END (*COMMENTER*);







{Handle string and constant declarations}


PROCEDURE aSTRING;     {keeps turbo happy}
LABEL 1;
{ Bug fix -- RSK 8-Sep-79 symptom: strings > 80 chars crashed the compiler
  fix: enforce 80 character limit
  severity: high
}
const
  maxstring=80;
VAR
  T: PACKED ARRAY [1..maxstring] OF CHAR;
  TP,NBLANKS,L: INTEGER;
  DUPLE: BOOLEAN;

BEGIN
  DUPLE := FALSE; (* INDICATES WHEN '' IS PRESENT *)
  TP := 0; (* INDEX INTO TEMPORARY STRING *)
  REPEAT
    IF DUPLE THEN {SYMCURSOR := SYMCURSOR+1;}
      bumpcursor(1); {/pc157}
    REPEAT
      {SYMCURSOR := SYMCURSOR+1;}
      bumpcursor(1); {/tp4}
      TP := TP+1;
      if tp > maxstring then
	begin error(398); tp:=1 end;
      { end of bug fix, maxstring added, check added }
      IF SYMBUFP^[SYMCURSOR] = CHR(EOL) THEN
	BEGIN ERROR(202); CHECKEND; GOTO 1 END;
      T[TP] := SYMBUFP^[SYMCURSOR];
    UNTIL SYMBUFP^[SYMCURSOR]='''';
    DUPLE := TRUE;
  UNTIL SYMBUFP^[SYMCURSOR+1]<>'''';
1:  TP := TP-1; (* ADJUST *)
  SY := STRINGCONST; OP := NOOP;
  LGTH := TP; (* GROSS *)
  IF TP=1 (* SINGLE CHARACTER CONSTANT *)
    THEN
      VAL.IVAL := ORD(T[1])
  ELSE
    WITH SCONST^ DO
      BEGIN
      CCLASS := STRG;
      SLGTH := TP;
      MOVE{LEFT}(T[1],SVAL[1],TP);
      VAL.VALP := SCONST
      END
END(*aSTRING*);










{ not commented out for /tp5.1}
PROCEDURE NUMBER;
VAR
  EXPONENT,ENDI,ENDF,ENDE,SIGN,IPART,FPART,EPART,
  ISUM:  INTEGER; hexsum : Word;
  TIPE: (REALTIPE,INTEGERTIPE);
  RSUM: REAL;
  NOTLONG: BOOLEAN;
  K,J: INTEGER;
  ch:char;    {/pc157}
BEGIN
  (* TAKES A NUMBER AND DECIDES WHETHER IT'S REAL
     OR INTEGER AND CONVERTS IT TO THE INTERNAL
     FORM. *)
  TIPE := INTEGERTIPE;
  ENDI := 0;
  ENDF := 0;
  ENDE := 0;
  SIGN := 1;
  NOTLONG := TRUE;
  EPART := 9999; (* OUT OF REACH *)
  IPART := SYMCURSOR; (* INTEGER PART STARTS HERE *)


  {/pc157 hex number addtn}


  if symbufp^[symcursor] = '$' then
    begin
    {Bumpcursor(1);}
    symcursor:= symcursor+1; {pc157g bug15}
    ch:=symbufp^[symcursor];
    hexsum := 0;
    while (ch >= '0') and (ch <= '9') or
          (ch >= 'a') and (ch <= 'f') or
          (ch >= 'A') and (ch <= 'F') do begin
        if (ch >= '0') and (ch <= '9') then
            k := ord(ch) - ord('0')
        else if (ch >= 'A') and (ch <= 'F') then
            k := ord(ch) - ord('A') + 10
        else
            k := ord(ch) - ord('a') + 10;
        if (hexsum > maxint {div 16}) or ((hexsum = maxint {div 16}) and
            (k > maxint {mod 16})) then
                error(203)
        else
            hexsum := hexsum * 16 + k;
      {Bumpcursor(1);}
      symcursor:= symcursor+1; {pc157g bug15}
      ch:=symbufp^[symcursor];
    end;
    sy := intconst;
    op := noop;
    {val.ival := hexsum;}
    move(hexsum,val.ival,sizeof(hexsum));
    SYMCURSOR := SYMCURSOR-1; (* ADJUST FOR POSTERITY *)
    exit;{(number);}
    end;


  {end hex number}















  REPEAT
    (*SYMCURSOR := SYMCURSOR+1*)
    {bumpcursor(1);} (*/tp4*)
    symcursor:= symcursor+1; {pc157g bug15}


  UNTIL (SYMBUFP^[SYMCURSOR]<'0') OR (SYMBUFP^[SYMCURSOR]>'9');
  (* SYMCURSOR NOW POINTS AT FIRST CHARACTER PAST INTEGER PART *)
  ENDI := SYMCURSOR-1; (* MARK THE END OF IPART *)
  IF SYMBUFP^[SYMCURSOR]='.'
    THEN
      IF SYMBUFP^[SYMCURSOR+1]<>'.'  (* WATCH OUT FOR '..' *)
	THEN
	  BEGIN
	    TIPE := REALTIPE;
	    (*SYMCURSOR := SYMCURSOR+1;*)
            {bumpcursor(1);} (*/tp4*)
            symcursor:= symcursor+1; {pc157g bug15}


	    FPART := SYMCURSOR; (* BEGINNING OF FPART *)
	    WHILE (SYMBUFP^[SYMCURSOR] >= '0') AND
		  (SYMBUFP^[SYMCURSOR] <= '9') DO
	      (*SYMCURSOR := SYMCURSOR+1;*)
              {bumpcursor(1);} (*/tp4*)
              symcursor:= symcursor+1; {pc157g bug15}


	    IF SYMCURSOR = FPART THEN ERROR(201);
	    ENDF := SYMCURSOR-1;
	  END;
  IF SYMBUFP^[SYMCURSOR]='E'
    THEN
      BEGIN
	TIPE := REALTIPE;
	(*SYMCURSOR := SYMCURSOR+1;*)
        {bumpcursor(1);} (*/tp4*)
        symcursor:= symcursor+1; {pc157g bug15}


	IF SYMBUFP^[SYMCURSOR]='-'
	  THEN
	    BEGIN
	      (*SYMCURSOR := SYMCURSOR+1;*)
              {bumpcursor(1);} (*/tp4*)
              symcursor:= symcursor+1; {pc157g bug15}


	      SIGN := -1;
	    END
	  ELSE
	    IF SYMBUFP^[SYMCURSOR]='+'
	      THEN
		(*SYMCURSOR := SYMCURSOR+1;*)
                {bumpcursor(1);} (*/tp4*)
                symcursor:= symcursor+1; {pc157g bug15}


	EPART := SYMCURSOR; (* BEGINNING OF EXPONENT *)
	WHILE (SYMBUFP^[SYMCURSOR]>='0') AND (SYMBUFP^[SYMCURSOR]<='9') DO
	  (*SYMCURSOR := SYMCURSOR+1;*)
          {bumpcursor(1);} (*/tp4*)
          symcursor:= symcursor+1; {pc157g bug15}


	ENDE := SYMCURSOR-1;
	IF ENDE<EPART THEN ERROR(201); (* ERROR IN REAL CONSTANT *)
      END;
  (* NOW CONVERT TO INTERNAL FORM *)
  IF TIPE=INTEGERTIPE THEN
    BEGIN
      ISUM := 0;
      FOR J := IPART TO ENDI DO
	BEGIN
	  IF (ISUM>MAXINT DIV 10) OR ((ISUM=MAXINT DIV 10) AND
		      (ORD(SYMBUFP^[J]) - ORD('0') > MAXINT MOD 10)) THEN
	      BEGIN NOTLONG := FALSE; K := J; J := ENDI END
	  ELSE ISUM := ISUM*10+(ORD(SYMBUFP^[J])-ORD('0'));
	END;
	IF NOTLONG THEN
	  BEGIN
	    SY := INTCONST;  OP := NOOP;
	    VAL.IVAL := ISUM;
	  END
	ELSE
	  BEGIN
	    IF ENDI - IPART >= MAXDEC THEN
	      BEGIN ERROR(203); IPART := ENDI; K := ENDI END;
	    NEW(LVP);(*,LONG);*)
	    WITH LVP^ DO
	      BEGIN CCLASS := LONG; J := 4; LLENG := 0;
		WHILE K <= ENDI DO
		  BEGIN
		    IF J = 4 THEN
		      BEGIN LLENG := LLENG + 1;
			LONGVAL[LLENG] := ISUM;
			ISUM := 0;
			J := 0
		      END;
		    ISUM := ISUM * 10 + ORD(SYMBUFP^[K])-ORD('0');
		    K := K + 1; J := J + 1
		  END;
		LLAST := J;
		IF J > 0 THEN
		  BEGIN LLENG := LLENG + 1;
		    LONGVAL[LLENG] := ISUM
		  END;
	      END;
	    SY := LONGCONST; OP := NOOP;
	    LGTH := ENDI - IPART + 1;
	    VAL.VALP := LVP
	  END;
    END (*TIPE = INTEGERTIPE*)
  ELSE
    BEGIN (* REAL NUMBER HERE *)
      RSUM := 0;
      FOR J := IPART TO ENDI DO
	BEGIN
	  RSUM := RSUM*10+(ORD(SYMBUFP^[J])-ORD('0'));
	END;
      FOR J := ENDF DOWNTO FPART DO
	RSUM := RSUM+(ORD(SYMBUFP^[J])-ORD('0'))/PWROFTEN(J-FPART+1);
      EXPONENT := 0;
      FOR J := EPART TO ENDE DO
	EXPONENT := EXPONENT*10+ORD(SYMBUFP^[J])-ORD('0');
      IF SIGN=-1 THEN
	RSUM := RSUM/PWROFTEN(EXPONENT)
      ELSE
	RSUM := RSUM*PWROFTEN(EXPONENT);
      SY := REALCONST;  OP := NOOP;
      NEW(LVP);(*,REEL);*)
      LVP^.CCLASS := REEL;
      LVP^.RVAL := RSUM;
      VAL.VALP := LVP;
    END;
  SYMCURSOR := SYMCURSOR-1; (* ADJUST FOR POSTERITY *)
END (*NUMBER*) ;







{ all new for /tp5.1
PROCEDURE NUMBER;
VAR
  EXPONENT,ENDI,ENDF,ENDE,SIGN,IPART,FPART,EPART,
  ISUM:	 INTEGER;
  TIPE: (REALTIPE,INTEGERTIPE);
  NOTLONG: BOOLEAN;
  K,J: INTEGER;
  
  (*canonical real stuff*)
  
  mantcount,sigctr,lastsig,decpt,digctr: integer;
  tempreal: canonreal;
  leadzero: boolean;
  
  procedure BuildMantissa;
  
    procedure building(var which: integer);
    var digit: 0..9;
    begin
      digit := ord(symbufp^[j]) - ord('0');
      leadzero := leadzero and (digit = 0);
      if not leadzero then
	begin
	  which := which*10 + digit;
	  sigctr := succ(sigctr);
	end;
    end (*building*);
  
  begin (*BuildMant*)
    digctr := succ(digctr);
    if sigctr <= realsig then
      begin
	lastsig := digctr;
	building(tempreal.mant[1 + ((sigctr - 1) div 4)]);
      end;
  end (*BuildMant*);

BEGIN
  (* TAKES A NUMBER AND DECIDES WHETHER IT'S REAL     OR INTEGER AND CONVERTS IT TO THE INTERNAL
     FORM. *)
  TIPE := INTEGERTIPE;
  ENDF := 0;
  ENDE := 0;
  SIGN := 1;
  NOTLONG := TRUE;
  EPART := 9999; (* OUT OF REACH *)
  FPART := 9999;
  IPART := SYMCURSOR; (* INTEGER PART STARTS HERE *)
  REPEAT
    SYMCURSOR := SYMCURSOR+1
  UNTIL (SYMBUFP^[SYMCURSOR]<'0') OR (SYMBUFP^[SYMCURSOR]>'9');
  (* SYMCURSOR NOW POINTS AT FIRST CHARACTER PAST INTEGER PART *)
  ENDI := SYMCURSOR-1; (* MARK THE END OF IPART *)
  IF SYMBUFP^[SYMCURSOR]='.'
    THEN
      IF SYMBUFP^[SYMCURSOR+1]<>'.'  (* WATCH OUT FOR '..' *)
	THEN
	  BEGIN
	    TIPE := REALTIPE;
	    SYMCURSOR := SYMCURSOR+1;
	    FPART := SYMCURSOR; (* BEGINNING OF FPART *)
	    WHILE (SYMBUFP^[SYMCURSOR] >= '0') AND
		  (SYMBUFP^[SYMCURSOR] <= '9') DO
	      SYMCURSOR := SYMCURSOR+1;
	    IF SYMCURSOR = FPART THEN ERROR(201);
	    ENDF := SYMCURSOR-1;
	  END;
  IF (SYMBUFP^[SYMCURSOR]='E') or (symbufp^[symcursor]='e')
    THEN
      BEGIN
	TIPE := REALTIPE;
	SYMCURSOR := SYMCURSOR+1;
	IF SYMBUFP^[SYMCURSOR]='-'
	  THEN
	    BEGIN
	      SYMCURSOR := SYMCURSOR+1;
	      SIGN := -1;
	    END
	  ELSE
	    IF SYMBUFP^[SYMCURSOR]='+'
	      THEN
		SYMCURSOR := SYMCURSOR+1;
	EPART := SYMCURSOR; (* BEGINNING OF EXPONENT *)
	WHILE (SYMBUFP^[SYMCURSOR]>='0') AND (SYMBUFP^[SYMCURSOR]<='9') DO
	  SYMCURSOR := SYMCURSOR+1;
  	ENDE := SYMCURSOR-1;
	IF ENDE<EPART THEN ERROR(201) (* ERROR IN REAL CONSTANT *)
      END;
  (* NOW CONVERT TO INTERNAL FORM *)
  IF TIPE=INTEGERTIPE THEN
    BEGIN
      ISUM := 0;
      FOR J := IPART TO ENDI DO
	BEGIN
	  IF (ISUM>MAXINT DIV 10) OR ((ISUM=MAXINT DIV 10) AND 
		      (ORD(SYMBUFP^[J]) - ORD('0') > MAXINT MOD 10)) THEN
	      BEGIN NOTLONG := FALSE; K := J; J := ENDI END
	  ELSE ISUM := ISUM*10+(ORD(SYMBUFP^[J])-ORD('0'));
	END;
	IF NOTLONG THEN
	  BEGIN
	    SY := INTCONST;  OP := NOOP;
	    VAL.IVAL := ISUM;
	  END
	ELSE
	  BEGIN 
	    IF ENDI - IPART >= MAXDEC THEN
	      BEGIN ERROR(203); IPART := ENDI; K := ENDI END;
	    NEW(LVP(*,LONG*));      (*/tp3*)
	    WITH LVP^ DO
	      BEGIN CCLASS := LONG; J := 4; LLENG := 0;
		WHILE K <= ENDI DO
		  BEGIN
		    IF J = 4 THEN
		      BEGIN LLENG := LLENG + 1;
			LONGVAL[LLENG] := ISUM;
			ISUM := 0;
			J := 0
		      END;
		    ISUM := ISUM * 10 + ORD(SYMBUFP^[K])-ORD('0');
		    K := K + 1; J := J + 1
		  END;
		IF J > 0 THEN
		  BEGIN LLENG := LLENG + 1;
		    LONGVAL[LLENG] := ISUM
		  END;
		llast := 1;
		while j > 0 do 
		  begin
		    llast := llast * 10;
		    j := pred(j);
		  end;
	      END;
	    SY := LONGCONST; OP := NOOP;
	    LGTH := ENDI - IPART + 1;
	    VAL.VALP := LVP
	  END;
    END (*TIPE = INTEGERTIPE*)
  ELSE
    BEGIN (* REAL NUMBER HERE *)
      fillchar(tempreal,sizeof(tempreal),0);
      sigctr := 1; digctr := 1; 
      leadzero := true;
      FOR J := IPART TO ENDI DO BuildMantissa;
      decpt := digctr;
      FOR J := FPART TO ENDF DO BuildMantissa;
      if leadzero then mantcount := 1 else
      mantcount := 1 + ((sigctr - 2) div 4);
      (* correct last mant word if partial *)
      if mantcount > 1 then
	with tempreal do
	  while ((sigctr - 1) mod 4) <> 0 do
	    begin mant[mantcount] := mant[mantcount]*10; 
	      sigctr := succ(sigctr); lastsig := succ(lastsig);
	    end;
      (* add terminator word if not max-sized constant *)
      if mantcount < (realkmax - 1) then
	with tempreal do
	  begin
	    mantcount := succ(mantcount);
	    mant[mantcount] := -1;
	  end;
      (* stretch constant if too short for real impl *)
      if (mantcount + 1) < realsize then
	mantcount := succ(mantcount);
      EXPONENT := 0;
      FOR J := EPART TO ENDE DO
	EXPONENT := EXPONENT*10+ORD(SYMBUFP^[J])-ORD('0');
      EXPONENT:=(SIGN*EXPONENT) + decpt - lastsig;
      SY := REALCONST;	OP := NOOP;
      NEW(LVP(*,REEL*));    (*/tp3*)
      LVP^.CCLASS := REEL;
      with LVP^.RVAL do
	begin
	  expon := exponent;
	  mant := tempreal.mant;
	  rsize := mantcount + 1;
	end;
      VAL.VALP := LVP;
    END;
  SYMCURSOR := SYMCURSOR-1; (* ADJUST FOR POSTERITY *)
END (*NUMBER*) ;

}



BEGIN (* INSYMBOL *)
  {Line below is 1.5 addition}
  IF GETSTMTLEV THEN BEGIN BEGSTMTLEV := STMTLEV; GETSTMTLEV := FALSE END;
  OP := NOOP;
1:  SY := OTHERSY; (* IF NO CASES EXERCISED BLOW UP *)

  tempc := SYMBUFP^[SYMCURSOR];




  CASE SYMBUFP^[SYMCURSOR] OF
  '''':aSTRING;
  '0','1','2','3','4','5','6','7','8','9','$':    {/pc157 $ for hex number}
       NUMBER;
  'A','B','C','D','E','F','G','H','I','J','K','L','M',
  'N','O','P','Q','R','S','T','U','V','W','X','Y','Z',
  'a','b','c','d','e','f','g','h','i','j','k','l','m',
  'n','o','p','q','r','s','t','u','v','w','x','y','z':
       IDSEARCH(*SYMCURSOR,SYMBUFP^*); (* MAGIC PROC *)
  '{': BEGIN COMMENTER('}'); GOTO 1 END;
  '(': BEGIN
	 IF SYMBUFP^[SYMCURSOR+1]='*' THEN
	     BEGIN
		{SYMCURSOR := SYMCURSOR+1;}
                bumpcursor(1); {/tp4}

		ExitInsymbol := False;            {/tp3}
		COMMENTER('*');
		If ExitInsymbol then Exit{insymbol};     {/tp3}
		{SYMCURSOR := SYMCURSOR+1;}
                bumpcursor(1); {/tp4}

		GOTO 1; (* GET ANOTHER TOKEN *)
	     END
	   ELSE
	     SY := LPARENT;
       END;
  ')': SY := RPARENT;
  ',': SY := COMMA;

  Chr(9),
  ' ': BEGIN       {watch out... the cases are chr(32),chr(09) /tp3}
       {SYMCURSOR := SYMCURSOR+1;}
       bumpcursor(1); {/tp4}

       GOTO 1;
       END;
  '.': BEGIN
	 IF SYMBUFP^[SYMCURSOR+1]='.'
	   THEN
	     BEGIN
		{SYMCURSOR := SYMCURSOR+1;}
                bumpcursor(1); {/tp4}

		SY := COLON
	     END
	   ELSE
	     SY := PERIOD;
       END;
  ':': IF SYMBUFP^[SYMCURSOR+1]='='
	 THEN
	   BEGIN
	     {SYMCURSOR := SYMCURSOR+1;}
             bumpcursor(1); {/tp4}

	     SY := BECOMES;
	  END
	ELSE
	   SY := COLON;
  ';': SY := SEMICOLON;
  '^': SY := ARROW;
  '[': SY := LBRACK;
  ']': SY := RBRACK;
  '*': BEGIN SY := MULOP; OP := MUL END;
  '+': BEGIN SY := ADDOP; OP := PLUS END;
  '-': BEGIN SY := ADDOP; OP := MINUS END;
  '/': BEGIN SY := MULOP; OP := RDIV END;
  '<': BEGIN
	 SY := RELOP;
	 OP := LTOP;
	 CASE SYMBUFP^[SYMCURSOR+1] OF
	   '>': BEGIN
		  OP := NEOP;
		  {SYMCURSOR := SYMCURSOR+1}
                  bumpcursor(1) {/tp4}

		END;
	   '=': BEGIN
		  OP := LEOP;
		  {SYMCURSOR := SYMCURSOR+1}
                  bumpcursor(1) {/tp4}

		END
	 END;
       END;
  '=': BEGIN SY := RELOP; OP := EQOP END;
  '>': BEGIN
	 SY := RELOP;
	 IF SYMBUFP^[SYMCURSOR+1]='='
	   THEN
	     BEGIN
		OP := GEOP;
		{SYMCURSOR := SYMCURSOR+1;}
                bumpcursor(1); {/tp4}

	     END
	   ELSE
	     OP := GTOP;
       END
  END (* CASE SYMBUFP^[SYMCURSOR] OF *);
  IF SY=OTHERSY THEN
    IF SYMBUFP^[SYMCURSOR] = CHR(EOL) THEN
      BEGIN
      CHECKEND;
      GETSTMTLEV := TRUE;
      GOTO 1
      END
    ELSE
      ERROR(400);
  {SYMCURSOR := SYMCURSOR+1;} (* NEXT CALL TALKS ABOUT NEXT TOKEN *)
  bumpcursor(1); {/tp4}

END (*INSYMBOL*) ;










{ (*$I PROCS.B.TEXT*) }
  (*      COPYRIGHT  (C) 1978, REGENTS OF THE      *)
  (*      UNIVERSITY OF CALIFORNIA, SAN DIEGO      *)

  PROCEDURE SEARCHSECTION(*FCP: CTP; VAR FCP1: CTP*);
  BEGIN
    IF FCP <> pNIL THEN
      IF TREESEARCH(FCP,FCP1,ID) = 0 THEN (*NADA*)
      ELSE FCP1 := pNIL
    ELSE FCP1 := pNIL
  END (*SEARCHSECTION*) ;

  PROCEDURE SEARCHID(*FIDCLS: SETOFIDS; VAR FCP: CTP*);
    LABEL 1; VAR LCP: CTP;
  BEGIN
    FOR DISX := TOP DOWNTO 0 DO
      BEGIN LCP := DISPLAY[DISX].FNAME;
	IF LCP <> pNIL THEN
	  IF TREESEARCH(LCP,LCP,ID) = 0 THEN
	    IF LCP^.KLASS IN FIDCLS THEN GOTO 1
	    ELSE
	      IF PRTERR THEN ERROR(103)
	      ELSE LCP := pNIL
	  ELSE LCP := pNIL
      END;
    IF PRTERR THEN
      BEGIN
        write('>>>',ID,' '); {pc157g 15/1/95}
        ERROR(104);
	IF TYPES IN FIDCLS THEN LCP := UTYPPTR
	ELSE IF ACTUALVARS IN FIDCLS THEN LCP := UVARPTR
	ELSE IF FIELD IN FIDCLS THEN LCP := UFLDPTR
	ELSE IF KONST IN FIDCLS THEN LCP := UCSTPTR
	ELSE IF PROC IN FIDCLS THEN LCP := UPRCPTR
	ELSE LCP := UFCTPTR
      END;
1:  FCP := LCP
  END (*SEARCHID*) ;

  PROCEDURE GETBOUNDS(*FSP: STP; VAR FMIN,FMAX: INTEGER*);
  BEGIN
    WITH FSP^ DO
      IF FORM = SUBRANGE THEN
	BEGIN FMIN := MIN.IVAL; FMAX := MAX.IVAL END
      ELSE
	BEGIN FMIN := 0;
	  IF FSP = CHARPTR THEN FMAX := 255
	  ELSE
	    IF FSP^.FCONST <> pNIL THEN
	      FMAX := FSP^.FCONST^.VALUES.IVAL
	    ELSE FMAX := 0
	END
  END (*GETBOUNDS*) ;

  PROCEDURE SKIP(*FSYS: SETOFSYS*);
  BEGIN WHILE NOT(SY IN FSYS) DO INSYMBOL
  END (*SKIP*) ;

  FUNCTION PAOFCHAR(*FSP: STP): BOOLEAN*);
  BEGIN PAOFCHAR := FALSE;
    IF FSP <> pNIL THEN
      IF FSP^.FORM = ARRAYS THEN
	PAOFCHAR := FSP^.AISPACKD AND (FSP^.AELTYPE = CHARPTR)
  END (*PAOFCHAR*) ;

  FUNCTION STRGTYPE(*FSP: STP) : BOOLEAN*);
  BEGIN STRGTYPE := FALSE;
    IF PAOFCHAR(FSP) THEN STRGTYPE := FSP^.AISSTRNG
  END (*STRGTYPE*) ;

  FUNCTION DECSIZE(*I: INTEGER): INTEGER*);
  BEGIN DECSIZE := (TRUNC(I*3.321) + 1 + BITSPERWD) DIV BITSPERWD
  END (*DECSIZE*) ;

  PROCEDURE CONSTANT(*FSYS: SETOFSYS; VAR FSP: STP; VAR FVALU: VALU*);
    VAR LSP: STP; LCP: CTP; SIGN: (NONE,POS,NEG);
	LVP: CSP;
  BEGIN LSP := pNIL; FVALU.IVAL := 0;
    IF NOT(SY IN CONSTBEGSYS) THEN
      BEGIN ERROR(50); SKIP(FSYS+CONSTBEGSYS) END;
    IF SY IN CONSTBEGSYS THEN
      BEGIN
	IF SY = STRINGCONST THEN
	  BEGIN
	    IF LGTH = 1 THEN LSP := CHARPTR
	    ELSE
	      BEGIN
		NEW(LSP);{,ARRAYS,TRUE,TRUE);}
		LSP^ := STRGPTR^;
                {rte if string=''; as maxlen is 1..strgleng...drop R+}
                {$R-}
		LSP^.MAXLENG := LGTH;
                {$R+}
		LSP^.INXTYPE := pNIL;
		NEW(LVP);
		LVP^ := VAL.VALP^;
		VAL.VALP := LVP
	      END;
	    FVALU := VAL; INSYMBOL
	  END
	ELSE
	  BEGIN
	    SIGN := NONE;
	    IF (SY = ADDOP) AND (OP IN [PLUS,MINUS]) THEN
	      BEGIN IF OP = PLUS THEN SIGN := POS ELSE SIGN := NEG;
		INSYMBOL
	      END;
	    IF SY = IDENT THEN
	      BEGIN SEARCHID([KONST],LCP);
		WITH LCP^ DO
		  BEGIN LSP := IDTYPE; FVALU := VALUES END;
		IF SIGN <> NONE THEN
		  IF LSP = INTPTR THEN
		    BEGIN IF SIGN = NEG THEN
			FVALU.IVAL := -FVALU.IVAL END
		  ELSE
		    IF LSP = REALPTR THEN
			BEGIN
			IF SIGN = NEG THEN
			  BEGIN NEW(LVP);{,REEL);}
			    LVP^.CCLASS := REEL;
			    LVP^.RVAL := -FVALU.VALP^.RVAL;
			    {lvp^.rval :=  fvalu.valp^.rval;}    {/tp5.1}
                            {with lvp^.rval do }                 {/tp5.1}
                             { mant[1] := -mant[1];}
			    FVALU.VALP := LVP;
			  END
		      END
		    ELSE
		      IF COMPTYPES(LSP,LONGINTPTR) THEN
			BEGIN
			  IF SIGN = NEG THEN
                          {there is a bug fix here in 4.1 for longints}
			    BEGIN NEW(LVP);{,LONG);}
			      LVP^.CCLASS := LONG;
			      LVP^.LONGVAL[1] := - FVALU.VALP^.LONGVAL[1];
			      FVALU.VALP := LVP
			    END
			END
		      ELSE ERROR(105);
		INSYMBOL;
	      END
	    ELSE
	      IF SY = INTCONST THEN
		BEGIN IF SIGN = NEG THEN VAL.IVAL := -VAL.IVAL;
		  LSP := INTPTR; FVALU := VAL; INSYMBOL
		END
	      ELSE
		IF SY = REALCONST THEN
		  BEGIN IF SIGN = NEG THEN
			 VAL.VALP^.RVAL := -VAL.VALP^.RVAL;     {/tp5.1}
		         {with val.valp^.rval do mant[1]:=-mant[1];} {/tp5.1}
		    LSP := REALPTR; FVALU := VAL; INSYMBOL
		  END
		ELSE
		  IF SY = LONGCONST THEN
		    BEGIN
		      IF SIGN = NEG THEN
			BEGIN VAL.VALP^.LONGVAL[1] := - VAL.VALP^.LONGVAL[1];
			  NEW(LSP);{,LONGINT);}
			  LSP^.SIZE := DECSIZE(LGTH);
			  LSP^.FORM := LONGINTs;
			  FVALU := VAL;
			  INSYMBOL
			END
		    END
		  ELSE
		    BEGIN ERROR(106); SKIP(FSYS) END
	  END;
	IF NOT (SY IN FSYS) THEN
	  BEGIN ERROR(6); SKIP(FSYS) END
	END;
    FSP := LSP
  END (*CONSTANT*) ;

  FUNCTION COMPTYPES(*FSP1,FSP2: STP) : BOOLEAN*);
    VAR NXT1,NXT2: CTP; COMP: BOOLEAN;
      LTESTP1,LTESTP2 : TESTP;
  BEGIN
    IF FSP1 = FSP2 THEN COMPTYPES := TRUE
    ELSE
      IF (FSP1 = pNIL) OR (FSP2 = pNIL) THEN COMPTYPES := TRUE
      ELSE
	IF FSP1^.FORM = FSP2^.FORM THEN
	  CASE FSP1^.FORM OF
	    SCALAR:
	      COMPTYPES := FALSE;
	    SUBRANGE:
	      COMPTYPES := COMPTYPES(FSP1^.RANGETYPE,
					   FSP2^.RANGETYPE);
	    POINTERs:    {/tp3}
		BEGIN
		  COMP := FALSE; LTESTP1 := GLOBTESTP;
		  LTESTP2 := GLOBTESTP;
		  WHILE LTESTP1 <> pNIL DO
		    WITH LTESTP1^ DO
			BEGIN
			IF (ELT1 = FSP1^.ELTYPE) AND
			  (ELT2 = FSP2^.ELTYPE) THEN COMP := TRUE;
			LTESTP1 := LASTTESTP
			END;
		  IF NOT COMP THEN
		    BEGIN NEW(LTESTP1);
			WITH LTESTP1^ DO
			BEGIN ELT1 := FSP1^.ELTYPE;
			  ELT2 := FSP2^.ELTYPE;
			  LASTTESTP := GLOBTESTP
			END;
			GLOBTESTP := LTESTP1;
			COMP := COMPTYPES(FSP1^.ELTYPE,FSP2^.ELTYPE)
		    END;
		  COMPTYPES := COMP; GLOBTESTP := LTESTP2
		END;
	    LONGINTs: COMPTYPES := TRUE;
	    POWER:
	      COMPTYPES := COMPTYPES(FSP1^.ELSET,FSP2^.ELSET);
	    ARRAYS:
	      BEGIN
		COMP := COMPTYPES(FSP1^.AELTYPE,FSP2^.AELTYPE)
			AND (FSP1^.AISPACKD = FSP2^.AISPACKD);
		IF COMP AND FSP1^.AISPACKD THEN
		    COMP := (FSP1^.ELSPERWD = FSP2^.ELSPERWD)
			    AND (FSP1^.ELWIDTH = FSP2^.ELWIDTH)
			    AND (FSP1^.AISSTRNG = FSP2^.AISSTRNG);
		IF COMP AND NOT STRGTYPE(FSP1) THEN
		  COMP := (FSP1^.SIZE = FSP2^.SIZE);
		COMPTYPES := COMP;
	      END;
	    RECORDS:
	      BEGIN NXT1 := FSP1^.FSTFLD; NXT2 := FSP2^.FSTFLD;
		COMP := TRUE;
		WHILE (NXT1 <> pNIL) AND (NXT2 <> pNIL) AND COMP DO
		  BEGIN COMP:=COMPTYPES(NXT1^.IDTYPE,NXT2^.IDTYPE);
		    NXT1 := NXT1^.NEXT; NXT2 := NXT2^.NEXT
		  END;
		COMPTYPES := COMP AND (NXT1 = pNIL) AND (NXT2 = pNIL)
			    AND (FSP1^.RECVAR = pNIL)
			    AND (FSP2^.RECVAR = pNIL)
	      END;
	    FILES:
	      COMPTYPES := COMPTYPES(FSP1^.FILTYPE,FSP2^.FILTYPE)
	  END (*CASE*)
	ELSE (*FSP1^.FORM <> FSP2^.FORM*)
	  IF FSP1^.FORM = SUBRANGE THEN
	    COMPTYPES := COMPTYPES(FSP1^.RANGETYPE,FSP2)
	  ELSE
	    IF FSP2^.FORM = SUBRANGE THEN
	      COMPTYPES := COMPTYPES(FSP1,FSP2^.RANGETYPE)
	    ELSE COMPTYPES := FALSE
  END (*COMPTYPES*) ;







  PROCEDURE GENBYTE(*FBYTE: INTEGER*);
  BEGIN
    If Interlist and list_open then
      write(listfile,fbyte:8);
    CODEP^[IC] := CHR(FBYTE); IC := IC+1
  END (*GENBYTE*) ;

  PROCEDURE GENWORD(*FWORD: INTEGER*);
  BEGIN
    IF ODD(IC) THEN IC := IC + 1;       {??? Word alignment ? L.B.}
    If Interlist and list_open then
      write(listfile,fword:8);
    MOVE{LEFT}(FWORD,CODEP^[IC],2);
    If flipsex then flipbufword;
    IC := IC + 2
  END (*GENWORD*) ;



PROCEDURE WRITETEXT( start:integer); {/pc157}
var i:integer;
  BEGIN
(*
  WRITELN('AT WRITE TEXT, SYMCURSOR = ',SYMCURSOR);
  WRITELN('                   START = ',START);
  READLN;
*)
    {as the text following the INTERFACE symbol is written, then
    a len of 1024 is too long if the start is > 0 or 1024 so the
    next few lines correct this.... /pc157}
    Fillchar(Codep^[0],1024,chr(32));   {blank pad buffer}
    If start = 1024 then
      move(symbufp^[start],codep^[0],2048-start)
    else
      begin   {must be first call from unitpart.inc}
      If start < 1024 then
        move(symbufp^[start],codep^[start],1024-start)
      else
        move(symbufp^[start],codep^[start-1024],2048-start)


      end;
    {MOVELEFT(SYMBUFP^[SYMCURSOR],CODEP^[0],1024);}

(*
    for i:=0 to 1023 do
    begin
    Write(codep^[i]);
    end;
    writeln('end of writetext...press return'); readln;
*)
    IF USERINFO.ERRNUM = 0 THEN
      IF ucsdBLOCKWRITE({USERINFO.WORKCODE^}wurkcode,CODEP^[0],
                     2,CURBLK) <> 2 THEN
	ERROR(402);
    CURBLK := CURBLK + 2
  END (*WRITETEXT*) ;





  PROCEDURE WRITECODE(*FORCEBUF: BOOLEAN*);
    VAR CODEINX,LIC,I: INTEGER;
  BEGIN CODEINX := 0; LIC := IC;
    REPEAT
      I := 512-CURBYTE;
      IF I > LIC THEN I := LIC;
      MOVE{LEFT}(CODEP^[CODEINX],DISKBUF[CURBYTE],I);
      CODEINX := CODEINX+I;
      CURBYTE := CURBYTE+I;
      IF (CURBYTE = 512) OR FORCEBUF THEN
	BEGIN
	  IF USERINFO.ERRNUM = 0 THEN
IF ucsdBLOCKWRITE({USERINFO.WORKCODE^}wurkcode ,DISKBUF,1,CURBLK) <> 1 THEN
	      ERROR(402);
	  CURBLK := CURBLK+1; CURBYTE := 0
	END;
      LIC := LIC-I
    UNTIL LIC = 0;
  END (*WRITECODE*) ;

  PROCEDURE FINISHSEG;
    VAR I: INTEGER;
  BEGIN
    IC := 0;
    If Interlist and list_open then
      Writeln(listfile,'Generating Segment Dictionary');
    FOR I := NEXTPROC-1 DOWNTO 1 DO
      IF PROCTABLE[I] = 0 THEN
	GENWORD(0)
      ELSE
	GENWORD(SEGINX+IC-PROCTABLE[I]);
    GENBYTE(SEG); GENBYTE(NEXTPROC-1);
    If Interlist and list_open then
      Begin
	Writeln(listfile);
	Writeln(listfile,'Diagnostic Proc Table Dump');
	For I := NextProc-1 DownTo 1 do
	  Writeln(Listfile,'Proc ',i,' Offset ',ProcTable[I]);
      End;
    SEGTABLE[SEG].CODELENG := SEGINX+IC;
    WRITECODE(TRUE); SEGINX := 0; CODEINSEG := FALSE;
    If Interlist and list_open then Writeln(ListFile);
  END (*FINISHSEG*) ;












end.
