
{Procedure Finishseg; Forward;}    {/pc157e}
{but not needed in dos version as Finishseg in interfaced in unit PROCS}


{SEGMENT} PROCEDURE UNITPART(FSYS: SETOFSYS);
  VAR UMARKP: TESTP;

  PROCEDURE OPENREFFILE;
  BEGIN
    assign(reffile,'system.inf');         {patch /tp3}
    REWRITE(REFFILE,512{'*SYSTEM.INFO[*]'});
    IF IORESULT <> 0 THEN ERROR(402)
  END (* OPENREFFILE *) ;
  
PROCEDURE UNITDECLARATION(FSYS: SETOFSYS; VAR UMARKP:TESTP);
  VAR LCP: CTP; FOUND: BOOLEAN; LLEXSTK: LEXSTKREC;
BEGIN
  IF INMODULE THEN ERROR(182 (* NESTED MODULES NOT ALLOWED *));
  IF CODEINSEG THEN
    BEGIN ERROR(399); SEGINX := 0; CURBYTE := 0 END;
  WITH LLEXSTK DO
    BEGIN
      DOLDTOP := TOP;
      DOLDLEV := LEVEL;
      POLDPROC := CURPROC;
      SOLDPROC := NEXTPROC;
      DOLDSEG := SEG;
      DLLC := LC;
      {PREVLEXSTACKP := TOS}
      move(tos,PREVLEXSTACKP,sizeof(tos));   {patch /tp3}
    END;
  SEG := NEXTSEG;
  NEXTSEG := NEXTSEG + 1;
  IF NEXTSEG > MAXSEG THEN ERROR(250);
(*                   out in /pc157e
    NEXTPROC := 1;
    PUBLICPROCS := FALSE;
*)
    Curproc := 1; NextProc :=2;           {/pc157e}

  INMODULE := TRUE;
  INSYMBOL;
  IF SY <> IDENT THEN ERROR(2)
  ELSE
    BEGIN
    FOUND := FALSE;
    LCP := MODPTR;
    WHILE (LCP <> pNIL) AND NOT FOUND DO
      IF LCP^.NAME <> ID THEN
        LCP := LCP^.NEXT
      ELSE
        BEGIN
        FOUND := TRUE;
        ERROR(101)
        END;
    IF NOT FOUND THEN
      BEGIN
      NEW(LCP);{,MODULE);}
      WITH LCP^ DO
        BEGIN
        NAME  := ID;
        IDTYPE:= pNIL;
        NEXT  := MODPTR;
        KLASS := MODULE;
        SEGID := SEG
        END;
      MODPTR := LCP
      END;
    END;
  SEGTABLE[SEG].SEGNAME := ID;
  MARK(UMARKP);
  NEW(REFLIST);
  NEW(TOS);
  TOS^ := LLEXSTK;
  LEVEL := 1;
  IF TOP < DISPLIMIT THEN
    BEGIN
    TOP := TOP +1;
    WITH DISPLAY[TOP] DO
      BEGIN
      FNAME := pNIL;
      FFILE := pNIL;
      FLABEL := pNIL;
      OCCUR := BLCK
      END;
    IF LCP <> pNIL THEN ENTERID(LCP)
    END
  ELSE ERROR(250);
  INSYMBOL;
  IF SY = SEMICOLON THEN INSYMBOL ELSE ERROR(14)
END (*UNITDECLARATION*) ;


PROCEDURE INITUNIT;              {new for pc157e}
 VAR LTOS: ^LEXSTKREC;
BEGIN
  {LTOS := TOS;}
  move(tos,ltos,sizeof(tos));   {patch /tp3}

  NEW(TOS);
  WITH TOS^ DO (*INIT PROC RECORD*)
    BEGIN
      NEW(DFPROCP);{,PROC,DECLARED,ACTUAL);}
      WITH DFPROCP^ DO
	BEGIN
	  NAME := MODPTR^.NAME;
	  IDTYPE := NIL; NEXT := NIL;
	  KLASS := PROC;
	  PFDECKIND := DECLARED; PFLEV := 0; PFNAME := 1;
	  PFSEG := SEG;
	  PFKIND := ACTUAL;
	  LOCALLC := 1; FORWDECL := FALSE; 
	  EXTURNAL := FALSE; INSCOPE := TRUE;
	END;
      DLLC := LC;
      {PREVLEXSTACKP := LTOS}
      move(ltos,prevlexstackp,sizeof(ltos));   {patch /tp3}
    END;
  LEVEL := 2; {1}   {changed to 2 for 157e}
  IF SY = BEGINSY THEN
    INSYMBOL;
  BODYPART(FSYS + [CASESY] - [ENDSY],TOS^.DFPROCP);
  LC := TOS^.DLLC;
  {TOS:=TOS^.PREVLEXSTACKP;}
  move(tos^.prevlexstackp,tos,sizeof(tos));   {patch /tp3}
END (*INITUNIT*) ;




BEGIN (*UNITPART*)
  OPENREFFILE;
  REPEAT
    RESET(REFFILE);
    NREFS := 1;
    REFBLK := 0;
    IF (SY = SEPARATSY) THEN
      BEGIN
      SEPPROC := TRUE;
      INSYMBOL;
      IF SY <> UNITSY THEN ERROR(24)
      END
    ELSE
      SEPPROC := FALSE;
    UNITDECLARATION(FSYS,UMARKP);
    IF SEPPROC THEN
      SEGTABLE[SEG].SEGKIND := 4
    ELSE
      SEGTABLE[SEG].SEGKIND := 3;
    SEGTABLE[SEG].TEXTADDR := CURBLK;

{    writeln('CALLINK WRITETEXT FROM UNITPART');}

    WRITETEXT(Symcursor);   {/pc157}
    SpitInterface := true;  {/pc157} {allow getnextpage to call writetext}
    IF SY = INTERFCESY THEN
      INSYMBOL
    ELSE ERROR(22);
    ININTERFACE := TRUE;
    DECLARATIONPART(FSYS);
    SpitInterFace := False;
{    Writeln('Spitinterface now off'); readln;}
      ININTERFACE := FALSE;
      IF SY <> IMPLESY THEN
        BEGIN
        ERROR(23);
        SKIP(FSYS - STATBEGSYS)
        END
      ELSE INSYMBOL;
      BLOCK(FSYS);
        Initunit;    {/pc157e}
        FinishSeg;   {/pc157e}
      IF REFBLK > 0 THEN
        IF ucsdBLOCKWRITE(REFFILE,REFLIST^,1,REFBLK) <> 1 THEN ERROR(402);
      WRITELINKERINFO(TRUE);

    SEPPROC := FALSE; (*FALSE WHENEVER NOT INMODULE*)
    INMODULE := FALSE;

{                     out in /pc157e
    IF SY = ENDSY THEN INSYMBOL
    ELSE BEGIN ERROR(13); SKIP(FSYS) END;
}
    IF SY <> PERIOD THEN
      IF SY = SEMICOLON THEN
        INSYMBOL
      ELSE ERROR(14);
    WITH TOS^ DO
      BEGIN
      TOP := DOLDTOP;
      LEVEL := DOLDLEV;
      CURPROC := POLDPROC;
      NEXTPROC := SOLDPROC;
      SEG := DOLDSEG;
      LC := DLLC;
      END;
    {TOS := TOS^.PREVLEXSTACKP;}
    move(tos^.prevlexstackp,tos,sizeof(tos));   {patch /tp3}
    RELEASE(UMARKP)
  UNTIL NOT (SY IN [UNITSY,SEPARATSY]);
  CLOSE(REFFILE)
END (*UNITPART*);
