{ BODYPRTA.TEXT }



{overlay} PROCEDURE BODYPART(FSYS: SETOFSYS; FPROCP: CTP);


  {additions 15/1/95 for continue and break additions}
  type
    Tconbrkptr = ^node;
    node    = record last : Tconbrkptr; conlab,brklab:lbp end;
  var
    conbrkptr : tconbrkptr;

  PROCEDURE LINKERREF(KLASS: IDCLASS; ID,ADDR: INTEGER);
  BEGIN
    IF NREFS > REFSPERBLK THEN (*WRITE BUFFER*)
      BEGIN
        IF ucsdBLOCKWRITE(REFFILE,REFLIST^,1,REFBLK) <> 1 THEN ERROR(402);
        REFBLK := REFBLK + 1;
        NREFS := 1
      END;
    WITH REFLIST^[NREFS] DO
      BEGIN
        IF KLASS IN VARS THEN KEY := ID + 32
        ELSE (*PROC*) KEY := ID;
        OFFSET := SEGINX + ADDR
      END;
    NREFS := NREFS + 1
  END (*LINKERREF*) ;


(*
 *      Used to start a line for p-code interlist.
 *      This defines the start of an instruction.
 *)
Procedure istart;
Begin
    If Interlist and list_open then Begin
        Write(listfile,';p-code     ',ic:4,'  ');
        if ioresult <> 0 then
            error(404);
    End;
End; { of procedure istart }


(*
 *      This is used to terminate a p-code interlist line.
 *      This defines the end of an instruction.
 *)

Procedure istop;
Begin
    If Interlist and list_open then Begin
        Writeln(listfile);
        if ioresult <> 0 then
            error(404);
    End;
End; { of procedure istop }

(*
 *      Generate a single byte opcode. Place in code area.
 *      If interlisting is on then decode the op-code.
 *)
Procedure fbyte1(Fbyte:Integer; Var s:string80);
Begin
  case Fbyte of
                128 : s:='ABI';
                129 : s:='ABR';
                130 : s:='ADI';
                131 : s:='ADR';
                132 : s:='LAND';
                133 : s:='DIF';
                134 : s:='DVI';
                135 : s:='DVR';
                136 : s:='CHK';
                137 : s:='FLO';
                138 : s:='FLT';
                139 : s:='INN';
                140 : s:='INT';
                141 : s:='LOR';
                142 : s:='MODI';
                143 : s:='MPI';
                144 : s:='MPR';
                145 : s:='NGI';
                146 : s:='NGR';
                147 : s:='LNOT';
                148 : s:='SRS';
                149 : s:='SBI';
                150 : s:='SBR';
                151 : s:='SGS';
                152 : s:='SQI';
                153 : s:='SQR';
                154 : s:='STO';
                155 : s:='IXS';
                156 : s:='UNI';
                157 : s:='S2P';         {Apple II.1 = LDE               LB}
                158 : s:='CSP';
                159 : s:='LDCN';
                160 : s:='ADJ';
                161 : s:='FJP';
                162 : s:='INC';
                163 : s:='IND';
                164 : s:='IXA';
                165 : s:='LAO';
                166 : s:='LCA';         {Apple II.1 = LSA               LB}
                167 : s:='LDO';         {Apple II.1 = LAE               LB}
                168 : s:='MOV';
                169 : s:='MVB';         {Apple II.1 = LDO               LB}

   end {case fbyte}
end;

Procedure fbyte2(Fbyte:Integer; Var s:string80);
Begin
  case Fbyte of
                170 : s:='SAS';
                171 : s:='SRO';
                172 : s:='XJP';
                173 : s:='RNP';
                174 : s:='CIP';
                175 : s:='EQU';
                176 : s:='GEQ';
                177 : s:='GRT';
                178 : s:='LDA';
                179 : s:='LDC';
                180 : s:='LEQ';
                181 : s:='LES';
                182 : s:='LOD';
                183 : s:='NEQ';
                184 : s:='STR';
                185 : s:='UJP';
                186 : s:='LDP';
                187 : s:='STP';
                188 : s:='LDM';
                189 : s:='STM';
                190 : s:='LDB';
                191 : s:='STB';
                192 : s:='IXP';
                193 : s:='RBP';
                194 : s:='CBP';
                195 : s:='EQUI';
                196 : s:='GEQI';
		197 : s:='GTRI';  {GRTI->GTRI 26/12/96 LB}
                198 : s:='LLA';
                199 : s:='LDCI';
                200 : s:='LEQI';
                201 : s:='LESI';
                202 : s:='LDL';
                203 : s:='NEQI';
                204 : s:='STL';
                205 : s:='CXP';
                206 : s:='CLP';
                207 : s:='CGP';
                208 : s:='S1P';         {Apple II.1 = LPA               LB}
                209 : s:='IXB';         {Apple II.1 = STE               LB}
                210 : s:='BYT';         {Apple II.1 = ??NOP or unused   LB}
                211 : s:='EJP';         {Apple II.1 = ??EJP or unused   LB}
                212 : s:='NFJ';         {Apple II.1 = ??NFJ or unused   LB}
                
   end {case fbyte}
end;

Procedure fbyte3(Fbyte:Integer; Var s:string80);
Begin
  case Fbyte of
                213 : s:='BPT';
                214 : s:='XIT';
                215 : s:='NOP';
                216 : s:='SLDL1';
                217 : s:='SLDL2';
                218 : s:='SLDL3';
                219 : s:='SLDL4';
                220 : s:='SLDL5';
                221 : s:='SLDL6';
                222 : s:='SLDL7';
                223 : s:='SLDL8';
                224 : s:='SLDL9';
                225 : s:='SLDL10';
                226 : s:='SLDL11';
                227 : s:='SLDL12';
                228 : s:='SLDL13';
                229 : s:='SLDL14';
                230 : s:='SLDL15';
                231 : s:='SLDL16';
                232 : s:='SLDO1';
                233 : s:='SLDO2';
                234 : s:='SLDO3';
                235 : s:='SLDO4';
                236 : s:='SLDO5';
                237 : s:='SLDO6';
                238 : s:='SLDO7';
                239 : s:='SLDO8';
                240 : s:='SLDO9';
                241 : s:='SLDO10';
                242 : s:='SLDO11';
                243 : s:='SLDO12';
                244 : s:='SLDO13';
                245 : s:='SLDO14';
                246 : s:='SLDO15';
                247 : s:='SLDO16';
                248 : s:='SIND0';
                249 : s:='SIND1';
                250 : s:='SIND2';
                251 : s:='SIND3';
                252 : s:='SIND4';
                253 : s:='SIND5';
                254 : s:='SIND6';
                255 : s:='SIND7';
   end {case fbyte}
end;

Procedure Genop(Fbyte:Integer);
var
    s,t : string80;
{must split case fbyte statement into 3 procedures as the one procedure
 is too long to compile on pre version IV p-systems! L.B.}
{PC1.3 str has a bug in that variables declared in the procedure parameter
 list are not recognised go the reference gattr.typtr!!!?bug in loadaddress
 so here is a temp patch NOT NEEDED FOR I.5    L.B.}
   i : integer;         {patch for str}
 
Begin
    If Interlist and list_open then begin
        s := 'Unknown';
        if fbyte <= 127 Then begin
            s := 'SLDC';
            i := fbyte {str(fbyte,t)} ;
            str(i,t);
            s := concat(s,t);
        End
        Else Begin
                   If Fbyte in [128..169] then Fbyte1(fbyte,s)
              else if fbyte in [170..212] then Fbyte2(fbyte,s)
              else if fbyte in [213..255] then Fbyte3(fbyte,s);
        End;
        while length(s) < 10 do
            s := concat(s,' ');
        Write(listfile,s);
    End;
    CODEP^[IC] := CHR(FBYTE);
    IC := IC+1
End;

 

(*
 *      Load a constant onto the stack use the short or long form 
 *      as appropriate.
 *)
PROCEDURE GENLDC(ival : integer);
BEGIN
    istart;
    IF (IVAL >= 0) AND (IVAL <= 127) THEN
        GENop(IVAL)
    ELSE BEGIN
        GENop(71(*LDCI*)+128);
        {Note that I.5 had --> GENBYTE(51(*LDC*)+148);}
        MOVE{LEFT}(IVAL,CODEP^[IC],2);
        If flipsex then flipbufword;
        If Interlist and list_open then
            Writeln(listfile,ival:8);
        IC := IC+2;
    END;
    istop;
END (*GENLDC*) ;
  
  
  PROCEDURE GENBIG(IVAL: INTEGER);
    VAR LOWORDER: CHAR;
  BEGIN
    IF IVAL <= 127 THEN GENBYTE(IVAL)
    ELSE
      BEGIN MOVE{LEFT}(IVAL,CODEP^[IC],2);
        If flipsex then flipbufword;
        LOWORDER := CODEP^[IC];
        CODEP^[IC] := CHR(ORD(CODEP^[IC+1])+128);
        CODEP^[IC+1] := LOWORDER; 
        If Interlist and list_open then begin
          Write(listfile,ord(CODEP^[IC]):4);
          Write(listfile,ord(CODEP^[IC+1]):4);
        End;
        IC := IC+2
      END
  END (*GENBIG*) ;

  PROCEDURE GEN0(FOP: OPRANGE);
    VAR I: INTEGER;
  BEGIN
    istart;
    GENop(FOP+128);{Genop}
    IF FOP = 38(*LCA*) THEN
      WITH GATTR.CVAL.VALP^ DO
        BEGIN GENBYTE(SLGTH);
          FOR I := 1 TO SLGTH DO GENBYTE(ORD(SVAL[I]))
        END;
    istop;
  END (*GEN0*) ;

  PROCEDURE GEN1(FOP: OPRANGE; FP2: INTEGER);
    LABEL 1,2;
    VAR I,J: INTEGER;
        ival : integer;
    
  BEGIN
    istart;
    if ((fop = 74(*LDL*)) or (fop = 39(*LDO*))) and (FP2 <= 16)
      then goto 1; {cure LDO/SLDO bug}
    if (fop = 35(*IND*)) and (FP2 <= 7)
      then goto 1; {similar for IND}

    GENop(FOP+128);   {GENop} {?? not present in 1.3??}
  
  1: {goto here instead of genop followed by backtrack later}
    
    IF FOP = 51(*LDC*) THEN
      BEGIN
        IF FP2 = 2 THEN
          I := REALSIZE
        ELSE
          BEGIN I := 8;
            WHILE I > 0 DO
              IF GATTR.CVAL.VALP^.CSTVAL[I] <> 0 THEN GOTO 2
              ELSE I := I - 1;
      2:  END;
        GATTR.TYPTR^.SIZE := I;
        IF I > 1 THEN
          BEGIN 
          {done in 2nd line of proc GENop(FOP+128);}
          GENBYTE(I);
            FOR J := I DOWNTO 1 DO GENWORD(GATTR.CVAL.VALP^.CSTVAL[J])
          END
        ELSE
          BEGIN IC := IC - 1;
            {1.3 differs here... mark has made a change. Why?}
            IF I = 1 THEN GENLDC(GATTR.CVAL.VALP^.CSTVAL[1])
          END
      END {fop=51(LDC)}
    ELSE
      IF FOP IN [30(*CSP*),32(*ADJ*),45(*RNP*),
                 46(*CIP*),60(*LDM*),61(*STM*),
                 65(*RBP*),66(*CBP*),78(*CLP*),
                 42(*SAS*),79(*CGP*)] THEN GENBYTE(FP2)
      ELSE
        IF INMODULE AND (FOP IN [37(*LAO*),39(*LDO*),43(*SRO*)])
         THEN
          BEGIN
          LINKERREF(ACTUALVARS,FP2,IC);
          GENBYTE(128);
          GENBYTE(0)
          END
        ELSE
          IF ((FOP = 74(*LDL*)) OR (FOP = 39(*LDO*)))
              AND (FP2 <= 16) THEN
            BEGIN {IC := IC-1;}
            {possible LDO instead of SLDO bug L.B. 25/2/88}
            
              IF FOP = 39(*LDO*) THEN
                {GENBYTE} genop(231+FP2) {was genop}
              ELSE {GENBYTE} genop(215+FP2) {was genop}
            END
          ELSE
            IF (FOP = 35(*IND*)) AND (FP2 <= 7) THEN
              BEGIN
                {IC := IC-1;} {no need to backtrack after goto 1}
                GENop {GENbyte}(248+FP2) {Changed from Genop}
              END 
            ELSE
              GENBIG(FP2);
    istop;
  END (*GEN1*) ;

  PROCEDURE GEN2(FOP: OPRANGE; FP1,FP2: INTEGER);
  BEGIN
    IF (FOP = 64(*IXP*)) OR (FOP = 77(*CXP*)) THEN
      BEGIN
        istart;
        GENop(FOP+128); GENBYTE(FP1); GENBYTE(FP2);
        istop;
      END
          ELSE
      IF FOP IN [47(*EQU*),48(*GEQ*),49(*GRT*),
                 52(*LEQ*),53(*LES*),55(*NEQ*)] THEN
        IF FP1 = 0 THEN GEN0(FOP+20)
        ELSE
          BEGIN
            istart;
            GEN1(FOP,FP1+FP1);
        (*---mf should be equivalent..rep by nxt 2 lines
            
     {BUG BUG BUG then next two lines generate invalid code for
      byte array compare eg EQU 13 08 instead of EQU 10 08
      so I have altered mark's patch             LB}
            {Genop(128+fop);
            GenBig(fp1+fp2);}
            {here is patch}
            Genop(128+fop);
            GenBig(fp1+fp1);    {Bug fix LB}
            *)
            IF FP1 > 4 THEN GENBIG(FP2);
            istop;
          END
      ELSE
        BEGIN (*LDA,LOD,STR*)
          IF FP1 = 0 THEN GEN1(FOP+20,FP2)
          ELSE
            BEGIN
              istart;
              GENop(FOP+128); GENBYTE(FP1); GENBIG(FP2);
              istop;
            END
        END;
  END (*GEN2*) ;

  PROCEDURE GENNR(EXTPROC: NONRESIDENT);
  
   PROCEDURE ASSIGN(EXTPROC: NONRESIDENT);
   BEGIN
     PROCTABLE[NEXTPROC] := 0;
     PFNUMOF[EXTPROC] := NEXTPROC; NEXTPROC := NEXTPROC + 1;
     IF NEXTPROC > MAXPROCNUM THEN
       ERROR(193);(*NOT ENOUGH ROOM FOR THIS OPERATION*)
     CLINKERINFO := TRUE
   END (*ASSIGN*) ;
      
  BEGIN (*GENNR*)
    IF PFNUMOF[EXTPROC] = 0 THEN ASSIGN(EXTPROC);
    IF SEPPROC THEN
      BEGIN
        GEN1(79(*CGP*),0);
        LINKERREF(PROC,-PFNUMOF[EXTPROC],IC-1)
      END
    ELSE
      GEN1(79(*CGP*),PFNUMOF[EXTPROC]);
  END (*GENNR*) ;
    
  PROCEDURE GENJMP(FOP: OPRANGE; FLBP: LBP);
    VAR DISP: INTEGER;
  BEGIN
    WITH FLBP^ DO
      IF DEFINED THEN
        BEGIN
          istart;
          GENop(FOP+128);
          DISP := OCCURIC-IC-1;
          IF (DISP >= 0) AND (DISP <= 127) THEN GENBYTE(DISP)
          ELSE
            BEGIN
              IF JTABINX = 0 THEN
                BEGIN JTABINX := NEXTJTAB;
                  IF NEXTJTAB = MAXJTAB THEN
                    Begin
                    ERROR(253);
                    Writeln('Maxjtab overflow');
                    end
                  ELSE NEXTJTAB := NEXTJTAB + 1;
                  JTAB[JTABINX] := OCCURIC
                END;
              DISP := -JTABINX;
              GENBYTE(248-JTABINX-JTABINX)
            END;
            istop;
        END
      ELSE
        BEGIN MOVE{LEFT}(REFLIST,CODEP^[IC],2);
          {If flipsex then flipbufword;}
          IF FOP = 57(*UJP*) THEN DISP := IC + 4096
          ELSE DISP := IC;
          REFLIST := DISP; IC := IC+2
        END;
  END (*GENJMP*) ;

  PROCEDURE LOAD; FORWARD;

  PROCEDURE GENFJP(FLBP: LBP);
  BEGIN LOAD;
    IF GATTR.TYPTR <> BOOLPTR THEN ERROR(135);
    GENJMP(33(*FJP*),FLBP)
  END (*GENFJP*) ;

  PROCEDURE GENLABEL(VAR FLBP: LBP);
  BEGIN NEW(FLBP);
    WITH FLBP^ DO
      BEGIN DEFINED := FALSE; REFLIST := MAXADDR END
  END (*GENLABEL*) ;

  PROCEDURE PUTLABEL(FLBP: LBP);
    VAR LREF: INTEGER; LOP: OPRANGE;
  BEGIN
    WITH FLBP^ DO
      BEGIN LREF := REFLIST;
        DEFINED := TRUE; OCCURIC := IC; JTABINX := 0;
        WHILE LREF < MAXADDR DO
          BEGIN
            IF LREF >= 4096 THEN
              BEGIN LREF := LREF - 4096; LOP := 57(*UJP*) END
            ELSE LOP := 33(*FJP*);
            IC := LREF;
            MOVE{LEFT}(CODEP^[IC],LREF,2);
            {If flipsex then flipbufword;}
            GENJMP(LOP,FLBP)
          END;
        IC := OCCURIC
      END
  END (*PUTLABEL*) ;

PROCEDURE LOAD;
VAR J,M: INTEGER;
BEGIN
  WITH GATTR DO
    IF TYPTR <> NIL THEN
      BEGIN
      CASE KIND OF
	CST:   IF TYPTR^.FORM = LONGINTs THEN
		 WITH GATTR.CVAL.VALP^ DO
		   BEGIN
		   M := 10000;
		   GENLDC(LONGVAL[1]); GENLDC(1);
		   FOR J := 2 TO LLENG DO
		     BEGIN
		     IF J = LLENG THEN M := TRUNC(PWROFTEN(LLAST));
		     GENLDC(M); GENLDC(1);
		     GENLDC(8(*DMP*));
                     {
                     GENNR(DECOPS);
                     }
                     gen2(77(*cxp*),0(*sys*),49(*decops*)); {/pc157a}
		     GENLDC(LONGVAL[J]); GENLDC(1);
		     GENLDC(2(*DAD*));
                     {
                     GENNR(DECOPS)
                     }
                     gen2(77(*cxp*),0(*sys*),49(*decops*)); {/pc157a}
		     END
		   END
		 ELSE
		 IF (TYPTR^.FORM = SCALAR) AND (TYPTR <> REALPTR) THEN
		     GENLDC(CVAL.IVAL)
		 ELSE
		 IF TYPTR = NILPTR THEN GEN0(31(*LDCN*))
		 ELSE
		 IF TYPTR = REALPTR THEN GEN1(51(*LDC*),2)
                 ELSE GEN1(51(*LDC*),5);
	VARBL: CASE ACCESS OF
                 DRCT:   IF VLEVEL = 1 THEN GEN1(39(*LDO*),DPLMT)
		           ELSE GEN2(54(*LOD*),LEVEL-VLEVEL,DPLMT);
                 INDRCT: GEN1(35(*IND*),IDPLMT);
		 PACKD:  GEN0(58(*LDP*));
		 MULTI:  GEN1(60(*LDM*),TYPTR^.SIZE);
		 BYTE:   GEN0(62(*LDB*))
		 END;
	EXPR:
	END;
	WITH TYPTR^ DO
	  IF ((FORM = POWER) OR
	     (FORM = LONGINTs) AND (KIND <> CST))
	     AND (KIND <> EXPR) THEN GENLDC(TYPTR^.SIZE);
	KIND := EXPR
      END
END (*LOAD*) ;

  PROCEDURE STORE(VAR FATTR: ATTR);
  BEGIN
    WITH FATTR DO
      IF TYPTR <> NIL THEN
        CASE ACCESS OF
          DRCT:   IF VLEVEL = 1 THEN GEN1(43(*SRO*),DPLMT)
                  ELSE GEN2(56(*STR*),LEVEL-VLEVEL,DPLMT);
          INDRCT: IF IDPLMT <> 0 THEN ERROR(400)
                  ELSE GEN0(26(*STO*));
          PACKD:  GEN0(59(*STP*));
          MULTI:  GEN1(61(*STM*),TYPTR^.SIZE);
          BYTE:   GEN0(63(*STB*))
        END
  END (*STORE*) ;

  PROCEDURE LOADADDRESS;
  BEGIN
    WITH GATTR DO
      IF TYPTR <> NIL THEN
        BEGIN
          CASE KIND OF
            CST:   IF STRGTYPE(TYPTR) THEN GEN0(38(*LCA*))
                   ELSE ERROR(400);
            VARBL: CASE ACCESS OF
                     DRCT:   IF VLEVEL = 1 THEN GEN1(37(*LAO*),DPLMT)
                                ELSE GEN2(50(*LDA*),LEVEL-VLEVEL,DPLMT);
                     INDRCT: IF IDPLMT <> 0 THEN GEN1(34(*INC*),IDPLMT+IDPLMT);
                     PACKD:  ERROR(103)
                   END
          END;
          KIND := VARBL; ACCESS := INDRCT; IDPLMT := 0
        END
  END (*LOADADDRESS*) ;

  PROCEDURE EXPRESSION(FSYS: SETOFSYS); FORWARD;

  PROCEDURE SELECTOR(FSYS: SETOFSYS; FCP: CTP);
    VAR LATTR: ATTR; LCP: CTP; LMIN,LMAX: INTEGER;
  BEGIN
    WITH FCP^, GATTR DO
      BEGIN TYPTR := IDTYPE; KIND := VARBL;
        CASE KLASS OF
          ACTUALVARS:
            BEGIN VLEVEL := VLEV; DPLMT := VADDR; ACCESS := DRCT;
              IF INMODULE THEN
                IF TYPTR <> NIL THEN
                  IF (VLEV = 1) AND (TYPTR^.FORM = RECORDS) THEN LOADADDRESS
            END;
          FORMALVARS:
            BEGIN
              IF VLEV = 1 THEN GEN1(39(*LDO*),VADDR)
              ELSE GEN2(54(*LOD*),LEVEL-VLEV,VADDR);
              ACCESS := INDRCT; IDPLMT := 0
            END;
          FIELD:
            WITH DISPLAY[DISX] DO
             BEGIN
              IF OCCUR = CREC THEN
                BEGIN ACCESS := DRCT; VLEVEL := CLEV;
                  DPLMT := CDSPL + FLDADDR
                END
              ELSE
                BEGIN
                  IF LEVEL = 1 THEN GEN1(39(*LDO*),VDSPL)
                  ELSE GEN2(54(*LOD*),0,VDSPL);
                  ACCESS := INDRCT; IDPLMT := FLDADDR
                END;
              IF FISPACKD THEN
                BEGIN LOADADDRESS;
                  IF ((FLDRBIT = 0) OR (FLDRBIT = 8))
                          AND (FLDWIDTH = 8) THEN
                    BEGIN ACCESS := BYTE;
                        IF FLDRBIT = 8 THEN GEN1(34(*INC*),1)
                    END
                  ELSE
                    BEGIN ACCESS := PACKD;
                        GENLDC(FLDWIDTH); GENLDC(FLDRBIT)
                    END
                END
             END;
          FUNC:
            IF PFDECKIND <> DECLARED THEN ERROR(150)
            ELSE
              IF NOT INSCOPE THEN ERROR(103)
              ELSE
                  BEGIN
                  ACCESS := DRCT;
                  VLEVEL := PFLEV + 1;
                  DPLMT := LCAFTERMARKSTACK
                  END
        END (*CASE*);
        IF TYPTR <> NIL THEN
          IF (TYPTR^.FORM <= POWER) AND
             (TYPTR^.SIZE > PTRSIZE) THEN
            BEGIN LOADADDRESS; ACCESS := MULTI END
      END (*WITH*);
    IF NOT (SY IN SELECTSYS + FSYS) THEN
      BEGIN ERROR(59); SKIP(SELECTSYS + FSYS) END;
    WHILE SY IN SELECTSYS DO
      BEGIN
  (*[*) IF SY = LBRACK THEN
          BEGIN
            REPEAT LATTR := GATTR;
              WITH LATTR DO
                IF TYPTR <> NIL THEN
                  IF TYPTR^.FORM <> ARRAYS THEN
                    BEGIN ERROR(138); TYPTR := NIL END;
              LOADADDRESS;
              INSYMBOL;
              EXPRESSION(FSYS + [COMMA,RBRACK]);
              LOAD;
              IF GATTR.TYPTR <> NIL THEN
                IF GATTR.TYPTR^.FORM <> SCALAR THEN ERROR(113);
              IF LATTR.TYPTR <> NIL THEN
                WITH LATTR.TYPTR^ DO
                  BEGIN
                    IF COMPTYPES(INXTYPE,GATTR.TYPTR) THEN
                        BEGIN
                        IF (INXTYPE <> NIL) AND
                            NOT STRGTYPE(LATTR.TYPTR) THEN
                          BEGIN GETBOUNDS(INXTYPE,LMIN,LMAX);
                            IF RANGECHECK THEN
                                 BEGIN GENLDC(LMIN); GENLDC(LMAX);
                                GEN0(8(*CHK*))
                                 END;
                            IF LMIN <> 0 THEN
                                 BEGIN GENLDC(ABS(LMIN));
                                IF LMIN > 0 THEN GEN0(21(*SBI*))
                                ELSE GEN0(2(*ADI*))
                                 END
                          END
                        END
                    ELSE ERROR(139);
                    WITH GATTR DO
                        BEGIN TYPTR := AELTYPE; KIND := VARBL;
                        ACCESS := INDRCT; IDPLMT := 0;
                        IF TYPTR <> NIL THEN
                          IF AISPACKD THEN
                            IF ELWIDTH = 8 THEN
                                 BEGIN ACCESS := BYTE;
                                IF STRGTYPE(LATTR.TYPTR) AND RANGECHECK THEN
                                  GEN0(27(*IXS*))
                                ELSE GEN0(2(*ADI*))
                                 END
                            ELSE
                                 BEGIN ACCESS := PACKD;
                                GEN2(64(*IXP*),ELSPERWD,ELWIDTH)
                                 END
                          ELSE
                            BEGIN GEN1(36(*IXA*),TYPTR^.SIZE);
                                 IF (TYPTR^.FORM <= POWER) AND
                                 (TYPTR^.SIZE > PTRSIZE) THEN
                                ACCESS := MULTI
                            END
                        END
                  END
            UNTIL SY <> COMMA;
            IF SY = RBRACK THEN INSYMBOL ELSE ERROR(12)
          END (*IF SY = LBRACK*)
        ELSE
  (*.*)   IF SY = PERIOD THEN
            BEGIN
              WITH GATTR DO
                BEGIN
                  IF TYPTR <> NIL THEN
                    IF TYPTR^.FORM <> RECORDS THEN
                        BEGIN ERROR(140); TYPTR := NIL END;
                  INSYMBOL;
                  IF SY = IDENT THEN
                    BEGIN
                        IF TYPTR <> NIL THEN
                        BEGIN SEARCHSECTION(TYPTR^.FSTFLD,LCP);
                          IF LCP = NIL THEN
                            BEGIN ERROR(152); TYPTR := NIL END
                          ELSE
                            WITH LCP^ DO
                                 BEGIN TYPTR := IDTYPE;
                                CASE ACCESS OF
                                  DRCT:   DPLMT := DPLMT + FLDADDR;
                                  INDRCT: IDPLMT := IDPLMT + FLDADDR;
                                  MULTI,BYTE,
                                  PACKD:  ERROR(400)
                                END (*CASE ACCESS*);
                                IF FISPACKD THEN
                                  BEGIN LOADADDRESS;
                                        IF ((FLDRBIT = 0) OR (FLDRBIT = 8))
                                        AND (FLDWIDTH = 8) THEN
                                          BEGIN ACCESS := BYTE;
                                        IF FLDRBIT = 8 THEN GEN1(34(*INC*),1)
                                          END
                                        ELSE
                                          BEGIN ACCESS := PACKD;
                                        GENLDC(FLDWIDTH); GENLDC(FLDRBIT)
                                          END
                                  END;
                                IF TYPTR <> NIL THEN
                                  IF (TYPTR^.FORM <= POWER) AND
                                         (TYPTR^.SIZE > PTRSIZE) THEN
                                        BEGIN LOADADDRESS; ACCESS := MULTI END
                                 END
                        END;
                        INSYMBOL
                    END (*SY = IDENT*)
                  ELSE ERROR(2)
                END (*WITH GATTR*)
            END (*IF SY = PERIOD*)
          ELSE
  (*^*)     BEGIN
              IF GATTR.TYPTR <> NIL THEN
                WITH GATTR,TYPTR^ DO
                  IF (FORM = POINTERs) OR (FORM = FILES) THEN   {/tp3}
                    BEGIN
                    LOAD;
                    KIND := VARBL;
                    ACCESS := INDRCT;
                    IDPLMT := 0;
                    IF FORM = POINTERs THEN    {/tp3}
                      TYPTR := ELTYPE
                    ELSE
                      BEGIN
                      TYPTR := FILTYPE;
                      IF TYPTR = NIL THEN ERROR(399)
                      END;
                    IF TYPTR <> NIL THEN
                      IF (TYPTR^.FORM <= POWER) AND
                           (TYPTR^.SIZE > PTRSIZE) THEN
                        ACCESS := MULTI
                    END
                  ELSE ERROR(141);
              INSYMBOL
            END;
        IF NOT (SY IN FSYS + SELECTSYS) THEN
          BEGIN ERROR(6); SKIP(FSYS + SELECTSYS) END
      END (*WHILE*)
  END (*SELECTOR*) ;

