unit cmpinit;     (* for DOS I.5 cross-compiler*)
interface
uses globals,
     procs,
     crt;  {only for readkey}

PROCEDURE COMPINIT;



implementation





PROCEDURE COMPINIT;

PROCEDURE ENTSTDTYPES;
BEGIN
  NEW(INTPTR);{,SCALAR,STANDARD);}
  WITH INTPTR^ DO
    BEGIN SIZE := INTSIZE; FORM := SCALAR; SCALKIND := STANDARD END;
  NEW(REALPTR);{,SCALAR,STANDARD);}
  WITH REALPTR^ DO
    BEGIN SIZE := REALSIZE; FORM := SCALAR; SCALKIND := STANDARD END;
  NEW(LONGINTPTR);{,LONGINT);}
  WITH LONGINTPTR^ DO
    BEGIN SIZE := INTSIZE; FORM := LONGINTs END;
  NEW(CHARPTR);{,SCALAR,STANDARD);}
  WITH CHARPTR^ DO
    BEGIN SIZE := CHARSIZE; FORM := SCALAR; SCALKIND := STANDARD END;
  NEW(BOOLPTR);{,SCALAR,DECLARED);}
  WITH BOOLPTR^ DO
    BEGIN SIZE := BOOLSIZE; FORM := SCALAR; SCALKIND := DECLARED END;
  NEW(NILPTR);{,POINTER);}
  WITH NILPTR^ DO
    BEGIN
    SIZE := PTRSIZE;
    FORM := POINTERs;    {/tp3}
    ELTYPE := pNIL
    END;
  new(ptrptr{,ppointer});   {today}
  with ptrptr^ do
    begin size := ptrsize; form := pointers; eltype := nil end;
  NEW(TEXTPTR);{,FILES);}
  WITH TEXTPTR^ DO
    BEGIN SIZE := FILESIZE+CHARSIZE; FORM := FILES; FILTYPE := CHARPTR END;
  NEW(INTRACTVPTR);{,FILES);}
  WITH INTRACTVPTR^ DO
    BEGIN SIZE := FILESIZE+CHARSIZE; FORM := FILES; FILTYPE := CHARPTR END;
  NEW(STRGPTR);{,ARRAYS,TRUE,TRUE);}
  WITH STRGPTR^ DO
    BEGIN FORM := ARRAYS; SIZE := (DEFSTRGLGTH + CHRSPERWD) DIV CHRSPERWD;
      AISPACKD := TRUE; AISSTRNG := TRUE; INXTYPE := INTPTR;
      ELWIDTH := BITSPERCHR; ELSPERWD := CHRSPERWD;
      AELTYPE := CHARPTR; MAXLENG := DEFSTRGLGTH;
    END
  {;writeln('leaving  entstdtypes');}  {patch /tp3}
END (*ENTSTDTYPES*) ;

PROCEDURE ENTSTDNAMES;
  VAR CP,CP1: CTP; I: INTEGER;
BEGIN
  {writeln('entering entstdnames');writeln(memavail);}  {patch /tp3}
  new(cp{,types});  {today}
  with cp^ do
    begin name := 'POINTER '; idtype := ptrptr; klass := types end;
  enterid(cp);
  NEW(CP);{,TYPES);}
  WITH CP^ DO
    BEGIN NAME := 'INTEGER '; IDTYPE := INTPTR; KLASS := TYPES END;
  ENTERID(CP);
  NEW(CP);{,TYPES);}
  WITH CP^ DO
    BEGIN NAME := 'REAL    '; IDTYPE := REALPTR; KLASS := TYPES END;
  ENTERID(CP);
  NEW(CP);{,TYPES);}
  WITH CP^ DO
    BEGIN NAME := 'CHAR    '; IDTYPE := CHARPTR; KLASS := TYPES END;
  ENTERID(CP);
  NEW(CP);{,TYPES);}
  WITH CP^ DO
    BEGIN NAME := 'BOOLEAN '; IDTYPE := BOOLPTR; KLASS := TYPES END;
  ENTERID(CP);
  NEW(CP);{,TYPES);}
  WITH CP^ DO
    BEGIN NAME := 'STRING  '; IDTYPE := STRGPTR; KLASS := TYPES END;
  ENTERID(CP);
  NEW(CP);{,TYPES);}
  WITH CP^ DO
    BEGIN NAME := 'TEXT    '; IDTYPE := TEXTPTR; KLASS := TYPES END;
  ENTERID(CP);
  NEW(CP);{,TYPES);}
  WITH CP^ DO
    BEGIN NAME := 'INTERACT'; IDTYPE := INTRACTVPTR; KLASS := TYPES END;
  ENTERID(CP);

  NEW(INPUTPTR);{,FORMALVARS,FALSE);}
  WITH INPUTPTR^ DO
    BEGIN
    NAME   := 'INPUT   ';
    IDTYPE := TEXTPTR;
    KLASS  := FORMALVARS;
    VLEV   := 0;
    VADDR  := 2
    END;
  ENTERID(INPUTPTR);

  NEW(OUTPUTPTR);{,FORMALVARS,FALSE);}
  WITH OUTPUTPTR^ DO
    BEGIN
    NAME   := 'OUTPUT  ';
    IDTYPE := TEXTPTR;
    KLASS  := FORMALVARS;
    VLEV   := 0;
    VADDR  := 3
    END;
  ENTERID(OUTPUTPTR);

  NEW(CP);{,FORMALVARS,FALSE);}
  WITH CP^ DO
    BEGIN
    NAME   := 'KEYBOARD';
    IDTYPE := TEXTPTR;
    KLASS  := FORMALVARS;
    VLEV   := 0;
    VADDR  := 4
    END;
  ENTERID(CP);
  CP1 := pNIL;
  FOR I := 0 TO 1 DO
    BEGIN NEW(CP);{,KONST);}
    WITH CP^ DO
      BEGIN
      IDTYPE := BOOLPTR;
      IF I = 0 THEN NAME := 'FALSE   '
	ELSE NAME := 'TRUE    ';
      NEXT  := CP1;
      VALUES.IVAL := I;      {warning the pcode ver of compiler has $FFFF for true}
                             {26/12/96 now changed to $0001 see bug 18}
      KLASS := KONST
      END;
    ENTERID(CP); CP1 := CP
    END;
  BOOLPTR^.FCONST := CP;

  NEW(CP);{,KONST);}
  WITH CP^ DO
    BEGIN
    NAME   := 'NIL     ';
    IDTYPE := NILPTR;
    NEXT   := pNIL;
    VALUES.IVAL := 0;     {bug @@ 1 or 0?}  {/pc157=0}
    KLASS  := KONST
    END;
  ENTERID(CP);
  NEW(CP);{,KONST);}
  WITH CP^ DO
    BEGIN
    NAME   := 'MAXINT  ';
    IDTYPE := INTPTR;
    KLASS  := KONST;
    VALUES.IVAL := MAXINT
    END;
  ENTERID(CP);
{writeln('leaving  entstdnames');}    {patch /tp3}
END (*ENTSTDNAMES*) ;

PROCEDURE ENTUNDECL;
BEGIN
  {writeln('entering entundecl  ');writeln(memavail);}  {patch /tp3}
NEW(UTYPPTR);{,TYPES);}
  WITH UTYPPTR^ DO
    BEGIN
    NAME   := '        ';
    IDTYPE := pNIL;
    KLASS  := TYPES
    END;
  NEW(UCSTPTR);{,KONST);}
  WITH UCSTPTR^ DO
    BEGIN
    NAME   := '        ';
    IDTYPE := pNIL;
    NEXT   := pNIL;
    VALUES.IVAL := 0;
    KLASS  := KONST
    END;
  NEW(UVARPTR);{,ACTUALVARS,FALSE);}
  WITH UVARPTR^ DO
    BEGIN
    NAME   := '        ';
    IDTYPE := pNIL;
    NEXT   := pNIL;
    VLEV   := 0;
    VADDR  := 0;
    KLASS  := ACTUALVARS
    END;
  NEW(UFLDPTR);{,FIELD);}
  WITH UFLDPTR^ DO
    BEGIN
    NAME   := '        ';
    IDTYPE := pNIL;
    NEXT   := pNIL;
    FLDADDR:= 0;
    KLASS  := FIELD
    END;
  NEW(UPRCPTR);{,PROC,DECLARED,ACTUAL,FALSE);}
  WITH UPRCPTR^ DO
    BEGIN
    NAME   := '        ';
    IDTYPE := pNIL;
    FORWDECL := FALSE;
    NEXT   := pNIL;
    INSCOPE:= FALSE;
    LOCALLC:= 0;
    EXTURNAL := FALSE;
    PFLEV  := 0;
    PFNAME := 0;
    PFSEG  := 0;
    KLASS  := PROC;
    PFDECKIND := DECLARED;
    PFKIND := ACTUAL
    END;
  NEW(UFCTPTR);{,FUNC,DECLARED,ACTUAL,FALSE);}
  WITH UFCTPTR^ DO
    BEGIN
    NAME   := '        ';
    IDTYPE := pNIL;
    NEXT   := pNIL;
    FORWDECL := FALSE;
    EXTURNAL := FALSE;
    INSCOPE:= FALSE;
    LOCALLC:= 0;
    PFLEV  := 0;
    PFNAME := 0;
    PFSEG  := 0;
    KLASS  := FUNC;
    PFDECKIND := DECLARED;
    PFKIND := ACTUAL
    END
{;writeln('leaving  entundecl  ');}   {patch /tp3}
END (*ENTUNDECL*) ;

PROCEDURE ENTSPCPROCS;
LABEL 1;
Const NumProcs = 55;        {3/10/95}
VAR LCP: CTP; I: INTEGER; ISFUNC: BOOLEAN;
    NA: ARRAY [1..{50} NumProcs{3/10/95}] OF ALPHA; {/pc157}   {bug..if 48..not range error!}

BEGIN
  {writeln('entering entspcprocs');writeln(memavail);}  {patch /tp3}
  NA[ 1] := 'READ    ';
  NA[ 2] := 'READLN  ';
  NA[ 3] := 'WRITE   ';
  NA[ 4] := 'WRITELN ';
  NA[ 5] := 'EOF     ';
  NA[ 6] := 'EOLN    ';
  NA[ 7] := 'PRED    ';
  NA[ 8] := 'SUCC    ';
  NA[ 9] := 'ORD     ';
  NA[10] := 'SQR     ';
  NA[11] := 'ABS     ';
  NA[12] := 'NEW     ';
  NA[13] := 'UNITREAD';
  NA[14] := 'UNITWRIT';
  NA[15] := 'CONCAT  ';
  NA[16] := 'LENGTH  ';
  NA[17] := 'INSERT  ';
  NA[18] := 'DELETE  ';
  NA[19] := 'COPY    ';
  NA[20] := 'POS     ';
  NA[21] := 'MOVELEFT';
  NA[22] := 'MOVERIGH';
  NA[23] := 'EXIT    ';
  NA[24] := 'IDSEARCH';
  NA[25] := 'TREESEAR';
  NA[26] := 'TIME    ';
  NA[27] := 'FILLCHAR';
  NA[28] := 'OPENNEW ';
  NA[29] := 'OPENOLD ';
  NA[30] := 'REWRITE ';
  NA[31] := 'CLOSE   ';
  NA[32] := 'SEEK    ';
  NA[33] := 'RESET   ';
  NA[34] := 'GET     ';
  NA[35] := 'PUT     ';
  NA[36] := 'SCAN    ';
  NA[37] := 'BLOCKREA';
  NA[38] := 'BLOCKWRI';
  NA[39] := 'TRUNC   ';
  NA[40] := 'PAGE    ';
  NA[41] := 'SIZEOF  ';
  NA[42] := 'STR     ';
  NA[43] := 'GOTOXY  ';
  NA[44] := 'PMACHINE';
  na[45] := 'ADDR    ';
  na[46] := 'MSDOS   ';
  na[47] := 'INTR    ';
  na[48] := 'DISPOSE ';
  na[49] := 'GETMEM  ';
  na[50] := 'FREEMEM ';
  na[51] := 'CONTINUE';
  na[52] := 'BREAK   ';  {15/1/95}
    na[53] := '        ';          {unused so 54/55 same as interp csp 54 and csp 55}
    na[54] := 'INC     '; na[55] := 'DEC     ';  {3/10/95}


  FOR I := 1 TO {50} NumProcs{3/10/95} DO {/pc157}
    BEGIN
      IF TINY THEN  {if tiny, allow readln       L.B.}
	  IF I IN [{2,}7,8,10,13,17,18,19,20,32,34,35,40,42,43] THEN
	    GOTO 1;
      ISFUNC := I IN [5,6,7,8,9,10,11,15,16,19,20,25,36,37,38,39,41,45];
      IF ISFUNC THEN NEW(LCP) {,FUNC,SPECIAL)}
      ELSE NEW(LCP);{,PROC,SPECIAL);}
      WITH LCP^ DO
	BEGIN
	NAME := NA[I];
	NEXT := pNIL;
	IDTYPE := pNIL;
	IF ISFUNC THEN KLASS := FUNC ELSE KLASS := PROC;
	PFDECKIND := SPECIAL;
	KEY := I
	END;
      ENTERID(LCP);
1:    END
END (*ENTSPCPROCS*) ;

PROCEDURE ENTSTDPROCS;
  VAR LCP,PARAM: CTP; LSP,FTYPE: STP; I: INTEGER; ISPROC: BOOLEAN;
      NA: ARRAY [1..19] OF ALPHA;
BEGIN
  NA[ 1]:= 'ODD     '; NA[ 2]:= 'CHR     '; NA[ 3]:= 'MEMAVAIL';
  NA[ 4]:= 'ROUND   '; NA[ 5]:= 'SIN     '; NA[ 6]:= 'COS     ';
  NA[ 7]:= 'LOG     '; NA[ 8]:= 'ATAN    '; NA[ 9]:= 'LN      ';
  NA[10]:= 'EXP     '; NA[11]:= 'SQRT    '; NA[12]:= 'MARK    ';
  NA[13]:= 'RELEASE '; NA[14]:= 'IORESULT'; NA[15]:= 'UNITBUSY';
  NA[16]:= 'PWROFTEN'; NA[17]:= 'UNITWAIT'; NA[18]:= 'UNITCLEA';
  NA[19]:= 'HALT    ';
  FOR I := 1 TO 19 DO
    BEGIN ISPROC := I IN [12,13,17,18,19];
      CASE I OF
	1:  BEGIN
	    FTYPE := BOOLPTR;
	    NEW(PARAM);{,ACTUALVARS,FALSE);}
	    WITH PARAM^ DO
	      BEGIN
	      IDTYPE := INTPTR;
	      KLASS := ACTUALVARS
	      END
	    END;
	2:  FTYPE := CHARPTR; {care..Param set by line above}
	3:  BEGIN
	    FTYPE := INTPTR;
	    PARAM := pNIL
	    END;
	4:  BEGIN
	    FTYPE := INTPTR;
	    NEW(PARAM);{,ACTUALVARS,FALSE);}
	    WITH PARAM^ DO
	      BEGIN IDTYPE := REALPTR;
	      KLASS := ACTUALVARS
	      END
	    END;
	5:  FTYPE := REALPTR;
       12:  BEGIN
	    FTYPE := pNIL;
	    NEW(PARAM);{,FORMALVARS,FALSE);}
	    NEW(LSP);{,POINTER);}
	    WITH LSP^ DO
	      BEGIN
	      SIZE := PTRSIZE;
	      FORM := POINTERs;    {/tp3}
	      ELTYPE := pNIL
	      END;
	    WITH PARAM^ DO
	      BEGIN IDTYPE := LSP;
	      KLASS := FORMALVARS
	      END
	    END;
       14:  BEGIN
	    FTYPE := INTPTR;
	    PARAM := pNIL
	    END;
       15:  BEGIN
	    FTYPE := BOOLPTR;
	    NEW(PARAM);{,ACTUALVARS,FALSE);}
	    WITH PARAM^ DO
	      BEGIN
	      IDTYPE := INTPTR;
	      KLASS := ACTUALVARS
	      END;
	    END;
       16:  FTYPE := REALPTR;
       17:  FTYPE := pNIL;
       19:  BEGIN
	    FTYPE := pNIL;
	    PARAM := pNIL
	    END
      END (*PARAM AND TYPE CASES*) ;
      IF ISPROC THEN NEW(LCP) {,PROC,STANDARD)}
      ELSE NEW(LCP);{,FUNC,STANDARD);}
      WITH LCP^ DO
	BEGIN
	NAME := NA[I];
	PFDECKIND := STANDARD;
	CSPNUM := I + 20;
	IF ISPROC THEN KLASS := PROC ELSE KLASS := FUNC;
	IF PARAM <> pNIL THEN PARAM^.NEXT := pNIL;
	IDTYPE := FTYPE;
	NEXT := PARAM
	END;
      ENTERID(LCP)
    END
END (*ENTSTDPROCS*) ;

PROCEDURE INITSCALARS;
 VAR I: NONRESIDENT;
BEGIN
  FWPTR := pNIL;
  MODPTR := pNIL;
  GLOBTESTP := pNIL;
  symcursor := 1024;       {/tp4}   {start in middle of buffer}
  LINESTART := 1024;
  LINEINFO := LCAFTERMARKSTACK;
  LIST := FALSE;
			{ucsd skips first 2 blocks of text file}
  SYMBLK := {2}0;       {patch /tp4 0 for dos....2 for ucsd}
  SCREENDOTS := 0;
  STARTDOTS := 0;
  FOR SEG := 0 TO MAXSEG DO
    WITH SEGTABLE[SEG] DO
      BEGIN
      DISKADDR := 0;
      CODELENG := 0;
      SEGNAME := '        ';
      SEGKIND := 0;
      TEXTADDR := 0
      END;
  USINGLIST := pNIL;
  With Userinfo Do  {moved from init user info}
    Begin
    ERRSYM := 0; ERRBLK := 0; ERRNUM := 0;STUPID:= false;
    End;

  IF USERINFO.STUPID THEN
    SYSTEMLIB := '*SYSTEM.PASCAL'
  ELSE
    SYSTEMLIB := {'*SYSTEM.LIBRARY';} 'SYSTEM.LIB'; {/tp6}
  LC := LCAFTERMARKSTACK;
  IOCHECK := TRUE;
  DP := TRUE;
  SEGINX := 0;
  NEXTJTAB := 1;
  NEXTPROC := 2;
  CURPROC := 1;
  NEW(SCONST);
  NEW(SYMBUFP);

     {/tp4}
  fillchar(symbufp^,sizeof(symbufp^),chr(0));     {/tp4}


  NEW(CODEP);
  CLINKERINFO := FALSE;
  DLINKERINFO := FALSE;
  SEG := 1;
  NEXTSEG := 10;   {change later to 2}
  CURBLK := 1;
  CURBYTE := 0;
  LSEPPROC := FALSE;
  STARTINGUP := TRUE;
  {NOISY := NOT USERINFO.SLOWTERM;}
  noisy  := true;     {patch /tp3 I want output while developing}
  SEPPROC := FALSE;
  NOSWAP := TRUE;
  DEBUGGING := FALSE;
  BPTONLINE := FALSE;
  INMODULE := FALSE;
  GOTOOK := {FALSE} true;     {/tp5}   {default allows goto}
  RANGECHECK := TRUE;
  SYSCOMP := FALSE;
  TINY := FALSE;
  CODEINSEG := FALSE;
  PRTERR := TRUE;
  INCLUDING := FALSE;
  USING := FALSE;
  flipsex:=false;
  FOR I := fSEAK TO fDECOPS DO PFNUMOF[I] := 0;   {/pc157a}
  COMMENT := pNIL;
  LIBNOTOPEN := TRUE;
  GETSTMTLEV := TRUE;
  BEGSTMTLEV := 0;
  SpitInterFace := False;  {/pc157} {allow getnextpage to call writetext}



END (*INITSCALARS*) ;







PROCEDURE INITSETS;
BEGIN
  {writeln('entering initsets   ');writeln(memavail);}  {patch /tp3}
  CONSTBEGSYS   := [ADDOP,INTCONST,REALCONST,STRINGCONST,IDENT];
  SIMPTYPEBEGSYS:= [LPARENT] + CONSTBEGSYS;
  TYPEBEGSYS    := [ARROW,PACKEDSY,ARRAYSY,RECORDSY,SETSY,FILESY]
		    + SIMPTYPEBEGSYS;
  TYPEDELS      := [ARRAYSY,RECORDSY,SETSY,FILESY];
  BLOCKBEGSYS   := [USESSY,LABELSY,CONSTSY,TYPESY,VARSY,
		     PROCSY,FUNCSY,PROGSY,BEGINSY];
  SELECTSYS     := [ARROW,PERIOD,LBRACK];
  FACBEGSYS     := [INTCONST,REALCONST,LONGCONST,STRINGCONST,IDENT,
		    LPARENT,LBRACK,NOTSY];
  STATBEGSYS    := [BEGINSY,GOTOSY,IFSY,WHILESY,REPEATSY,FORSY,WITHSY,CASESY];
  VARS          := [FORMALVARS,ACTUALVARS]
{;writeln('leaving  initsets   ');}  {patch /tp3}
END (*INITSETS*) ;




Procedure InitIdTable;   {patch /tp3}
{I apologise for this proc but it had to be done very quickly LB}
{
TYPE
  t_tokenname = array[0..idnum] of alpha;
  t_tokentype = array[0..idnum] of symbol;
  t_optype    = array[0..idnum] of operator;
VAR
  tokenname : t_tokenname;
  tokentype : t_tokentype;
  optype    : t_optype;
}
Begin
tokenname[0] :='ABSOLUTE';  tokentype[0]:=absolutsy; optype[0]:=NOOP;{/pc157f}
tokenname[1] :='AND     ';  tokentype[1]:=MULOP;     optype[1]:=ANDop;
tokenname[2] :='ARRAY   ';  tokentype[2]:=ARRAYSY;   optype[2]:=NOOP;
tokenname[3] :='BEGIN   ';  tokentype[3]:=BEGINSY;   optype[3]:=NOOP;
tokenname[4] :='CASE    ';  tokentype[4]:=CASESY;    optype[4]:=NOOP;
tokenname[5] :='CONST   ';  tokentype[5]:=CONSTSY;   optype[5]:=NOOP;
tokenname[6] :='DIV     ';  tokentype[6]:=MULOP;     optype[6]:=IDIV;
tokenname[7] :='DO      ';  tokentype[7]:=DOSY;      optype[7]:=NOOP;
tokenname[8] :='DOWNTO  ';  tokentype[8]:=DOWNTOSY;  optype[8]:=NOOP;
tokenname[9] :='ELSE    ';  tokentype[9]:=ELSESY;    optype[9]:=NOOP;
tokenname[10]:='END     ';  tokentype[10]:=ENDSY;   optype[10]:=NOOP;
tokenname[11]:='EXTERNAL';{tokentype[11]:=EXTERNLSY;optype[11]:=NOOP;}
tokenname[12]:='FILE    '; tokentype[12]:=FILESY;   optype[12]:=NOOP;
tokenname[13]:='FOR     '; tokentype[13]:=FORSY;    optype[13]:=NOOP;
tokenname[14]:='FORWARD '; tokentype[14]:=FORWARDSY;optype[14]:=NOOP;
tokenname[15]:='FUNCTION'; tokentype[15]:=FUNCSY;   optype[15]:=NOOP;

tokenname[16]:='GOTO    '; tokentype[16]:=GOTOSY;   optype[16]:=NOOP;
tokenname[17]:='IF      '; tokentype[17]:=IFSY;     optype[17]:=NOOP;
tokenname[18]:='IMPLEMEN'; tokentype[18]:=IMPLESY;  optype[18]:=NOOP;
tokenname[19]:='IN      '; tokentype[19]:=RELOP;    optype[19]:=INOP;
tokenname[20]:='INTERFAC'; tokentype[20]:=INTERFCESY;optype[20]:=NOOP;
tokenname[21]:='LABEL   '; tokentype[21]:=LABELSY;  optype[21]:=NOOP;

tokenname[22]:='MOD     '; tokentype[22]:=MULOP;    optype[22]:=IMOD;
tokenname[23]:='NOT     '; tokentype[23]:=NOTSY;    optype[23]:=MUL;
tokenname[24]:='OF      '; tokentype[24]:=OFSY;     optype[24]:=NOOP;
tokenname[25]:='OR      '; tokentype[25]:=ADDOP;    optype[25]:=OROP;

tokenname[26]:='PACKED  '; tokentype[26]:=PACKEDSY; optype[26]:=NOOP;
tokenname[27]:='PROCEDUR'; tokentype[27]:=PROCSY;   optype[27]:=NOOP;
tokenname[28]:='PROGRAM '; tokentype[28]:=PROGSY;   optype[28]:=NOOP;
tokenname[29]:='RECORD  '; tokentype[29]:=RECORDSY; optype[29]:=NOOP;

tokenname[30]:='REPEAT  '; tokentype[30]:=REPEATSY; optype[30]:=NOOP;
tokenname[31]:='SEGMENT '; tokentype[31]:=PROGSY;   optype[31]:=NOOP;
tokenname[32]:='SEPARATE';{tokentype[32]:=SEPARATSY;optype[32]:=NOOP;}
tokenname[33]:='SET     '; tokentype[33]:=SETSY;    optype[33]:=NOOP;
tokenname[34]:='SHL     '; tokentype[34]:=mulop;    optype[34]:=shlop;{/pc157d}
tokenname[35]:='SHR     '; tokentype[35]:=mulop;    optype[35]:=shrop;{/pc157d}

tokenname[36]:='THEN    '; tokentype[36]:=THENSY;   optype[36]:=NOOP;
tokenname[37]:='TO      '; tokentype[37]:=TOSY;     optype[37]:=NOOP;
tokenname[38]:='TYPE    '; tokentype[38]:=TYPESY;   optype[38]:=NOOP;
tokenname[39]:='UNIT    '; tokentype[39]:=UNITSY;   optype[39]:=NOOP;

tokenname[40]:='UNTIL   '; tokentype[40]:=UNTILSY;  optype[40]:=NOOP;
tokenname[41]:='USES    '; tokentype[41]:=USESSY;   optype[41]:=NOOP;
tokenname[42]:='VAR     '; tokentype[42]:=VARSY;    optype[42]:=NOOP;
tokenname[43]:='WHILE   '; tokentype[43]:=WHILESY;  optype[43]:=NOOP;

tokenname[44]:='WITH    '; tokentype[44]:=WITHSY;   optype[44]:=NOOP;
tokenname[45]:='XOR     '; tokentype[45]:=addop;    optype[45]:=xorop;
{one more for bisection search}
tokenname[46]:='ZZZZZZZZ';{tokentype[46]:=WITHSY;}  optype[46]:=NOOP;
end; {INITIDTABLE}





{start /tp4}

procedure suffix(var s:string80; suff:string; add:boolean);
{  Add a suffix. If add= false, only add suffix if there is not one present
   If Add=true, always add new suffix.  }
begin
  if pos('.',s)=0 then suff := concat('.',suff);
  if pos('.', s) <> 0 then
    if add then
      s[0] := chr(pos('.', s){ - 1})
    else
      exit;{(suffix);}
  s := concat(s, suff)
end;


{end /tp4}






{Mark's patch from 1.3}
Procedure Init_userinfo;
Var
    Name : string80;
    ch : char;
    ERR : integer;
    temp:string80;
Begin
  {writeln('entering inituserinf');writeln(memavail);}  {patch /tp3}
    Name := '';
    If paramcount >=1 then Name := Paramstr(1);    {/tp4}
    If name = '' then
      begin
      Write(output,'Compile what text? ');
      Readln (Name);
      end;
    suffix(name,'pas',false);
   {$I-}
    Assign(worksym,name);
    Reset(worksym,512);

    Suffix(name,'COD',true);
    Assign(wurkcode,name);
    Rewrite(Wurkcode,512);
    If Ioresult <> 0 then
      Begin
      err := ioresult; Writeln ('error ',err);{readln;}
      Writeln(output,'Can''t open ',name);
      exit;{(pascalcompiler);}  {exit crap again}
      end;



    write(output,'Output file for compiler listing <cr> for none, $ for same ');
    Readln(temp);
    if temp <> '' then
      begin
      {$I-}
      if temp = '$' then temp := name;
      Suffix(temp,'lst',true);
      Assign(listfile,temp);
      Rewrite(listfile);      {no 512 as textfile}
      {$I+}
      If ioresult <> 0 then
	error(404);
      list := true;
      list_open := true;
    end
    else
      list_open := false;
    If list_open then
      Begin
      Write(output,'Generate p-Code Interlist ? ');
      ch := readkey;
      interlist := ch in ['y','Y'];
      write(output,ch);
      writeln;
      end;
    Write(output,'Flip sex ? ');
    ch := readkey;
    flipsex := ch in ['y','Y'];
    write(output,ch);
    {writeln('leaving  inituserinf');}  {patch /tp3}
  End; { Init_Userinfo }


















BEGIN (*COMPINIT*)
  {writeln('entering compinit   ');writeln(memavail);}  {patch /tp3}
  InitIdTable;    {patch /tp3}

  INITSCALARS;
  Init_Userinfo;
  INITSETS;
  LEVEL := 0; TOP := 0;
  IF NOISY THEN
    BEGIN
      FOR IC := 1 TO 7 DO WRITELN(OUTPUT);
      {WRITELN(OUTPUT,'PASCAL Compiler [I.5] (Unit Compiler)');}
      Writeln(output,'Portable Pascal [157g]');
      WRITE(OUTPUT,'<   0>')
    END;
  WITH DISPLAY[0] DO
    BEGIN FNAME := pNIL; FFILE := pNIL; FLABEL := pNIL; OCCUR := BLCK END;
  SMALLESTSPACE:=MEMAVAIL;

  {get next page will decrement symcursor and linestart so as this
   is the first read then increment them so that they are correct
   on return for get next page}

  symcursor:=2048; linestart:=2048;  {/tp4}

  GETNEXTPAGE;
  INSYMBOL;
  ENTSTDTYPES;
  ENTSTDNAMES;
  ENTUNDECL;
  ENTSPCPROCS;
  ENTSTDPROCS;




  IF SYSCOMP THEN
    BEGIN
    OUTERBLOCK := pNIL;
    SEG := 0;
    NEXTSEG := 1;
    GLEV :=1;
    BLOCKBEGSYS := BLOCKBEGSYS + [UNITSY,SEPARATSY]
    END
  ELSE
    BEGIN
    TOP := 1;
    LEVEL := 1;
    WITH DISPLAY[1] DO
      BEGIN
      FNAME := pNIL;
      FFILE := pNIL;
      FLABEL := pNIL;
      OCCUR := BLCK
      END;
    LC := LC+2;
    GLEV := 3; (*KEEP STACK STRAIGHT FOR NOW*)
    NEW(OUTERBLOCK);{,PROC,DECLARED,ACTUAL,FALSE);}
    WITH OUTERBLOCK^ DO
      BEGIN
      NEXT := pNIL;
      LOCALLC := LC;
      NAME := 'PROGRAM ';
      IDTYPE := pNIL;
      KLASS := PROC;
      PFDECKIND := DECLARED;
      PFLEV := 0;
      PFNAME := 1;
      PFSEG := SEG;
      PFKIND := ACTUAL;
      FORWDECL := FALSE;
      EXTURNAL := FALSE;
      INSCOPE := TRUE
      END
    END;
  IF SY = PROGSY THEN
    BEGIN
    INSYMBOL;
    IF SY = IDENT THEN
      BEGIN
      SEGTABLE[SEG].SEGNAME := ID;
      IF OUTERBLOCK <> pNIL THEN
	BEGIN
	OUTERBLOCK^.NAME := ID;
	ENTERID(OUTERBLOCK) (*ALLOWS EXIT ON PROGRAM NAME*)
	END
      END
    ELSE ERROR(2);
    INSYMBOL;
    IF SY = LPARENT THEN
      BEGIN
      REPEAT INSYMBOL      {skip (input,output) for program}
      UNTIL SY IN [RPARENT,SEMICOLON]+BLOCKBEGSYS;
      IF SY = RPARENT THEN INSYMBOL ELSE ERROR(4)
      END;
    IF SY = SEMICOLON THEN INSYMBOL ELSE ERROR(14)
    END;
  MARK(MARKP);
  NEW(TOS);
  WITH TOS^ DO  (*MAKE LEXSTKREC FOR OUTERBLOCK*)
    BEGIN
    PREVLEXSTACKP:=pNIL;
    BFSY:=PERIOD;
    DFPROCP:=OUTERBLOCK;
    DLLC:=LC;
    DOLDLEV:=LEVEL;
    DOLDTOP:=TOP;
    POLDPROC:=CURPROC;
    ISSEGMENT:=FALSE;
    {DMARKP:=MARKP;}
    move(markp,dmarkp,sizeof(markp));  {patch /tp3}
    END;
{writeln('leaving  compinit   ');}  {patch /tp3}
  END (*COMPINIT*) ;


  end.
