{overlay} PROCEDURE DECLARATIONPART(FSYS: SETOFSYS);
label 1;   {for label/const/type/var in any order like turbo pc157g 28/9/92}
VAR
  LSY     : SYMBOL;
  NOTDONE : BOOLEAN;
  DUMMYVAR: ARRAY[0..0] OF INTEGER; (*FOR PRETTY DISPLAY OF STACK AND HEAP *)

  PROCEDURE TYP(FSYS: SETOFSYS; VAR FSP: STP; VAR FSIZE: ADDRRANGE);
  VAR
    LSP,LSP1,LSP2  : STP;
    OLDTOP         : DISPRANGE;
    LCP            : CTP;
    LSIZE,DISPL    : ADDRRANGE;
    LMIN,LMAX      : INTEGER;
    PACKING        : BOOLEAN;
    NEXTBIT,NUMBITS: BITRANGE;

    PROCEDURE SIMPLETYPE(FSYS:SETOFSYS; VAR FSP:STP; VAR FSIZE:ADDRRANGE);
      VAR
        LSP,LSP1: STP;
        LCP,LCP1: CTP;
        TTOP    : DISPRANGE;
        LCNT    : INTEGER;
        LVALU   : VALU;
    BEGIN
      FSIZE := 1;
      IF NOT (SY IN SIMPTYPEBEGSYS) THEN
        BEGIN
        ERROR(1);
        SKIP(FSYS + SIMPTYPEBEGSYS)
        END;
      IF SY IN SIMPTYPEBEGSYS THEN
        BEGIN
          IF SY = LPARENT THEN
            BEGIN
            TTOP := TOP;
            WHILE DISPLAY[TOP].OCCUR <> BLCK DO TOP := TOP - 1;
            NEW(LSP);{,SCALAR,DECLARED);}
            WITH LSP^ DO
              BEGIN
              SIZE := INTSIZE;
              FORM := SCALAR;
              SCALKIND := DECLARED
              END;
            LCP1 := pNIL;
            LCNT := 0;
            REPEAT
              INSYMBOL;
              IF SY = IDENT THEN
                BEGIN
                NEW(LCP);{,KONST);}
                WITH LCP^ DO
                  BEGIN
                  NAME := ID;
                  IDTYPE := LSP;
                  NEXT := LCP1;
                  VALUES.IVAL := LCNT;
                  KLASS := KONST
                  END;
                ENTERID(LCP);
                LCNT := LCNT + 1;
                LCP1 := LCP;
                INSYMBOL
                END
              ELSE ERROR(2);
              IF NOT (SY IN FSYS + [COMMA,RPARENT]) THEN
                BEGIN ERROR(6); SKIP(FSYS + [COMMA,RPARENT]) END
            UNTIL SY <> COMMA;
            LSP^.FCONST := LCP1; TOP := TTOP;
            IF SY = RPARENT THEN INSYMBOL ELSE ERROR(4)
          END
          ELSE
            BEGIN
            IF SY = IDENT THEN
              BEGIN
              SEARCHID([TYPES,KONST],LCP);
              INSYMBOL;
              IF LCP^.KLASS = KONST THEN
                BEGIN
                NEW(LSP);{,SUBRANGE);}
                WITH LSP^, LCP^ DO
                  BEGIN
                  RANGETYPE := IDTYPE;
                  FORM := SUBRANGE;
                  IF STRGTYPE(RANGETYPE) THEN
                    BEGIN
                    ERROR(148);
                    RANGETYPE :=
                    pNIL
                    END;
                  MIN := VALUES;
                  SIZE := INTSIZE
                  END;
                IF SY = COLON THEN
                  INSYMBOL
                ELSE
                  ERROR(5);
                CONSTANT(FSYS,LSP1,LVALU);
                LSP^.MAX := LVALU;
                IF LSP^.RANGETYPE <> LSP1 THEN ERROR(107)
                END
              ELSE
                BEGIN
                LSP := LCP^.IDTYPE;
                IF (LSP = STRGPTR) AND (SY = LBRACK) THEN
                  BEGIN
                  INSYMBOL;
                  CONSTANT(FSYS + [RBRACK],LSP1,LVALU);
                  IF LSP1 = INTPTR THEN
                    BEGIN
                    IF (LVALU.IVAL <= 0) OR (LVALU.IVAL > STRGLGTH) THEN
                      BEGIN
                      ERROR(203);
                      LVALU.IVAL := DEFSTRGLGTH
                      END;
                    IF LVALU.IVAL <> DEFSTRGLGTH THEN
                      BEGIN
                      NEW(LSP);{,ARRAYS,TRUE,TRUE);}
                      LSP^ := STRGPTR^;
                      WITH LSP^,LVALU DO
                        BEGIN
                        MAXLENG := IVAL;
                        SIZE := (IVAL+CHRSPERWD) DIV CHRSPERWD
                        END
                      END
                    END
                  ELSE
                    ERROR(15);
                  IF SY = RBRACK THEN
                    INSYMBOL
                  ELSE
                    ERROR(12)
                  END
                ELSE
                  IF LSP = INTPTR THEN
                    IF SY = LBRACK THEN
                      BEGIN
                      INSYMBOL;
                      NEW(LSP);{,LONGINT);}
                      LSP^ := LONGINTPTR^;
                      CONSTANT(FSYS + [RBRACK],LSP1,LVALU);
                      IF LSP1 = INTPTR THEN
                        IF (LVALU.IVAL <= 0) OR (LVALU.IVAL > MAXDEC) THEN
                          ERROR(203)
                        ELSE
                          LSP^.SIZE := DECSIZE(LVALU.IVAL)
                      ELSE
                        ERROR(15);
                      IF SY = RBRACK THEN
                        INSYMBOL
                      ELSE
                        ERROR(12);
                      END
                    ELSE
                      IF LSP^.FORM = FILES THEN
                        IF INMODULE THEN
                          IF NOT ININTERFACE THEN
                            ERROR(191); (*NO PRIVATE FILES*)
                  IF LSP <> pNIL THEN FSIZE := LSP^.SIZE
                    END
              END (*SY = IDENT*)
            ELSE
              BEGIN
              NEW(LSP);{,SUBRANGE);}
              LSP^.FORM := SUBRANGE;
              CONSTANT(FSYS + [COLON],LSP1,LVALU);
              IF STRGTYPE(LSP1) THEN
                BEGIN
                ERROR(148);
                LSP1 := pNIL
                END;
              WITH LSP^ DO
                BEGIN
                RANGETYPE:=LSP1;
                MIN:=LVALU;
                SIZE:=INTSIZE
                END;
              IF SY = COLON THEN
                INSYMBOL
              ELSE
                ERROR(5);
              CONSTANT(FSYS,LSP1,LVALU);
              LSP^.MAX := LVALU;
              IF LSP^.RANGETYPE <> LSP1 THEN
                ERROR(107)
              END;
            IF LSP <> pNIL THEN
              WITH LSP^ DO
                IF FORM = SUBRANGE THEN
                  IF RANGETYPE <> pNIL THEN
                    IF RANGETYPE = REALPTR THEN
                      ERROR(399)
                    ELSE
                      IF MIN.IVAL > MAX.IVAL THEN
                        BEGIN
                        ERROR(102);
                        MAX.IVAL := MIN.IVAL
                        END
            END;
          FSP := LSP;
          IF NOT (SY IN FSYS) THEN
            BEGIN ERROR(6); SKIP(FSYS) END
        END
          ELSE FSP := pNIL
    END (*SIMPLETYPE*) ;

    FUNCTION PACKABLE(FSP: STP): BOOLEAN;
    VAR
      LMIN,LMAX: INTEGER;
    BEGIN
      PACKABLE := FALSE;
      IF (FSP <> pNIL) AND PACKING THEN
        WITH FSP^ DO
          CASE FORM OF
            SUBRANGE,
            SCALAR:  IF (FSP <> INTPTR) AND (FSP <> REALPTR) THEN
                       BEGIN
                       GETBOUNDS(FSP,LMIN,LMAX);
                       IF LMIN >= 0 THEN
                         BEGIN
                         PACKABLE := TRUE;
                         NUMBITS := 1;
                         LMIN := 1;
                         WHILE LMIN < LMAX DO
                           BEGIN
                           LMIN := LMIN + 1;
                           LMIN := LMIN + LMIN - 1;
                           NUMBITS := NUMBITS + 1
                           END
                         END
                       END;
            POWER:   IF PACKABLE(ELSET) THEN
                       BEGIN
                       GETBOUNDS(ELSET,LMIN,LMAX);
                       LMAX := LMAX + 1;
                       IF LMAX < BITSPERWD THEN
                         BEGIN
                         PACKABLE := TRUE;
                         NUMBITS := LMAX
                         END
                       END
          END (* CASES *);
    END (*PACKABLE*) ;

    PROCEDURE FIELDLIST(FSYS: SETOFSYS; VAR FRECVAR: STP);
    VAR
      LCP,LCP1,NXT,NXT1,LAST: CTP;
      LSP,LSP1,LSP2,LSP3,LSP4: STP;
      MINSIZE,MAXSIZE,LSIZE: ADDRRANGE;
      LVALU: VALU;
      MAXBIT,MINBIT: BITRANGE;

      PROCEDURE ALLOCATE(FCP: CTP);
        VAR ONBOUND: BOOLEAN;
      BEGIN
        ONBOUND := FALSE;
        WITH FCP^ DO
          IF PACKABLE(IDTYPE) THEN
            BEGIN
            IF (NUMBITS + NEXTBIT) > BITSPERWD THEN
              BEGIN
              DISPL := DISPL + 1;
              NEXTBIT := 0;
              ONBOUND := TRUE
              END;
            FLDADDR := DISPL;
            FISPACKD := TRUE;
            FLDWIDTH := NUMBITS;
            FLDRBIT := NEXTBIT;
            NEXTBIT := NEXTBIT + NUMBITS
            END
          ELSE
            BEGIN
            DISPL := DISPL + ORD(NEXTBIT > 0);
            NEXTBIT := 0;
            ONBOUND := TRUE;
            FISPACKD := FALSE;
            FLDADDR := DISPL;
            IF IDTYPE <> pNIL THEN
              DISPL := DISPL + IDTYPE^.SIZE
            END;
        IF ONBOUND AND (LAST <> pNIL) THEN
          WITH LAST^ DO
            IF FISPACKD THEN
              IF FLDRBIT = 0 THEN
                FISPACKD := FALSE
              ELSE
                IF (FLDWIDTH <= 8) AND (FLDRBIT <= 8) THEN
                  BEGIN
                  FLDWIDTH := 8;
                  FLDRBIT := 8
                  END
      END (*ALLOCATE*) ;

      PROCEDURE VARIANTLIST;
      VAR
        GOTTAGNAME: BOOLEAN;
      BEGIN
        NEW(LSP);{,TAGFLD);}
        WITH LSP^ DO
          BEGIN
          TAGFIELDP := pNIL;
          FSTVAR := pNIL;
          FORM := TAGFLD
          END;
        FRECVAR := LSP;
        INSYMBOL;
        IF SY = IDENT THEN
          BEGIN
          IF PACKING THEN
            NEW(LCP) {,FIELD,TRUE)}
          ELSE
            NEW(LCP);{,FIELD,FALSE);}
          WITH LCP^ DO
            BEGIN
            IDTYPE := pNIL;
            KLASS:=FIELD;
            NEXT := pNIL;
            FISPACKD := FALSE
            END;
          GOTTAGNAME := FALSE;
          PRTERR := FALSE;
          SEARCHID([TYPES],LCP1);
          PRTERR := TRUE;
          IF LCP1 = pNIL THEN
            BEGIN
            GOTTAGNAME := TRUE;
            LCP^.NAME := ID;
            ENTERID(LCP);
            INSYMBOL;
            IF SY = COLON THEN
              INSYMBOL
            ELSE
              ERROR(5)
            END;
          IF SY = IDENT THEN
            BEGIN
            SEARCHID([TYPES],LCP1);
            LSP1 := LCP1^.IDTYPE;
            IF LSP1 <> pNIL THEN
              BEGIN
              IF LSP1^.FORM <= SUBRANGE THEN
                BEGIN
                IF COMPTYPES(REALPTR,LSP1) THEN ERROR(109);
                LCP^.IDTYPE := LSP1;
                LSP^.TAGFIELDP := LCP;
                IF GOTTAGNAME THEN ALLOCATE(LCP)
                END
              ELSE
                ERROR(110)
              END;
            INSYMBOL
            END
          ELSE
            BEGIN
            ERROR(2);
            SKIP(FSYS + [OFSY,LPARENT])
            END
          END
        ELSE
          BEGIN
          ERROR(2);
          SKIP(FSYS + [OFSY,LPARENT])
          END;
        LSP^.SIZE := DISPL + ORD(NEXTBIT > 0);
        IF SY = OFSY THEN
          INSYMBOL
        ELSE
          ERROR(8);
        LSP1 := pNIL;
        MINSIZE := DISPL;
        MAXSIZE := DISPL;
        MINBIT := NEXTBIT;
        MAXBIT := NEXTBIT;
        REPEAT LSP2 := pNIL;
          REPEAT CONSTANT(FSYS + [COMMA,COLON,LPARENT],LSP3,LVALU);
            IF LSP^.TAGFIELDP <> pNIL THEN
              IF NOT COMPTYPES(LSP^.TAGFIELDP^.IDTYPE,LSP3) THEN
                ERROR(111);
            NEW(LSP3);{,VARIANT);}
            WITH LSP3^ DO
              BEGIN
              NXTVAR := LSP1;
              SUBVAR := LSP2;
              VARVAL := LVALU;
              FORM := VARIANT
              END;
            LSP1 := LSP3;
            LSP2 := LSP3;
            TEST := SY <> COMMA;
            IF NOT TEST THEN INSYMBOL
          UNTIL TEST;
          IF SY = COLON THEN INSYMBOL ELSE ERROR(5);
          IF SY = LPARENT THEN INSYMBOL ELSE ERROR(9);
          IF SY = RPARENT THEN LSP2 := pNIL
          ELSE
            FIELDLIST(FSYS + [RPARENT,SEMICOLON],LSP2);
          IF DISPL > MAXSIZE THEN
            BEGIN MAXSIZE := DISPL; MAXBIT := NEXTBIT END
          ELSE
            IF (DISPL = MAXSIZE) AND (NEXTBIT > MAXBIT) THEN
              MAXBIT := NEXTBIT;
          WHILE LSP3 <> pNIL DO
            BEGIN
            LSP4 := LSP3^.SUBVAR;
            LSP3^.SUBVAR := LSP2;
            LSP3^.SIZE := DISPL + ORD(NEXTBIT > 0);
            LSP3 := LSP4
            END;
          IF SY = RPARENT THEN
            BEGIN
            INSYMBOL;
            IF NOT (SY IN FSYS + [SEMICOLON]) THEN
              BEGIN
              ERROR(6);
              SKIP(FSYS + [SEMICOLON])
              END
            END
          ELSE ERROR(4);
          TEST := SY <> SEMICOLON;
          IF NOT TEST THEN
            BEGIN
            INSYMBOL;
            DISPL := MINSIZE;
            NEXTBIT := MINBIT
            END
        UNTIL (TEST) OR (SY = ENDSY); (* <<<< SMF 2-28-78 *)
        DISPL := MAXSIZE;
        NEXTBIT := MAXBIT;
        LSP^.FSTVAR := LSP1
      END (*VARIANTLIST*) ;

    BEGIN (*FIELDLIST*)
      NXT1 := pNIL;
      LSP := pNIL;
      LAST := pNIL;
      IF NOT (SY IN [IDENT,CASESY,endsy]) THEN  {addition ...please note!}
        BEGIN
        ERROR(19);
        SKIP(FSYS + [IDENT,CASESY])
        END;
      WHILE SY = IDENT DO
        BEGIN
        NXT := NXT1;
          REPEAT
            IF SY = IDENT THEN
              BEGIN
              IF PACKING THEN
                NEW(LCP) {,FIELD,TRUE)}
              ELSE
                NEW(LCP);{,FIELD,FALSE);}
              WITH LCP^ DO
                BEGIN
                NAME := ID;
                IDTYPE := pNIL;
                NEXT := NXT;
                KLASS := FIELD;
                FISPACKD := FALSE
                END;
              NXT := LCP;
              ENTERID(LCP);
              INSYMBOL
              END
            ELSE ERROR(2);
            IF NOT (SY IN [COMMA,COLON]) THEN
              BEGIN
              ERROR(6);
              SKIP(FSYS + [COMMA,COLON,SEMICOLON,CASESY])
              END;
            TEST := SY <> COMMA;
            IF NOT TEST  THEN INSYMBOL
          UNTIL TEST;
          IF SY = COLON THEN INSYMBOL ELSE ERROR(5);
          TYP(FSYS + [CASESY,SEMICOLON],LSP,LSIZE);
          IF LSP <> pNIL THEN
            IF LSP^.FORM = FILES THEN ERROR(108);
          WHILE NXT <> NXT1 DO
            WITH NXT^ DO
              BEGIN
              IDTYPE := LSP;
              ALLOCATE(NXT);
              IF NEXT = NXT1 THEN LAST := NXT;
              NXT := NEXT
              END;
          NXT1 := LCP;
          IF SY = SEMICOLON THEN
            BEGIN
            INSYMBOL;
            IF NOT (SY IN [IDENT,ENDSY,CASESY]) THEN (* <<<< SMF 2-28-78 *)
              BEGIN
              ERROR(19);
              SKIP(FSYS + [IDENT,CASESY])
              END
            END
        END (*WHILE*);
      NXT := pNIL;
      WHILE NXT1 <> pNIL DO
        WITH NXT1^ DO
          BEGIN
          LCP := NEXT;
          NEXT := NXT;
          NXT := NXT1;
          NXT1 := LCP
          END;
      IF SY = CASESY THEN
        VARIANTLIST
      ELSE
        FRECVAR := pNIL
    END (*FIELDLIST*) ;

    PROCEDURE POINTERTYPE;
    BEGIN
      NEW(LSP);{,POINTER);}
      FSP := LSP;
      WITH LSP^ DO
        BEGIN
        ELTYPE := pNIL;
        SIZE := PTRSIZE;
        FORM := POINTERs     {/tp3}
        END;
      INSYMBOL;
      IF SY = IDENT THEN
        BEGIN
        PRTERR := FALSE;
        SEARCHID([TYPES],LCP);
        PRTERR := TRUE;
        IF LCP = pNIL THEN   (*FORWARD REFERENCED TYPE ID*)
          BEGIN
          NEW(LCP);{,TYPES);}
          WITH LCP^ DO
            BEGIN
            NAME := ID;
            IDTYPE := LSP;
            NEXT := FWPTR;
            KLASS := TYPES
            END;
          FWPTR := LCP
          END
        ELSE
          BEGIN
          IF LCP^.IDTYPE <> pNIL THEN
            IF (LCP^.IDTYPE^.FORM <> FILES) OR SYSCOMP THEN
              LSP^.ELTYPE := LCP^.IDTYPE
            ELSE
              ERROR(108)
          END;
        INSYMBOL;
        END
      ELSE
        ERROR(2)
    END (*POINTERTYPE*) ;

  BEGIN (*TYP*)
    PACKING := FALSE;
    IF NOT (SY IN TYPEBEGSYS) THEN
      BEGIN
      ERROR(10);
      SKIP(FSYS + TYPEBEGSYS)
      END;
    IF SY IN TYPEBEGSYS THEN
      BEGIN
      IF SY IN SIMPTYPEBEGSYS THEN
        SIMPLETYPE(FSYS,FSP,FSIZE)
      ELSE
  (*^*) IF SY = ARROW THEN
          POINTERTYPE
        ELSE
          BEGIN
          IF SY = PACKEDSY THEN
            BEGIN
            INSYMBOL;
            PACKING := TRUE;
            IF NOT (SY IN TYPEDELS) THEN
              BEGIN
              ERROR(10);
              SKIP(FSYS + TYPEDELS)
              END
            END;
          IF SY = ARRAYSY THEN
  (*ARRAY*) BEGIN
            INSYMBOL;
            IF SY = LBRACK THEN
              INSYMBOL
            ELSE
              ERROR(11);
            LSP1 := pNIL;
            REPEAT
              IF PACKING THEN
                NEW(LSP) {,ARRAYS,TRUE,FALSE)}
              ELSE
                NEW(LSP);{,ARRAYS,FALSE);}
              WITH LSP^ DO
                BEGIN
                AELTYPE := LSP1;
                INXTYPE := pNIL;
                IF PACKING THEN
                  AISSTRNG := FALSE;
                AISPACKD := FALSE;
                FORM := ARRAYS
                END;
              LSP1 := LSP;
              SIMPLETYPE(FSYS + [COMMA,RBRACK,OFSY],LSP2,LSIZE);
              LSP1^.SIZE := LSIZE;
              IF LSP2 <> pNIL THEN
                IF LSP2^.FORM <= SUBRANGE THEN
                  BEGIN
                  IF LSP2 = REALPTR THEN
                    BEGIN
                    ERROR(109);
                    LSP2 := pNIL
                    END
                  ELSE
                    IF LSP2 = INTPTR THEN
                      BEGIN
                      ERROR(149);
                      LSP2 := pNIL
                      END;
                  LSP^.INXTYPE := LSP2
                  END
                ELSE
                  BEGIN
                  ERROR(113);
                  LSP2 := pNIL
                  END;
              TEST := SY <> COMMA;
              IF NOT TEST THEN INSYMBOL
            UNTIL TEST;
            IF SY = RBRACK THEN INSYMBOL ELSE ERROR(12);
            IF SY = OFSY THEN INSYMBOL ELSE ERROR(8);
            TYP(FSYS,LSP,LSIZE);
            IF LSP <> pNIL THEN
              IF LSP^.FORM = FILES THEN ERROR(108);
            IF PACKABLE(LSP) THEN
              IF NUMBITS + NUMBITS <= BITSPERWD THEN
                WITH LSP1^ DO
                  BEGIN
                  AISPACKD := TRUE;
                  ELSPERWD := BITSPERWD DIV NUMBITS;
                  ELWIDTH := NUMBITS
                  END;
            REPEAT
              WITH LSP1^ DO
                BEGIN LSP2 := AELTYPE; AELTYPE := LSP;
              IF INXTYPE <> pNIL THEN
                BEGIN
                GETBOUNDS(INXTYPE,LMIN,LMAX);
                IF AISPACKD THEN
                  LSIZE := (LMAX-LMIN+ELSPERWD) DIV ELSPERWD
                ELSE
                  LSIZE := LSIZE*(LMAX - LMIN + 1);
                IF LSIZE <= 0 THEN
                  BEGIN ERROR(398); LSIZE := 1 END;
                SIZE := LSIZE
                END
              END;
              LSP := LSP1; LSP1 := LSP2
            UNTIL LSP1 = pNIL
            END
          ELSE
  (*RECORD*)IF SY = RECORDSY THEN
              BEGIN
              INSYMBOL;
              OLDTOP := TOP;
              IF TOP < DISPLIMIT THEN
                BEGIN TOP := TOP + 1;
                WITH DISPLAY[TOP] DO
                  BEGIN
                  FNAME := pNIL;
                  OCCUR := REC
                  END
                END
            ELSE ERROR(250);
            DISPL := 0;
            NEXTBIT := 0;
            FIELDLIST(FSYS-[SEMICOLON]+[ENDSY],LSP1);
            DISPL := DISPL + ORD(NEXTBIT > 0);
            NEW(LSP);{,RECORDS);}
            WITH LSP^ DO
              BEGIN
              FSTFLD := DISPLAY[TOP].FNAME;
              RECVAR := LSP1; SIZE := DISPL;
              FORM := RECORDS
              END;
            TOP := OLDTOP;
            IF SY = ENDSY THEN INSYMBOL ELSE ERROR(13)
            END
                ELSE
  (*SET*)         IF SY = SETSY THEN
                    BEGIN
                      INSYMBOL;
                      IF SY = OFSY THEN INSYMBOL ELSE ERROR(8);
                      SIMPLETYPE(FSYS,LSP1,LSIZE);
                      IF LSP1 <> pNIL THEN
                        IF (LSP1^.FORM > SUBRANGE) OR
                           (LSP1 = INTPTR) {OR (LSP1 = REALPTR)} THEN  {157g}
                          BEGIN ERROR(115); LSP1 := pNIL END
                        ELSE
                          IF LSP1 = REALPTR THEN
                            BEGIN ERROR(114); LSP1 := pNIL END;
                      NEW(LSP);{,POWER);}
                      WITH LSP^ DO
                        BEGIN ELSET := LSP1; FORM := POWER;
                          IF LSP1 <> pNIL THEN
                            BEGIN GETBOUNDS(LSP1,LMIN,LMAX);
                              SIZE := (LMAX + BITSPERWD) DIV BITSPERWD;
                              {IF SIZE > 255 THEN}   {pc157g bug13}
                              if (lmin<0) or(lmax>setsize) then   {157g,bug13}
                                BEGIN ERROR(169); SIZE := 1 END
                            END
                          ELSE SIZE := 0
                        END
                    END
                  ELSE
  (*FILE*)          IF SY = FILESY THEN
                        BEGIN
                        IF INMODULE THEN
                          IF NOT ININTERFACE THEN
                            ERROR(191); (*NO PRIVATE FILES*)
                        INSYMBOL; NEW(LSP);{,FILES);}
                        WITH LSP^ DO
                          BEGIN FORM := FILES; FILTYPE := pNIL END;
                        IF SY = OFSY THEN
                          BEGIN INSYMBOL; TYP(FSYS,LSP1,LSIZE) END
                        ELSE LSP1 := pNIL;
                        LSP^.FILTYPE := LSP1;
                        IF LSP1 <> pNIL THEN
                          LSP^.SIZE := FILESIZE + LSP1^.SIZE
                        ELSE LSP^.SIZE := NILFILESIZE
                        END;
              FSP := LSP
            END;
        IF NOT (SY IN FSYS) THEN
          BEGIN ERROR(6); SKIP(FSYS) END
      END
    ELSE FSP := pNIL;
    IF FSP = pNIL THEN
      FSIZE := 1
    ELSE
      FSIZE := FSP^.SIZE
    END (*TYP*) ;

{ (*$I DECPART.B.TEXT*) }


(*    COPYRIGHT (C) 1978, REGENTS OF THE*)
(*    UNIVERSITY OF CALIFORNIA, SAN DIEGO*)

PROCEDURE USESDECLARATION(MAGIC: BOOLEAN);
  LABEL 1;
  TYPE DCREC = RECORD
                 DISKADDR: INTEGER;
                 CODELENG: INTEGER
               END;
  VAR SEGDICT: RECORD
                   DANDC: ARRAY[SEGRANGE] OF DCREC;
                   SEGNAME: ARRAY[SEGRANGE] OF ALPHA;
                   SEGKIND: ARRAY[SEGRANGE] OF INTEGER;
                   TEXTADDR: ARRAY[SEGRANGE] OF INTEGER;
                   FILLER: ARRAY[0..127] OF INTEGER
               END;
      FOUND: BOOLEAN; BEGADDR: INTEGER;
      LCP: CTP; LLEXSTK: LEXSTKREC; LNAME: ALPHA;
      LSY: SYMBOL; LOP: OPERATOR; LID: ALPHA;

PROCEDURE GETTEXT(VAR FOUND: BOOLEAN);
  VAR LCP: CTP; SEGINDEX: INTEGER;

BEGIN FOUND := FALSE;
  LCP := MODPTR;
  WHILE (LCP <> pNIL) AND NOT FOUND DO
    IF LCP^.NAME = ID THEN FOUND := TRUE ELSE LCP := LCP^.NEXT;
  IF FOUND THEN
    BEGIN
      LSEPPROC := SEGTABLE[LCP^.SEGID].SEGKIND = 4;
      IF NOT LSEPPROC THEN
        BEGIN
        SEG := LCP^.SEGID;
        NEXTPROC := 2 {1}   {/pc157e}
        END;
      BEGADDR := SEGTABLE[LCP^.SEGID].TEXTADDR;
      USEFILE := WORKCODE;
    END
  ELSE
    BEGIN FOUND := TRUE;
      IF LIBNOTOPEN THEN
        BEGIN
          Assign(plibrary,systemlib);
          {$I-}
          RESET(pLIBRARY,512);
          {$I+}
          IF IORESULT <> 0 THEN BEGIN ERROR(187); FOUND := FALSE END
          ELSE
            IF ucsdBLOCKREADrel(pLIBRARY,SEGDICT,1,0) <> 1 THEN
              BEGIN ERROR(187); FOUND := FALSE END;
        END;
      IF FOUND THEN
        BEGIN LIBNOTOPEN := FALSE;
          SEGINDEX := 0; FOUND := FALSE;
          WHILE (SEGINDEX <= MAXSEG) AND (NOT FOUND) DO
            IF MAGIC THEN
                IF SEGDICT.SEGNAME[SEGINDEX] = LNAME THEN FOUND := TRUE
                ELSE SEGINDEX := SEGINDEX + 1
            ELSE
              IF SEGDICT.SEGNAME[SEGINDEX] = ID THEN FOUND := TRUE
              ELSE SEGINDEX := SEGINDEX + 1;
          IF FOUND THEN
            BEGIN USEFILE := SYSLIBRARY;
              BEGADDR := SEGDICT.TEXTADDR[SEGINDEX];
              LSEPPROC := SEGDICT.SEGKIND[SEGINDEX] = 4;
              IF NOT LSEPPROC THEN
                BEGIN
                  IF MAGIC THEN SEG := 6
                  ELSE
                    BEGIN SEG := NEXTSEG;
                      NEXTSEG := NEXTSEG + 1;
                      IF NEXTSEG > MAXSEG THEN ERROR(250)
                    END;
                  WITH SEGTABLE[SEG] DO
                    BEGIN DISKADDR := 0; CODELENG := 0;
                      SEGNAME := SEGDICT.SEGNAME[SEGINDEX];
                      IF INMODULE OR MAGIC THEN SEGKIND := 0
                      ELSE SEGKIND := SEGDICT.SEGKIND[SEGINDEX];
                      TEXTADDR := 0
                    END;
		  NEXTPROC := 2 {1}  {/pc157e}
                END
            END
          ELSE ERROR(190) (*NOT IN LIBRARY*)
        END
    END;
  IF BEGADDR = 0 THEN
    BEGIN
    ERROR(195);   {unit not importable} {? or not in library ?LB}
    FOUND := FALSE
    END;
  IF FOUND THEN
    BEGIN
    USING := TRUE;
    PREVSYMCURSOR := SYMCURSOR+1024; {/tp6} {allow for shuffle in GETNEXTPAGE}
    PREVLINESTART := LINESTART+1024; {/tp6}
    PREVSYMBLK := SYMBLK - 2;
    SYMBLK := BEGADDR;
    symcursor := 2048; {/tp6}
    linestart := 2048; {/tp6}
    GETNEXTPAGE;
    INSYMBOL
    END
END (*GETTEXT*) ;

BEGIN (*USESDECLARATION*)
  IF LEVEL <> 1 THEN ERROR(189);
  IF INMODULE AND NOT ININTERFACE THEN ERROR(192);
  IF NOT MAGIC THEN DLINKERINFO := TRUE;
  IF NOT USING THEN USINGLIST := pNIL;
  REPEAT
    IF (NOT MAGIC) AND (SY <> IDENT) THEN ERROR(2)
    ELSE
      IF USING THEN
        BEGIN
        LCP := USINGLIST;
        WHILE LCP <> pNIL DO
          IF LCP^.NAME = ID THEN GOTO 1
          ELSE LCP := LCP^.NEXT;
        ERROR(188)(*UNIT MUST BE PREDECLARED IN MAIN PROG*);
      1:
        END
      ELSE
        BEGIN
        IF MAGIC THEN
          BEGIN
          LNAME := 'TURTLE  ';
          LSY := SY;
          LOP := OP;
          LID := ID
          END
        ELSE
          BEGIN
          LNAME := ID;
          WRITELN{(OUTPUT)};
          WRITELN({OUTPUT,}ID,' [',MEMAVAIL:5,' words]');
          WRITE({OUTPUT,}'<',SCREENDOTS:4,'>')
          END;
        WITH LLEXSTK DO
          BEGIN
          DOLDSEG := SEG;
          SOLDPROC := NEXTPROC
          END;
        GETTEXT(FOUND);
        IF FOUND THEN
          BEGIN
          NEW(LCP);{,MODULE);}
          WITH LCP^ DO
            BEGIN
            NAME := LNAME;
            NEXT := USINGLIST;
            IDTYPE := pNIL;
            KLASS := MODULE;
            IF LSEPPROC THEN SEGID := -1 (*NO SEG*)
            ELSE SEGID := SEG
            END;
          ENTERID(LCP);
          USINGLIST := LCP;
          DECLARATIONPART(FSYS + [ENDSY]);
          IF NEXTPROC=1 (*NO PROCS DECLARED*) THEN
            LCP^.SEGID := -1; (*NO SEG*)
          SYMBLK := 9999; (*FORCE RETURN TO SOURCEFILE*)
          {by doing this, an error on the blockread of unit file occurs and
           this means we are no longer using a unit... and so the place in
           the original source file is then re-read by GETNEXTPAGE}
          GETNEXTPAGE
          END;
          IF NOT LSEPPROC THEN
            WITH LLEXSTK DO
              BEGIN
              SEG := DOLDSEG;
              NEXTPROC := SOLDPROC
              END;
          LSEPPROC := FALSE;
        END;
    IF NOT MAGIC THEN
      BEGIN
      INSYMBOL;
      TEST := SY <> COMMA;
      IF TEST THEN
        IF SY <> SEMICOLON THEN ERROR(20)
        ELSE
      ELSE INSYMBOL
      END
  UNTIL TEST OR MAGIC;
  IF NOT MAGIC THEN
    IF SY = SEMICOLON THEN INSYMBOL ELSE ERROR(14)
  ELSE
    BEGIN
    SY := LSY;
    OP := LOP;
    ID := LID
    END;
  IF NOT USING THEN
    BEGIN
    IF INMODULE THEN USINGLIST := pNIL;
    CLOSE(pLIBRARY{,LOCK});
    LIBNOTOPEN := TRUE
    END
END (*USESDECLARATION*) ;


PROCEDURE LABELDECLARATION;
      VAR LLP: LABELP; REDEF: BOOLEAN;
    BEGIN
      REPEAT
        IF SY = INTCONST THEN
          WITH DISPLAY[TOP] DO
            BEGIN LLP := FLABEL; REDEF := FALSE;
              WHILE (LLP <> pNIL) AND NOT REDEF DO
                IF LLP^.LABVAL <> VAL.IVAL THEN
                  LLP := LLP^.NEXTLAB
                ELSE BEGIN REDEF := TRUE; ERROR(166) END;
              IF NOT REDEF THEN
                BEGIN NEW(LLP);
                  WITH LLP^ DO
                    BEGIN LABVAL := VAL.IVAL;
                        CODELBP := pNIL; NEXTLAB := FLABEL
                    END;
                  FLABEL := LLP
                END;
              INSYMBOL
            END
        ELSE ERROR(15);
        IF NOT ( SY IN FSYS + [COMMA, SEMICOLON] ) THEN
          BEGIN ERROR(6); SKIP(FSYS+[COMMA,SEMICOLON]) END;
        TEST := SY <> COMMA;
        IF NOT TEST THEN INSYMBOL
      UNTIL TEST;
      IF SY = SEMICOLON THEN INSYMBOL ELSE ERROR(14)
    END (* LABELDECLARATION *) ;
  
    PROCEDURE CONSTDECLARATION;
      VAR LCP: CTP; LSP: STP; LVALU: VALU;
    BEGIN
      IF SY <> IDENT THEN
        BEGIN ERROR(2); SKIP(FSYS + [IDENT]) END;
      WHILE SY = IDENT DO
        BEGIN NEW(LCP);{,KONST);}
          WITH LCP^ DO
            BEGIN NAME := ID; IDTYPE := pNIL;
              NEXT := pNIL; KLASS := KONST
            END;
          INSYMBOL;
          IF (SY = RELOP) AND (OP = EQOP) THEN INSYMBOL ELSE ERROR(16);
          CONSTANT(FSYS + [SEMICOLON],LSP,LVALU);
          ENTERID(LCP);
          LCP^.IDTYPE := LSP; LCP^.VALUES := LVALU;
          IF SY = SEMICOLON THEN
            BEGIN INSYMBOL;
              IF NOT (SY IN FSYS + [IDENT]) THEN
                BEGIN ERROR(6); SKIP(FSYS + [IDENT]) END
            END
          ELSE
            IF NOT ((SY = ENDSY) AND (INMODULE)) THEN ERROR(14)
        END
    END (*CONSTDECLARATION*) ;
  
    PROCEDURE TYPEDECLARATION;
      VAR LCP,LCP1,LCP2: CTP; LSP: STP; LSIZE: ADDRRANGE;
    BEGIN
      IF SY <> IDENT THEN
        BEGIN ERROR(2); SKIP(FSYS + [IDENT]) END;
      WHILE SY = IDENT DO
        BEGIN NEW(LCP);{,TYPES);}
          WITH LCP^ DO
            BEGIN NAME := ID; IDTYPE := pNIL; KLASS := TYPES END;
          INSYMBOL;
          IF (SY = RELOP) AND (OP = EQOP) THEN INSYMBOL ELSE ERROR(16);
          TYP(FSYS + [SEMICOLON],LSP,LSIZE);
          ENTERID(LCP);
          LCP^.IDTYPE := LSP;
          LCP1 := FWPTR;
          WHILE LCP1 <> pNIL DO
            BEGIN
              IF LCP1^.NAME = LCP^.NAME THEN
                BEGIN
                  LCP1^.IDTYPE^.ELTYPE := LCP^.IDTYPE;
                  IF LCP1 <> FWPTR THEN
                    LCP2^.NEXT := LCP1^.NEXT
                  ELSE FWPTR := LCP1^.NEXT;
                END;
              LCP2 := LCP1; LCP1 := LCP1^.NEXT
            END;
          IF SY = SEMICOLON THEN
            BEGIN INSYMBOL;
              IF NOT (SY IN FSYS + [IDENT]) THEN
                BEGIN ERROR(6); SKIP(FSYS + [IDENT]) END
            END
          ELSE
            IF NOT ((SY = ENDSY) AND (INMODULE)) THEN ERROR(14)
        END;
      IF FWPTR <> pNIL THEN
        BEGIN ERROR(117); FWPTR := pNIL END
    END (*TYPEDECLARATION*) ;




PROCEDURE VARDECLARATION;
  VAR LCP,NXT,IDLIST: CTP; LSP: STP; LSIZE: ADDRRANGE;
  absclause : Boolean;  {157f}   {if absloute clause found}
  abslcp    : ctp;      {157f}   {for addr+lev of absolute clause var}
BEGIN NXT := pNIL;
  absclause := false;    {157f}
  REPEAT
    REPEAT
      IF SY = IDENT THEN
	BEGIN
	IF INMODULE THEN NEW(LCP){,ACTUALVARS,TRUE)}
	ELSE NEW(LCP){,ACTUALVARS,FALSE)};
	WITH LCP^ DO
	  BEGIN
          NAME := ID; NEXT := NXT; KLASS := ACTUALVARS;
	  IDTYPE := pNIL; VLEV := LEVEL;
	  IF INMODULE THEN
	    IF ININTERFACE THEN PUBLIC := TRUE
	    ELSE PUBLIC := FALSE
	  END;
	ENTERID(LCP);
	NXT := LCP;
	INSYMBOL;
	END
      ELSE ERROR(2);
      IF NOT (SY IN FSYS + [COMMA,COLON] + TYPEDELS) THEN
	BEGIN ERROR(6); SKIP(FSYS+[COMMA,COLON,SEMICOLON]+TYPEDELS) END;
      TEST := SY <> COMMA;
      IF NOT TEST THEN INSYMBOL
    UNTIL TEST;
    IF SY = COLON THEN INSYMBOL ELSE ERROR(5);
    IDLIST := NXT;
    TYP(FSYS + [SEMICOLON,absolutsy{157f}] + TYPEDELS,LSP,LSIZE);
    {all below pc157f addition}
    {here the id is the var type i.e. integer and sy=semicolon
     but if ABSOLUTE then var=type  and sy = absolutsy }

    {writeln('after typ, sy=',ord(sy),' id=',id);}
    if sy=absolutsy then
      Begin
      absclause := True;
      {ok boys..get the var name, address and level}
      insymbol;
      if sy = ident then
        begin
        searchid(vars +[{types,}field],abslcp);
        {interesting note here..If you allow types in the above call then
         var i:integer absolute integer; is correct and actually points to
         the compiler data structure used to build the basic data type
         integer.  This could allow you to alter data types at run time!LB}
        end
      else error(2) ;  {only a var..allow machine memory loc later}
      insymbol;   {get ';'}
      end;
    if absclause then
    while nxt <> pNIL do
      with nxt^ do
	begin idtype := lsp; vaddr := abslcp^.vaddr; vlev := abslcp^.vlev;
          {157f fix below LB 9/10/91 ..allows var to be declared absolute
           to a var parameter in parameter list}
          klass := abslcp^.klass;
          absclause:=false;
	  {LC := LC + LSIZE;} NXT := NEXT;
          If next <> pNIL then Writeln('WARNING Only one absolute var allowed');
	  IF NEXT = pNIL THEN IF LSP <> pNIL THEN IF LSP^.FORM = FILES THEN
            BEGIN (*PUT IDLIST INTO LOCAL FILE LIST*)
	    NEXT := DISPLAY[TOP].FFILE;
	    DISPLAY[TOP].FFILE := IDLIST
	    END
	end
    else

    WHILE NXT <> pNIL DO
      WITH NXT^ DO
	BEGIN IDTYPE := LSP; VADDR := LC;
	  LC := LC + LSIZE; NXT := NEXT;
	  IF NEXT = pNIL THEN IF LSP <> pNIL THEN IF LSP^.FORM = FILES THEN
            BEGIN (*PUT IDLIST INTO LOCAL FILE LIST*)
	    NEXT := DISPLAY[TOP].FFILE;
	    DISPLAY[TOP].FFILE := IDLIST
	    END
	END;

    IF SY = SEMICOLON THEN
      BEGIN INSYMBOL;
	IF NOT (SY IN FSYS + [IDENT]) THEN
	  BEGIN ERROR(6); SKIP(FSYS + [IDENT]) END
      END
    ELSE
	IF NOT ((SY = ENDSY) AND (INMODULE)) THEN ERROR(14)
  UNTIL (SY <> IDENT) AND NOT (SY IN TYPEDELS);
IF FWPTR <> pNIL THEN
    BEGIN ERROR(117); FWPTR := pNIL END
END (*VARDECLARATION*) ;
        {turbo incompatibility here. for var s:^string, or any pointer
        declararion, the pointer size (LSIZE) was 1735...not 1!!!
        this is due to the word pointer in the enumerated type
        STRUCTFORM of the globals section of the pascal compiler}
        {fix LB 5/4/91 change POINTER to POINTERS as enumerated type}
        {/tp3}

    
{ (*$I DECPART.C.TEXT*)  }

(*    COPYRIGHT (C) 1978, REGENTS OF THE        *)
(*    UNIVERSITY OF CALIFORNIA, SAN DIEGO       *)

    PROCEDURE PROCDECLARATION(FSY: SYMBOL; SEGDEC: BOOLEAN);
      VAR LSY: SYMBOL; LCP,LCP1: CTP; LSP: STP;
          EXTONLY,FORW: BOOLEAN; 
          LCM: ADDRRANGE;  
          LLEXSTK: LEXSTKREC;
  
      PROCEDURE PARAMETERLIST(FSY: SETOFSYS; VAR FPAR: CTP; FCP: CTP);
        VAR LCP,LCP1,LCP2,LCP3: CTP; LSP: STP; LKIND: IDKIND;
          LLC,LEN : ADDRRANGE; COUNT : INTEGER;
      BEGIN LCP1 := pNIL; LLC := LC;
        IF NOT (SY IN FSY + [LPARENT]) THEN
          BEGIN ERROR(7); SKIP(FSYS + FSY + [LPARENT]) END;
        IF SY = LPARENT THEN
          BEGIN IF FORW THEN ERROR(119);
            INSYMBOL;
            IF NOT (SY IN [IDENT,VARSY]) THEN
              BEGIN ERROR(7); SKIP(FSYS + [IDENT,RPARENT]) END;
            WHILE SY IN [IDENT,VARSY] DO
              BEGIN
                IF SY = VARSY THEN
                  BEGIN LKIND := FORMAL; INSYMBOL END
                ELSE LKIND := ACTUAL;
                LCP2 := pNIL;
                COUNT := 0;
                REPEAT
                  IF SY <> IDENT THEN ERROR(2)
                  ELSE
                    BEGIN
                      NEW(LCP);{,FORMALVARS,FALSE);} (*MAY BE ACTUAL(SAME SIZE)*)

                        WITH LCP^ DO
                        BEGIN NAME := ID; IDTYPE := pNIL; NEXT := LCP2;
                          IF LKIND = FORMAL THEN KLASS := FORMALVARS
                          ELSE KLASS := ACTUALVARS; VLEV := LEVEL
                        END;
                        ENTERID(LCP);
                        LCP2 := LCP; COUNT := COUNT + 1;
                        INSYMBOL
                    END;
                  IF NOT (SY IN FSYS + [COMMA,SEMICOLON,COLON]) THEN
                    BEGIN ERROR(7);
                        SKIP(FSYS + [COMMA,SEMICOLON,RPARENT,COLON])
                    END;
                  TEST := SY <> COMMA;
                  IF NOT TEST THEN INSYMBOL
                UNTIL TEST;
                LSP := pNIL;
                IF SY = COLON THEN
                  BEGIN INSYMBOL;
                    IF SY = IDENT THEN
                        BEGIN
                        SEARCHID([TYPES],LCP);
                        INSYMBOL;
                        LSP := LCP^.IDTYPE;
                        LEN := PTRSIZE;
                        IF LSP <> pNIL THEN
                          IF LKIND = ACTUAL THEN
                            IF LSP^.FORM = FILES THEN ERROR(121)
                            ELSE
                                 IF LSP^.FORM <= POWER THEN LEN := LSP^.SIZE;
                        LC := LC + COUNT * LEN
                        END
                    ELSE ERROR(2)
                  END
                ELSE
                  IF LKIND = FORMAL THEN
                    EXTONLY := TRUE
                  ELSE ERROR(5);
                IF NOT (SY IN FSYS + [SEMICOLON,RPARENT]) THEN
                  BEGIN ERROR(7); SKIP(FSYS + [SEMICOLON,RPARENT]) END;
                LCP3 := LCP2; LCP := pNIL;
                WHILE LCP2 <> pNIL DO
                  BEGIN LCP := LCP2;
                    WITH LCP2^ DO
                      BEGIN IDTYPE := LSP;
                        LCP2 := NEXT
                      END
                  END;
                {1.3 Update? bug?? correction LB}
                IF LCP <> pNIL THEN
                  BEGIN LCP^.NEXT := LCP1; LCP1 := LCP3 END;
                IF SY = SEMICOLON THEN
                  BEGIN INSYMBOL;
                    IF NOT (SY IN FSYS + [IDENT,VARSY]) THEN
                        BEGIN ERROR(7); SKIP(FSYS + [IDENT,RPARENT]) END
                  END
              END (*WHILE*) ;
              {End of 1.3 update LB}

            IF SY = RPARENT THEN
              BEGIN INSYMBOL;
                IF NOT (SY IN FSY + FSYS) THEN
                  BEGIN ERROR(6); SKIP(FSY + FSYS) END
              END
            ELSE ERROR(4);
            FCP^.LOCALLC := LC; LCP3 := pNIL;
            WHILE LCP1 <> pNIL DO
              WITH LCP1^ DO
                BEGIN LCP2 := NEXT; NEXT := LCP3;
              {Start of 1.3 update LB}
                  IF (IDTYPE <> pNIL) THEN
                    IF KLASS = FORMALVARS THEN
                      BEGIN VADDR := LLC; LLC := LLC + PTRSIZE END
                    ELSE
                      IF KLASS = ACTUALVARS THEN
                        IF (IDTYPE^.FORM <= POWER) THEN
                          BEGIN VADDR := LLC; LLC := LLC + IDTYPE^.SIZE END
              {End of 1.3 update LB}
                        ELSE
                          BEGIN VADDR := LC;
                            LC := LC + IDTYPE^.SIZE;
                            LLC := LLC + PTRSIZE
                          END;
                  LCP3 := LCP1; LCP1 := LCP2
                END;
            FPAR := LCP3
          END
            ELSE FPAR := pNIL
    END (*PARAMETERLIST*) ;
    
    Procedure DoSegDec;
        BEGIN
        IF CODEINSEG THEN
          BEGIN
          ERROR(399);
          SEGINX:=0;
          CURBYTE:=0;
          END;
        WITH LLEXSTK DO
          BEGIN
          DOLDSEG:=SEG;
          SEG:=NEXTSEG;
          SOLDPROC:=NEXTPROC;
          END;
        NEXTPROC:=1;
        LSY:=SY;
        IF SY IN [PROCSY,FUNCSY] THEN
          INSYMBOL
        ELSE
          BEGIN
          ERROR(399);
          LSY:=PROCSY
          END;
        FSY:=LSY;
        END;
        
      Procedure DoSyIsIdent;    {moved here to make room}
        BEGIN
        IF USING OR INMODULE AND ININTERFACE THEN
          FORW := FALSE
        ELSE
          BEGIN
          SEARCHSECTION(DISPLAY[TOP].FNAME,LCP);
          IF LCP <> pNIL THEN
            BEGIN
            IF LCP^.KLASS = PROC THEN
              FORW := LCP^.FORWDECL AND (FSY = PROCSY)
                            AND (LCP^.PFKIND = ACTUAL)
            ELSE
              IF LCP^.KLASS = FUNC THEN
                FORW := LCP^.FORWDECL AND (FSY = FUNCSY)
                              AND (LCP^.PFKIND = ACTUAL)
              ELSE FORW := FALSE;
            IF NOT FORW THEN ERROR(160)
            END
          ELSE FORW := FALSE
          END;
        IF NOT FORW THEN
          BEGIN
          IF FSY = PROCSY THEN
           {1.3 update to support Units etc        LB}
            IF INMODULE THEN
              NEW(LCP) {,PROC,DECLARED,ACTUAL,TRUE)}
            ELSE
              NEW(LCP) {,PROC,DECLARED,ACTUAL,FALSE)}
          ELSE
            IF INMODULE THEN
              NEW(LCP) {,FUNC,DECLARED,ACTUAL,TRUE)}
            ELSE
              NEW(LCP);{,FUNC,DECLARED,ACTUAL,FALSE);}
           {End of 1.3 update to support Units etc        LB}
          WITH LCP^ DO
            BEGIN
            NAME := ID;
            IDTYPE := pNIL;
            LOCALLC := LC;
            PFDECKIND :=
            DECLARED;
            PFKIND := ACTUAL;
            INSCOPE := FALSE;
            PFLEV := LEVEL;
            PFNAME := NEXTPROC;
            PFSEG := SEG;
            {Start of 1.3 update to support units etc       LB}
            IF USING THEN PROCTABLE[NEXTPROC] := 0;
            IF INMODULE THEN
              IF USING THEN
                IMPORTED := TRUE
              ELSE
                IMPORTED := FALSE;
            IF SEGDEC THEN
              BEGIN
              IF NEXTSEG > MAXSEG THEN ERROR(250);
              NEXTSEG := NEXTSEG+1;
              SEGTABLE[SEG].SEGNAME := ID
              END;
            {End of 1.3 update to support units etc       LB}
            IF NEXTPROC = MAXPROCNUM
              THEN ERROR(251)
            ELSE
              NEXTPROC := NEXTPROC + 1;
            IF FSY = PROCSY THEN
              KLASS := PROC
            ELSE
              KLASS := FUNC
            END;
              ENTERID(LCP)
          END
        ELSE
          BEGIN LCP1 := LCP^.NEXT;
          WHILE LCP1 <> pNIL DO
            BEGIN
            WITH LCP1^ DO
              IF IDTYPE = pNIL THEN
                EXTONLY := TRUE
              ELSE
                IF KLASS = FORMALVARS THEN
                  BEGIN
                  LCM := VADDR + PTRSIZE;
                  IF LCM > LC THEN LC := LCM
                  END
                ELSE
                  IF KLASS = ACTUALVARS THEN
                    BEGIN
                    LCM := VADDR + IDTYPE^.SIZE;
                    IF LCM > LC THEN LC := LCM
                    END;
                LCP1 := LCP1^.NEXT
            END;      {While LB}
          IF SEG <> LCP^.PFSEG THEN
            BEGIN
            SEG := LCP^.PFSEG;
            NEXTPROC := 2;
            IF NOT SEGDEC THEN ERROR(399)
            END
          END;
        INSYMBOL
        END; {Sy = Ident}

    BEGIN (*PROCDECLARATION*)
      IF SEGDEC THEN (* SEGMENT DECLARATION *)
        DoSegDec;       {moved to stop proc too long err}
      LLEXSTK.DLLC := LC; LC := LCAFTERMARKSTACK;
      IF FSY = FUNCSY THEN LC := LC + REALSIZE;
      LINEINFO := LC; DP := TRUE; EXTONLY := FALSE;
      IF SY = IDENT THEN
        DoSyIsIdent     {moved out of proc to stop too long err}
      ELSE
        BEGIN ERROR(2); LCP := UPRCPTR END;
      WITH LLEXSTK DO
        BEGIN DOLDLEV:=LEVEL; 
          DOLDTOP:=TOP; 
          POLDPROC:=CURPROC; 
          DFPROCP:=LCP;
        END;
      CURPROC := LCP^.PFNAME;
      IF LEVEL < MAXLEVEL THEN LEVEL := LEVEL + 1 ELSE ERROR(251);
      IF TOP < DISPLIMIT THEN
        BEGIN TOP := TOP + 1;
          WITH DISPLAY[TOP] DO
            BEGIN
              IF FORW THEN FNAME := LCP^.NEXT
              ELSE FNAME := pNIL;
              FLABEL := pNIL; FFILE := pNIL; OCCUR := BLCK
            END
        END
      ELSE ERROR(250);
      IF FSY = PROCSY THEN
        BEGIN PARAMETERLIST([SEMICOLON],LCP1,LCP);
          IF NOT FORW THEN LCP^.NEXT := LCP1
        END
      ELSE
        BEGIN PARAMETERLIST([SEMICOLON,COLON],LCP1,LCP);
          IF NOT FORW THEN LCP^.NEXT := LCP1;
          IF SY = COLON THEN
            BEGIN INSYMBOL;
              IF SY = IDENT THEN
                BEGIN IF FORW THEN ERROR(122);
                  SEARCHID([TYPES],LCP1);
                  LSP := LCP1^.IDTYPE;
                  LCP^.IDTYPE := LSP;
	         IF LSP <> pNIL THEN  {LB add arrays after ppointer for strng fn}
		   IF NOT (LSP^.FORM IN [SCALAR,SUBRANGE,pointers,arrays{11/4/94}]) THEN
		       BEGIN ERROR(120); LCP^.IDTYPE := pNIL END;
                  INSYMBOL
                END
              ELSE BEGIN ERROR(2); SKIP(FSYS + [SEMICOLON]) END
            END
          ELSE
            IF NOT FORW THEN ERROR(123)
        END;
      IF SY = SEMICOLON THEN INSYMBOL ELSE ERROR(14);
      LCP^.EXTURNAL := FALSE;
      IF (SY = EXTERNLSY)
         OR ((USING) AND (LSEPPROC)) THEN
        BEGIN
          IF LEVEL <> 2 THEN
            ERROR(183) (*EXTERNAL PROCS MUST BE IN OUTERMOST BLOCK*);
          IF INMODULE THEN
            IF ININTERFACE AND NOT USING THEN
              ERROR(184); (*NO EXTERNAL DECL IN INTERFACE*)
          IF SEGDEC THEN ERROR(399);
          WITH LCP^ DO
            BEGIN EXTURNAL := TRUE; FORWDECL := FALSE;
              WRITELN{(OUTPUT)}; WRITELN({OUTPUT,}NAME,' [',MEMAVAIL:5,' words]');
              WRITE({OUTPUT,}'<',SCREENDOTS:4,'>')
            END;
          PROCTABLE[CURPROC] := 0;
          DLINKERINFO := TRUE;
          IF SY = EXTERNLSY THEN
            BEGIN INSYMBOL;
              IF SY = SEMICOLON THEN INSYMBOL ELSE ERROR(14);
              IF NOT (SY IN FSYS) THEN
                BEGIN ERROR(6); SKIP(FSYS) END
            END
        END
      ELSE
        IF USING THEN
          BEGIN LCP^.FORWDECL := FALSE;
          END
        ELSE
          IF (SY = FORWARDSY) OR INMODULE AND ININTERFACE THEN
            BEGIN
              IF FORW THEN ERROR(161)
              ELSE LCP^.FORWDECL := TRUE;
              IF SY = FORWARDSY THEN 
                BEGIN INSYMBOL;
                  IF SY = SEMICOLON THEN INSYMBOL ELSE ERROR(14)
                END;
              IF NOT (SY IN FSYS) THEN
                BEGIN ERROR(6); SKIP(FSYS) END
            END
          ELSE
            BEGIN 
              IF EXTONLY THEN
                ERROR(7);
              NEWBLOCK:=TRUE;
              NOTDONE:=TRUE;
              WITH LLEXSTK DO
                BEGIN 
                  MARK(DMARKP);
                  WITH LCP^ DO
                    BEGIN FORWDECL := FALSE; INSCOPE := TRUE;
                      EXTURNAL := FALSE END;
                  BFSY:=SEMICOLON;
                  ISSEGMENT:=SEGDEC;
                  {PREVLEXSTACKP:=TOS;}
                  Move(tos,PREVLEXSTACKP,sizeof(PREVLEXSTACKP)); {patch /tp3}
                 END;
              NEW(TOS);
              TOS^:=LLEXSTK;
              EXIT;{(PROCDECLARATION);}
            END;
      WITH LLEXSTK DO  (* FORWARD OR EXTERNAL DECLARATION, SO RESTORE STATE *)
        BEGIN 
          LEVEL:=DOLDLEV; 
          TOP:=DOLDTOP;
          LC:=DLLC; 
          CURPROC:=POLDPROC; 
          IF SEGDEC THEN
            BEGIN
              NEXTPROC:=SOLDPROC;
              SEG:=DOLDSEG;
            END;
        END;
     END; (* PROCDECLARATION *)
     

BEGIN (*DECLARATIONPART*)
  IF (NOSWAP) AND (STARTINGUP) THEN
    BEGIN
    STARTINGUP:=FALSE; (* ALL SEGMENTS ARE IN BY THIS TIME *)
    BLOCK(FSYS);
    EXIT;{(DECLARATIONPART);}
    END;
  IF NOISY THEN    {patch /tp3}
   ; { UNITWRITE(3,DUMMYVAR[-1600],35);}  (*ADJUST DISPLAY OF STACK AND HEAP*)
  REPEAT
    NOTDONE:=FALSE;
    IF USERINFO.STUPID THEN
      IF NOT CODEINSEG THEN
        IF (LEVEL = 1) AND (NEXTSEG = 10) THEN
          IF NOT(INMODULE OR USING) THEN USESDECLARATION(TRUE);
          (*To get turtle graphics*)
    IF SY = USESSY THEN
      BEGIN
      INSYMBOL;
      USESDECLARATION(FALSE)
      END;
1:  {pc157g label/const/type/var in any order pc157g}
    IF SY = LABELSY THEN
      BEGIN IF INMODULE AND ININTERFACE THEN
        BEGIN ERROR(186); SKIP(FSYS - [LABELSY]) END
      ELSE
        INSYMBOL;
      LABELDECLARATION
      END;
    IF SY = CONSTSY THEN BEGIN INSYMBOL; CONSTDECLARATION END;
    IF SY = TYPESY  THEN BEGIN INSYMBOL; TYPEDECLARATION  END;
    IF SY = VARSY   THEN BEGIN INSYMBOL; VARDECLARATION   END;
    IF LEVEL = 1 THEN GLEV := TOP;
    IF SY IN [PROCSY,FUNCSY,PROGSY] THEN
      BEGIN
      IF INMODULE THEN
        IF ININTERFACE AND NOT USING THEN PUBLICPROCS := TRUE;
      REPEAT
        LSY := SY;
        INSYMBOL;
        IF LSY = PROGSY THEN
          IF INMODULE THEN
            BEGIN
            ERROR(185 (*SEG DEC NOT ALLOWED IN UNIT*));
            PROCDECLARATION(PROCSY,FALSE)
            END
          ELSE
            PROCDECLARATION(LSY,TRUE)
        ELSE
          PROCDECLARATION(LSY,FALSE); {used for most procs}
      UNTIL NOT (SY IN [PROCSY,FUNCSY,PROGSY])
      END;
    {patch to allow label/const/type/var dec in any order like turbo}
    If sy in [Labelsy,Constsy,Typesy,Varsy] Then
      goto 1;    {pc157g 28/9/92}
    IF (SY <> BEGINSY) THEN
      IF NOT ((USING OR INMODULE) AND (SY IN [IMPLESY,ENDSY]))
        AND NOT( SY IN [SEPARATSY,UNITSY]) THEN
        IF (NOT (INCLUDING OR NOTDONE)) OR NOT(SY IN BLOCKBEGSYS) THEN
          BEGIN
          ERROR(18);
          SKIP(FSYS - [UNITSY,INTERFCESY]);
          END;
  UNTIL (SY IN (STATBEGSYS + [SEPARATSY,UNITSY,IMPLESY,ENDSY]));
  NEWBLOCK:=FALSE;
END (*DECLARATIONPART*) ;

